//Copyright (c) 2014 - 2020, The Trustees of Indiana University.
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.

#ifndef TOPPIC_COMMON_BASE_RESIDUE_DATA_HPP_
#define TOPPIC_COMMON_BASE_RESIDUE_DATA_HPP_

#include <string>

namespace toppic {

std::string residue_base_data = R"(
<residue_list>
  <residue>
    <amino_acid>
      <name>None</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Alanine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Arginine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Asparagine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Aspartic_acid</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Cysteine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Glutamic_acid</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Glutamine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Glycine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Histidine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Isoleucine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Leucine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Lysine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Methionine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Phenylalanine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Proline</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Serine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Threonine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Tryptophan</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Tyrosine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Valine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
      <name>Selenocysteine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
  <residue>
    <amino_acid>
	    <name>Ornithine</name>
    </amino_acid>
    <ptm>
      <abbreviation>No PTM</abbreviation>
    </ptm>
  </residue>
</residue_list>
)";

} 

#endif
