"use strict";
let sampleProteoform = {
    "id_": "0",
    "protName_": "sp|P66491|RS19_SALTY",
    "protDesc_": "30S ribosomal protein S19 OS=Salmonella typhimurium (strain LT2 / SGSC1412 / ATCC 700720) OX=99287 GN=rpsS PE=3 SV=2",
    "seq_": "MPRSLKKGPFIDLHLLKKVEKAVESGDKKPLRTWSRRSTIFPNMIGLTIAVHNGRQHVPVFVSDEMVGHKLGEFAPTRTYRGHAADKKAKKK",
    "seqId_": "0",
    "firstPos_": 1,
    "lastPos_": 91,
    "protMass_": 10278.6589,
    "massShiftList_": [],
    "prefixMasses_": [
        {
            "ion_": {},
            "mass_": 97.052763848919,
            "pos_": 0
        },
        {
            "ion_": {},
            "mass_": 253.153874872773,
            "pos_": 1
        },
        {
            "ion_": {},
            "mass_": 340.185903277112,
            "pos_": 2
        },
        {
            "ion_": {},
            "mass_": 453.269967254315,
            "pos_": 3
        },
        {
            "ion_": {},
            "mass_": 581.364930268449,
            "pos_": 4
        },
        {
            "ion_": {},
            "mass_": 709.459893282583,
            "pos_": 5
        },
        {
            "ion_": {},
            "mass_": 766.481357003218,
            "pos_": 6
        },
        {
            "ion_": {},
            "mass_": 863.534120852137,
            "pos_": 7
        },
        {
            "ion_": {},
            "mass_": 1010.602534765198,
            "pos_": 8
        },
        {
            "ion_": {},
            "mass_": 1123.686598742401,
            "pos_": 9
        },
        {
            "ion_": {},
            "mass_": 1238.713541766302,
            "pos_": 10
        },
        {
            "ion_": {},
            "mass_": 1351.7976057435048,
            "pos_": 11
        },
        {
            "ion_": {},
            "mass_": 1488.8565176021439,
            "pos_": 12
        },
        {
            "ion_": {},
            "mass_": 1601.9405815793468,
            "pos_": 13
        },
        {
            "ion_": {},
            "mass_": 1715.0246455565498,
            "pos_": 14
        },
        {
            "ion_": {},
            "mass_": 1843.1196085706838,
            "pos_": 15
        },
        {
            "ion_": {},
            "mass_": 1971.2145715848178,
            "pos_": 16
        },
        {
            "ion_": {},
            "mass_": 2070.2829854978786,
            "pos_": 17
        },
        {
            "ion_": {},
            "mass_": 2199.3255785859214,
            "pos_": 18
        },
        {
            "ion_": {},
            "mass_": 2327.4205416000555,
            "pos_": 19
        },
        {
            "ion_": {},
            "mass_": 2398.4576553848324,
            "pos_": 20
        },
        {
            "ion_": {},
            "mass_": 2497.526069297893,
            "pos_": 21
        },
        {
            "ion_": {},
            "mass_": 2626.568662385936,
            "pos_": 22
        },
        {
            "ion_": {},
            "mass_": 2713.600690790275,
            "pos_": 23
        },
        {
            "ion_": {},
            "mass_": 2770.62215451091,
            "pos_": 24
        },
        {
            "ion_": {},
            "mass_": 2885.649097534811,
            "pos_": 25
        },
        {
            "ion_": {},
            "mass_": 3013.744060548945,
            "pos_": 26
        },
        {
            "ion_": {},
            "mass_": 3141.839023563079,
            "pos_": 27
        },
        {
            "ion_": {},
            "mass_": 3238.891787411998,
            "pos_": 28
        },
        {
            "ion_": {},
            "mass_": 3351.975851389201,
            "pos_": 29
        },
        {
            "ion_": {},
            "mass_": 3508.0769624130553,
            "pos_": 30
        },
        {
            "ion_": {},
            "mass_": 3609.1246408815364,
            "pos_": 31
        },
        {
            "ion_": {},
            "mass_": 3795.2039538315285,
            "pos_": 32
        },
        {
            "ion_": {},
            "mass_": 3882.2359822358676,
            "pos_": 33
        },
        {
            "ion_": {},
            "mass_": 4038.3370932597218,
            "pos_": 34
        },
        {
            "ion_": {},
            "mass_": 4194.438204283576,
            "pos_": 35
        },
        {
            "ion_": {},
            "mass_": 4281.470232687915,
            "pos_": 36
        },
        {
            "ion_": {},
            "mass_": 4382.517911156396,
            "pos_": 37
        },
        {
            "ion_": {},
            "mass_": 4495.601975133599,
            "pos_": 38
        },
        {
            "ion_": {},
            "mass_": 4642.67038904666,
            "pos_": 39
        },
        {
            "ion_": {},
            "mass_": 4739.723152895579,
            "pos_": 40
        },
        {
            "ion_": {},
            "mass_": 4853.766080336849,
            "pos_": 41
        },
        {
            "ion_": {},
            "mass_": 4984.80656525141,
            "pos_": 42
        },
        {
            "ion_": {},
            "mass_": 5097.890629228613,
            "pos_": 43
        },
        {
            "ion_": {},
            "mass_": 5154.912092949248,
            "pos_": 44
        },
        {
            "ion_": {},
            "mass_": 5267.9961569264515,
            "pos_": 45
        },
        {
            "ion_": {},
            "mass_": 5369.043835394932,
            "pos_": 46
        },
        {
            "ion_": {},
            "mass_": 5482.127899372135,
            "pos_": 47
        },
        {
            "ion_": {},
            "mass_": 5553.165013156912,
            "pos_": 48
        },
        {
            "ion_": {},
            "mass_": 5652.233427069973,
            "pos_": 49
        },
        {
            "ion_": {},
            "mass_": 5789.292338928612,
            "pos_": 50
        },
        {
            "ion_": {},
            "mass_": 5903.3352663698815,
            "pos_": 51
        },
        {
            "ion_": {},
            "mass_": 5960.356730090517,
            "pos_": 52
        },
        {
            "ion_": {},
            "mass_": 6116.457841114371,
            "pos_": 53
        },
        {
            "ion_": {},
            "mass_": 6244.5164186197835,
            "pos_": 54
        },
        {
            "ion_": {},
            "mass_": 6381.575330478422,
            "pos_": 55
        },
        {
            "ion_": {},
            "mass_": 6480.643744391483,
            "pos_": 56
        },
        {
            "ion_": {},
            "mass_": 6577.696508240402,
            "pos_": 57
        },
        {
            "ion_": {},
            "mass_": 6676.764922153463,
            "pos_": 58
        },
        {
            "ion_": {},
            "mass_": 6823.833336066524,
            "pos_": 59
        },
        {
            "ion_": {},
            "mass_": 6922.901749979585,
            "pos_": 60
        },
        {
            "ion_": {},
            "mass_": 7009.933778383924,
            "pos_": 61
        },
        {
            "ion_": {},
            "mass_": 7124.960721407825,
            "pos_": 62
        },
        {
            "ion_": {},
            "mass_": 7254.003314495868,
            "pos_": 63
        },
        {
            "ion_": {},
            "mass_": 7385.043799410429,
            "pos_": 64
        },
        {
            "ion_": {},
            "mass_": 7484.112213323489,
            "pos_": 65
        },
        {
            "ion_": {},
            "mass_": 7541.133677044125,
            "pos_": 66
        },
        {
            "ion_": {},
            "mass_": 7678.192588902763,
            "pos_": 67
        },
        {
            "ion_": {},
            "mass_": 7806.287551916897,
            "pos_": 68
        },
        {
            "ion_": {},
            "mass_": 7919.371615894101,
            "pos_": 69
        },
        {
            "ion_": {},
            "mass_": 7976.393079614736,
            "pos_": 70
        },
        {
            "ion_": {},
            "mass_": 8105.435672702779,
            "pos_": 71
        },
        {
            "ion_": {},
            "mass_": 8252.50408661584,
            "pos_": 72
        },
        {
            "ion_": {},
            "mass_": 8323.541200400618,
            "pos_": 73
        },
        {
            "ion_": {},
            "mass_": 8420.593964249536,
            "pos_": 74
        },
        {
            "ion_": {},
            "mass_": 8521.641642718017,
            "pos_": 75
        },
        {
            "ion_": {},
            "mass_": 8677.742753741872,
            "pos_": 76
        },
        {
            "ion_": {},
            "mass_": 8778.790432210353,
            "pos_": 77
        },
        {
            "ion_": {},
            "mass_": 8941.853760742975,
            "pos_": 78
        },
        {
            "ion_": {},
            "mass_": 9097.95487176683,
            "pos_": 79
        },
        {
            "ion_": {},
            "mass_": 9154.976335487465,
            "pos_": 80
        },
        {
            "ion_": {},
            "mass_": 9292.035247346104,
            "pos_": 81
        },
        {
            "ion_": {},
            "mass_": 9363.072361130882,
            "pos_": 82
        },
        {
            "ion_": {},
            "mass_": 9434.10947491566,
            "pos_": 83
        },
        {
            "ion_": {},
            "mass_": 9549.13641793956,
            "pos_": 84
        },
        {
            "ion_": {},
            "mass_": 9677.231380953694,
            "pos_": 85
        },
        {
            "ion_": {},
            "mass_": 9805.326343967827,
            "pos_": 86
        },
        {
            "ion_": {},
            "mass_": 9876.363457752605,
            "pos_": 87
        },
        {
            "ion_": {},
            "mass_": 10004.45842076674,
            "pos_": 88
        },
        {
            "ion_": {},
            "mass_": 10132.553383780873,
            "pos_": 89
        }
    ],
    "suffixMasses_": [
        {
            "ion_": {},
            "mass_": 128.094963014134,
            "pos_": 90
        },
        {
            "ion_": {},
            "mass_": 256.189926028268,
            "pos_": 89
        },
        {
            "ion_": {},
            "mass_": 384.284889042402,
            "pos_": 88
        },
        {
            "ion_": {},
            "mass_": 455.32200282717906,
            "pos_": 87
        },
        {
            "ion_": {},
            "mass_": 583.4169658413131,
            "pos_": 86
        },
        {
            "ion_": {},
            "mass_": 711.5119288554471,
            "pos_": 85
        },
        {
            "ion_": {},
            "mass_": 826.5388718793481,
            "pos_": 84
        },
        {
            "ion_": {},
            "mass_": 897.5759856641251,
            "pos_": 83
        },
        {
            "ion_": {},
            "mass_": 968.6130994489022,
            "pos_": 82
        },
        {
            "ion_": {},
            "mass_": 1105.6720113075412,
            "pos_": 81
        },
        {
            "ion_": {},
            "mass_": 1162.6934750281762,
            "pos_": 80
        },
        {
            "ion_": {},
            "mass_": 1318.7945860520301,
            "pos_": 79
        },
        {
            "ion_": {},
            "mass_": 1481.8579145846531,
            "pos_": 78
        },
        {
            "ion_": {},
            "mass_": 1582.9055930531342,
            "pos_": 77
        },
        {
            "ion_": {},
            "mass_": 1739.0067040769882,
            "pos_": 76
        },
        {
            "ion_": {},
            "mass_": 1840.0543825454693,
            "pos_": 75
        },
        {
            "ion_": {},
            "mass_": 1937.1071463943883,
            "pos_": 74
        },
        {
            "ion_": {},
            "mass_": 2008.1442601791653,
            "pos_": 73
        },
        {
            "ion_": {},
            "mass_": 2155.2126740922263,
            "pos_": 72
        },
        {
            "ion_": {},
            "mass_": 2284.255267180269,
            "pos_": 71
        },
        {
            "ion_": {},
            "mass_": 2341.276730900904,
            "pos_": 70
        },
        {
            "ion_": {},
            "mass_": 2454.3607948781073,
            "pos_": 69
        },
        {
            "ion_": {},
            "mass_": 2582.4557578922413,
            "pos_": 68
        },
        {
            "ion_": {},
            "mass_": 2719.5146697508803,
            "pos_": 67
        },
        {
            "ion_": {},
            "mass_": 2776.5361334715153,
            "pos_": 66
        },
        {
            "ion_": {},
            "mass_": 2875.604547384576,
            "pos_": 65
        },
        {
            "ion_": {},
            "mass_": 3006.6450322991373,
            "pos_": 64
        },
        {
            "ion_": {},
            "mass_": 3135.68762538718,
            "pos_": 63
        },
        {
            "ion_": {},
            "mass_": 3250.714568411081,
            "pos_": 62
        },
        {
            "ion_": {},
            "mass_": 3337.74659681542,
            "pos_": 61
        },
        {
            "ion_": {},
            "mass_": 3436.815010728481,
            "pos_": 60
        },
        {
            "ion_": {},
            "mass_": 3583.8834246415418,
            "pos_": 59
        },
        {
            "ion_": {},
            "mass_": 3682.9518385546025,
            "pos_": 58
        },
        {
            "ion_": {},
            "mass_": 3780.0046024035214,
            "pos_": 57
        },
        {
            "ion_": {},
            "mass_": 3879.073016316582,
            "pos_": 56
        },
        {
            "ion_": {},
            "mass_": 4016.131928175221,
            "pos_": 55
        },
        {
            "ion_": {},
            "mass_": 4144.190505680634,
            "pos_": 54
        },
        {
            "ion_": {},
            "mass_": 4300.291616704488,
            "pos_": 53
        },
        {
            "ion_": {},
            "mass_": 4357.313080425123,
            "pos_": 52
        },
        {
            "ion_": {},
            "mass_": 4471.356007866393,
            "pos_": 51
        },
        {
            "ion_": {},
            "mass_": 4608.414919725032,
            "pos_": 50
        },
        {
            "ion_": {},
            "mass_": 4707.4833336380925,
            "pos_": 49
        },
        {
            "ion_": {},
            "mass_": 4778.520447422869,
            "pos_": 48
        },
        {
            "ion_": {},
            "mass_": 4891.604511400073,
            "pos_": 47
        },
        {
            "ion_": {},
            "mass_": 4992.652189868553,
            "pos_": 46
        },
        {
            "ion_": {},
            "mass_": 5105.736253845756,
            "pos_": 45
        },
        {
            "ion_": {},
            "mass_": 5162.757717566392,
            "pos_": 44
        },
        {
            "ion_": {},
            "mass_": 5275.841781543595,
            "pos_": 43
        },
        {
            "ion_": {},
            "mass_": 5406.882266458156,
            "pos_": 42
        },
        {
            "ion_": {},
            "mass_": 5520.925193899426,
            "pos_": 41
        },
        {
            "ion_": {},
            "mass_": 5617.977957748345,
            "pos_": 40
        },
        {
            "ion_": {},
            "mass_": 5765.046371661406,
            "pos_": 39
        },
        {
            "ion_": {},
            "mass_": 5878.130435638609,
            "pos_": 38
        },
        {
            "ion_": {},
            "mass_": 5979.17811410709,
            "pos_": 37
        },
        {
            "ion_": {},
            "mass_": 6066.210142511429,
            "pos_": 36
        },
        {
            "ion_": {},
            "mass_": 6222.311253535283,
            "pos_": 35
        },
        {
            "ion_": {},
            "mass_": 6378.412364559137,
            "pos_": 34
        },
        {
            "ion_": {},
            "mass_": 6465.444392963476,
            "pos_": 33
        },
        {
            "ion_": {},
            "mass_": 6651.523705913468,
            "pos_": 32
        },
        {
            "ion_": {},
            "mass_": 6752.5713843819485,
            "pos_": 31
        },
        {
            "ion_": {},
            "mass_": 6908.672495405803,
            "pos_": 30
        },
        {
            "ion_": {},
            "mass_": 7021.756559383006,
            "pos_": 29
        },
        {
            "ion_": {},
            "mass_": 7118.809323231925,
            "pos_": 28
        },
        {
            "ion_": {},
            "mass_": 7246.904286246059,
            "pos_": 27
        },
        {
            "ion_": {},
            "mass_": 7374.999249260193,
            "pos_": 26
        },
        {
            "ion_": {},
            "mass_": 7490.026192284095,
            "pos_": 25
        },
        {
            "ion_": {},
            "mass_": 7547.04765600473,
            "pos_": 24
        },
        {
            "ion_": {},
            "mass_": 7634.079684409069,
            "pos_": 23
        },
        {
            "ion_": {},
            "mass_": 7763.122277497112,
            "pos_": 22
        },
        {
            "ion_": {},
            "mass_": 7862.190691410173,
            "pos_": 21
        },
        {
            "ion_": {},
            "mass_": 7933.22780519495,
            "pos_": 20
        },
        {
            "ion_": {},
            "mass_": 8061.322768209084,
            "pos_": 19
        },
        {
            "ion_": {},
            "mass_": 8190.365361297127,
            "pos_": 18
        },
        {
            "ion_": {},
            "mass_": 8289.433775210187,
            "pos_": 17
        },
        {
            "ion_": {},
            "mass_": 8417.528738224322,
            "pos_": 16
        },
        {
            "ion_": {},
            "mass_": 8545.623701238455,
            "pos_": 15
        },
        {
            "ion_": {},
            "mass_": 8658.707765215659,
            "pos_": 14
        },
        {
            "ion_": {},
            "mass_": 8771.791829192862,
            "pos_": 13
        },
        {
            "ion_": {},
            "mass_": 8908.850741051501,
            "pos_": 12
        },
        {
            "ion_": {},
            "mass_": 9021.934805028704,
            "pos_": 11
        },
        {
            "ion_": {},
            "mass_": 9136.961748052605,
            "pos_": 10
        },
        {
            "ion_": {},
            "mass_": 9250.045812029808,
            "pos_": 9
        },
        {
            "ion_": {},
            "mass_": 9397.114225942869,
            "pos_": 8
        },
        {
            "ion_": {},
            "mass_": 9494.166989791787,
            "pos_": 7
        },
        {
            "ion_": {},
            "mass_": 9551.188453512423,
            "pos_": 6
        },
        {
            "ion_": {},
            "mass_": 9679.283416526556,
            "pos_": 5
        },
        {
            "ion_": {},
            "mass_": 9807.378379540689,
            "pos_": 4
        },
        {
            "ion_": {},
            "mass_": 9920.462443517892,
            "pos_": 3
        },
        {
            "ion_": {},
            "mass_": 10007.494471922231,
            "pos_": 2
        },
        {
            "ion_": {},
            "mass_": 10163.595582946085,
            "pos_": 1
        }
    ]
};
