"use strict";
let commonPtmList = [{ 'name': 'None', 'abbr': '', 'mass': 0 }, { 'name': 'Acetylation', 'abbr': 'Acetyl', 'mass': 42.010565 }, { 'name': 'Amidation', 'abbr': 'Amidated', 'mass': -0.984016 }, { 'name': 'Biotinylation', 'abbr': 'Biotin', 'mass': 226.077598 }, { 'name': 'Iodoacetamide derivative', 'abbr': 'Carbamidomethyl', 'mass': 57.021464 }, { 'name': 'Carbamylation', 'abbr': 'Carbamyl', 'mass': 43.005814 }, { 'name': 'Iodoacetic acid derivative', 'abbr': 'Carboxymethyl', 'mass': 58.005479 }, { 'name': 'Deamidation', 'abbr': 'Deamidated', 'mass': 0.984016 }, { 'name': 'Gygi ICAT(TM) d0', 'abbr': 'ICAT-G', 'mass': 486.251206 }, { 'name': 'Gygi ICAT(TM) d8', 'abbr': 'ICAT-G:2H(8)', 'mass': 494.30142 }, { 'name': 'Homoserine', 'abbr': 'Met->Hse', 'mass': -29.992806 }, { 'name': 'Homoserine lactone', 'abbr': 'Met->Hsl', 'mass': -48.003371 }, { 'name': 'Applied Biosystems original ICAT(TM) d8', 'abbr': 'ICAT-D:2H(8)', 'mass': 450.275205 }, { 'name': 'Applied Biosystems original ICAT(TM) d0', 'abbr': 'ICAT-D', 'mass': 442.224991 }, { 'name': 'N-isopropylcarboxamidomethyl', 'abbr': 'NIPCAM', 'mass': 99.068414 }, { 'name': 'Biotinyl-iodoacetamidyl-3,6-dioxaoctanediamine', 'abbr': 'PEO-Iodoacetyl-LC-Biotin', 'mass': 414.193691 }, { 'name': 'Phosphorylation', 'abbr': 'Phospho', 'mass': 79.966331 }, { 'name': 'S-methyl amino phosphinate', 'abbr': 'Methamidophos-S', 'mass': 108.975121 }, { 'name': 'Dehydration', 'abbr': 'Dehydrated', 'mass': -18.010565 }, { 'name': 'Acrylamide adduct', 'abbr': 'Propionamide', 'mass': 71.037114 }, { 'name': 'pyridylacetyl', 'abbr': 'Pyridylacetyl', 'mass': 119.037114 }, { 'name': 'S-carbamoylmethylcysteine cyclization (N-terminus)', 'abbr': 'Pyro-carbamidomethyl', 'mass': 39.994915 }, { 'name': 'Pyro-glu from E', 'abbr': 'Glu->pyro-Glu', 'mass': -18.010565 }, { 'name': 'Pyro-glu from Q', 'abbr': 'Gln->pyro-Glu', 'mass': -17.026549 }, { 'name': 'N-Succinimidyl-2-morpholine acetate', 'abbr': 'SMA', 'mass': 127.063329 }, { 'name': 'Sodium adduct', 'abbr': 'Cation:Na', 'mass': 21.981943 }, { 'name': 'S-pyridylethylation', 'abbr': 'Pyridylethyl', 'mass': 105.057849 }, { 'name': 'Methylation', 'abbr': 'Methyl', 'mass': 14.01565 }, { 'name': 'Oxidation or Hydroxylation', 'abbr': 'Oxidation', 'mass': 15.994915 }, { 'name': 'di-Methylation', 'abbr': 'Dimethyl', 'mass': 28.0313 }, { 'name': 'tri-Methylation', 'abbr': 'Trimethyl', 'mass': 42.04695 }, { 'name': 'Beta-methylthiolation', 'abbr': 'Methylthio', 'mass': 45.987721 }, { 'name': 'O-Sulfonation', 'abbr': 'Sulfo', 'mass': 79.956815 }, { 'name': 'Hexose', 'abbr': 'Hex', 'mass': 162.052824 }, { 'name': 'Lipoyl', 'abbr': 'Lipoyl', 'mass': 188.032956 }, { 'name': 'N-Acetylhexosamine', 'abbr': 'HexNAc', 'mass': 203.079373 }, { 'name': 'Farnesylation', 'abbr': 'Farnesyl', 'mass': 204.187801 }, { 'name': 'Myristoylation', 'abbr': 'Myristoyl', 'mass': 210.198366 }, { 'name': 'Pyridoxal phosphate', 'abbr': 'PyridoxalPhosphate', 'mass': 229.014009 }, { 'name': 'Palmitoylation', 'abbr': 'Palmitoyl', 'mass': 238.229666 }, { 'name': 'Geranyl-geranyl', 'abbr': 'GeranylGeranyl', 'mass': 272.250401 }, { 'name': 'Phosphopantetheine', 'abbr': 'Phosphopantetheine', 'mass': 340.085794 }, { 'name': 'Flavin adenine dinucleotide', 'abbr': 'FAD', 'mass': 783.141486 }, { 'name': 'N-acyl diglyceride cysteine', 'abbr': 'Tripalmitate', 'mass': 788.725777 }, { 'name': 'Guanidination', 'abbr': 'Guanidinyl', 'mass': 42.021798 }, { 'name': '4-hydroxynonenal (HNE)', 'abbr': 'HNE', 'mass': 156.11503 }, { 'name': 'hexuronic acid', 'abbr': 'Glucuronyl', 'mass': 176.032088 }, { 'name': 'glutathione disulfide', 'abbr': 'Glutathione', 'mass': 305.068156 }, { 'name': 'Acetate labeling reagent (N-term & K) (heavy form, +3amu)', 'abbr': 'Acetyl:2H(3)', 'mass': 45.029395 }, { 'name': 'Propionate labeling reagent light form (N-term & K)', 'abbr': 'Propionyl', 'mass': 56.026215 }, { 'name': 'Propionate labeling reagent heavy form (+3amu), N-term & K', 'abbr': 'Propionyl:13C(3)', 'mass': 59.036279 }, { 'name': 'Quaternary amine labeling reagent light form (N-term & K)', 'abbr': 'GIST-Quat', 'mass': 127.099714 }, { 'name': 'Quaternary amine labeling reagent heavy (+3amu) form, N-term & K', 'abbr': 'GIST-Quat:2H(3)', 'mass': 130.118544 }, { 'name': 'Quaternary amine labeling reagent heavy form (+6amu), N-term & K', 'abbr': 'GIST-Quat:2H(6)', 'mass': 133.137375 }, { 'name': 'Quaternary amine labeling reagent heavy form (+9amu), N-term & K', 'abbr': 'GIST-Quat:2H(9)', 'mass': 136.156205 }, { 'name': 'Succinic anhydride labeling reagent light form (N-term & K)', 'abbr': 'Succinyl', 'mass': 100.016044 }, { 'name': 'Succinic anhydride labeling reagent, heavy form (+4amu, 4H2), N-term & K', 'abbr': 'Succinyl:2H(4)', 'mass': 104.041151 }, { 'name': 'Succinic anhydride labeling reagent, heavy form (+4amu, 4C13), N-term & K', 'abbr': 'Succinyl:13C(4)', 'mass': 104.029463 }, { 'name': 'oxidized proline biotinylated with biotin hydrazide', 'abbr': 'probiotinhydrazide', 'mass': 258.115047 }, { 'name': 'proline oxidation to pyroglutamic acid', 'abbr': 'Pro->pyro-Glu', 'mass': 13.979265 }, { 'name': 'His->Asn substitution', 'abbr': 'His->Asn', 'mass': -23.015984 }, { 'name': 'His->Asp substitution', 'abbr': 'His->Asp', 'mass': -22.031969 }, { 'name': 'tryptophan oxidation to hydroxykynurenin', 'abbr': 'Trp->Hydroxykynurenin', 'mass': 19.989829 }, { 'name': 'Propionaldehyde +40', 'abbr': 'Delta:H(4)C(3)', 'mass': 40.0313 }, { 'name': 'Acetaldehyde +28', 'abbr': 'Delta:H(4)C(2)', 'mass': 28.0313 }, { 'name': 'Dehydroalanine (from Cysteine)', 'abbr': 'Cys->Dha', 'mass': -33.987721 }, { 'name': 'Arginine oxidation to glutamic semialdehyde', 'abbr': 'Arg->GluSA', 'mass': -43.053433 }, { 'name': 'cysteine oxidation to cysteic acid', 'abbr': 'Trioxidation', 'mass': 47.984744 }, { 'name': 'Iminobiotinylation', 'abbr': 'Iminobiotin', 'mass': 225.093583 }, { 'name': 'ESP-Tag light d0', 'abbr': 'ESP', 'mass': 338.177647 }, { 'name': 'ESP-Tag heavy d10', 'abbr': 'ESP:2H(10)', 'mass': 348.240414 }, { 'name': 'NHS-LC-Biotin', 'abbr': 'NHS-LC-Biotin', 'mass': 339.161662 }, { 'name': 'EDT-maleimide-PEO-biotin', 'abbr': 'EDT-maleimide-PEO-biotin', 'mass': 601.206246 }, { 'name': 'IMID d0', 'abbr': 'IMID', 'mass': 68.037448 }, { 'name': 'IMID d4', 'abbr': 'IMID:2H(4)', 'mass': 72.062555 }, { 'name': 'oxidized Lysine biotinylated with biotin hydrazide', 'abbr': 'Lysbiotinhydrazide', 'mass': 241.088497 }, { 'name': 'Acrylamide d3', 'abbr': 'Propionamide:2H(3)', 'mass': 74.055944 }, { 'name': 'Oxidation to nitro', 'abbr': 'Nitro', 'mass': 44.985078 }, { 'name': 'Applied Biosystems cleavable ICAT(TM) light', 'abbr': 'ICAT-C', 'mass': 227.126991 }, { 'name': 'Acetaldehyde +26', 'abbr': 'Delta:H(2)C(2)', 'mass': 26.01565 }, { 'name': 'tryptophan oxidation to kynurenin', 'abbr': 'Trp->Kynurenin', 'mass': 3.994915 }, { 'name': 'Lysine oxidation to aminoadipic semialdehyde', 'abbr': 'Lys->Allysine', 'mass': -1.031634 }, { 'name': 'Applied Biosystems cleavable ICAT(TM) heavy', 'abbr': 'ICAT-C:13C(9)', 'mass': 236.157185 }, { 'name': 'Addition of N-formyl met', 'abbr': 'FormylMet', 'mass': 159.035399 }, { 'name': 'N-ethylmaleimide on cysteines', 'abbr': 'Nethylmaleimide', 'mass': 125.047679 }, { 'name': 'Oxidized lysine biotinylated with biotin-LC-hydrazide, reduced', 'abbr': 'OxLysBiotinRed', 'mass': 354.172562 }, { 'name': 'Thio Ether Formation - BTP Adduct', 'abbr': 'IBTP', 'mass': 316.138088 }, { 'name': 'Oxidized lysine biotinylated with biotin-LC-hydrazide', 'abbr': 'OxLysBiotin', 'mass': 352.156911 }, { 'name': 'Oxidized proline biotinylated with biotin-LC-hydrazide, reduced', 'abbr': 'OxProBiotinRed', 'mass': 371.199111 }, { 'name': 'Oxidized Proline biotinylated with biotin-LC-hydrazide', 'abbr': 'OxProBiotin', 'mass': 369.183461 }, { 'name': 'Oxidized arginine biotinylated with biotin-LC-hydrazide', 'abbr': 'OxArgBiotin', 'mass': 310.135113 }, { 'name': 'Oxidized arginine biotinylated with biotin-LC-hydrazide, reduced', 'abbr': 'OxArgBiotinRed', 'mass': 312.150763 }, { 'name': 'EDT-iodo-PEO-biotin', 'abbr': 'EDT-iodoacetyl-PEO-biotin', 'mass': 490.174218 }, { 'name': 'ubiquitinylation residue', 'abbr': 'GG', 'mass': 114.042927 }, { 'name': 'Formylation', 'abbr': 'Formyl', 'mass': 27.994915 }, { 'name': 'N-iodoacetyl, p-chlorobenzyl-12C6-glucamine', 'abbr': 'ICAT-H', 'mass': 345.097915 }, { 'name': 'N-iodoacetyl, p-chlorobenzyl-13C6-glucamine', 'abbr': 'ICAT-H:13C(6)', 'mass': 351.118044 }, { 'name': 'Replacement of proton by potassium', 'abbr': 'Cation:K', 'mass': 37.955882 }, { 'name': 'Cleaved and reduced DSP/DTSSP crosslinker', 'abbr': 'Xlink:DTSSP[88]', 'mass': 87.998285 }, { 'name': 'Intact EGS cross-linker', 'abbr': 'Xlink:EGS[226]', 'mass': 226.047738 }, { 'name': 'fluorination', 'abbr': 'Fluoro', 'mass': 17.990578 }, { 'name': '5-Iodoacetamidofluorescein (Molecular Probe, Eugene, OR)', 'abbr': 'Fluorescein', 'mass': 387.074287 }, { 'name': 'Iodination', 'abbr': 'Iodo', 'mass': 125.896648 }, { 'name': 'di-Iodination', 'abbr': 'Diiodo', 'mass': 251.793296 }, { 'name': 'tri-Iodination', 'abbr': 'Triiodo', 'mass': 377.689944 }, { 'name': '(cis-delta 5)-tetradecaenoyl', 'abbr': 'Myristoleyl', 'mass': 208.182715 }, { 'name': 'Proline oxidation to pyrrolidinone', 'abbr': 'Pro->Pyrrolidinone', 'mass': -30.010565 }, { 'name': '(cis,cis-delta 5, delta 8)-tetradecadienoyl', 'abbr': 'Myristoyl+Delta:H(-4)', 'mass': 206.167065 }, { 'name': 'labeling reagent light form (N-term & K)', 'abbr': 'Benzoyl', 'mass': 104.026215 }, { 'name': 'M5/Man5', 'abbr': 'Hex(5)HexNAc(2)', 'mass': 1216.422863 }, { 'name': '5-dimethylaminonaphthalene-1-sulfonyl', 'abbr': 'Dansyl', 'mass': 233.051049 }, { 'name': 'ISD a-series (C-Term)', 'abbr': 'a-type-ion', 'mass': -46.005479 }, { 'name': 'amidination of lysines or N-terminal amines with methyl acetimidate', 'abbr': 'Amidine', 'mass': 41.026549 }, { 'name': 'HexNAc1dHex1', 'abbr': 'HexNAc(1)dHex(1)', 'mass': 349.137281 }, { 'name': 'HexNAc2', 'abbr': 'HexNAc(2)', 'mass': 406.158745 }, { 'name': 'Hex3', 'abbr': 'Hex(3)', 'mass': 486.158471 }, { 'name': 'HexNAc1dHex2', 'abbr': 'HexNAc(1)dHex(2)', 'mass': 495.19519 }, { 'name': 'Hex1HexNAc1dHex1', 'abbr': 'Hex(1)HexNAc(1)dHex(1)', 'mass': 511.190105 }, { 'name': 'HexNAc2dHex1', 'abbr': 'HexNAc(2)dHex(1)', 'mass': 552.216654 }, { 'name': 'Hex1HexNAc2', 'abbr': 'Hex(1)HexNAc(2)', 'mass': 568.211569 }, { 'name': 'Hex1HexNAc1NeuAc1', 'abbr': 'Hex(1)HexNAc(1)NeuAc(1)', 'mass': 656.227613 }, { 'name': 'HexNAc2dHex2', 'abbr': 'HexNAc(2)dHex(2)', 'mass': 698.274563 }, { 'name': 'Hex1HexNAc2Pent1', 'abbr': 'Hex(1)HexNAc(2)Pent(1)', 'mass': 700.253828 }, { 'name': 'Hex1HexNAc2dHex1', 'abbr': 'Hex(1)HexNAc(2)dHex(1)', 'mass': 714.269478 }, { 'name': 'Hex2HexNAc2', 'abbr': 'Hex(2)HexNAc(2)', 'mass': 730.264392 }, { 'name': 'Hex3HexNAc1Pent1', 'abbr': 'Hex(3)HexNAc(1)Pent(1)', 'mass': 821.280102 }, { 'name': 'Hex1HexNAc2dHex1Pent1', 'abbr': 'Hex(1)HexNAc(2)dHex(1)Pent(1)', 'mass': 846.311736 }, { 'name': 'Hex1HexNAc2dHex2', 'abbr': 'Hex(1)HexNAc(2)dHex(2)', 'mass': 860.327386 }, { 'name': 'Hex2HexNAc2Pent1', 'abbr': 'Hex(2)HexNAc(2)Pent(1)', 'mass': 862.306651 }, { 'name': 'Hex2HexNAc2dHex1', 'abbr': 'Hex(2)HexNAc(2)dHex(1)', 'mass': 876.322301 }, { 'name': 'M3/Man3', 'abbr': 'Hex(3)HexNAc(2)', 'mass': 892.317216 }, { 'name': 'Hex HexNAc NeuAc(2) ---OR--- Hex HexNAc(3) HexA', 'abbr': 'Hex(1)HexNAc(1)NeuAc(2)', 'mass': 947.323029 }, { 'name': 'Hex(3) HexNAc(2) Phos', 'abbr': 'Hex(3)HexNAc(2)Phos(1)', 'mass': 972.283547 }, { 'name': 'Selenium replaces sulfur', 'abbr': 'Delta:S(-1)Se(1)', 'mass': 47.944449 }, { 'name': 'Shimadzu NBS-13C', 'abbr': 'NBS:13C(6)', 'mass': 159.008578 }, { 'name': 'monomethylation', 'abbr': 'Methyl:2H(3)13C(1)', 'mass': 18.037835 }, { 'name': 'dimethylation', 'abbr': 'Dimethyl:2H(6)13C(2)', 'mass': 36.07567 }, { 'name': 'Shimadzu NBS-12C', 'abbr': 'NBS', 'mass': 152.988449 }, { 'name': 'glycosylated asparagine 18O labeling', 'abbr': 'Delta:H(-1)N(-1)18O(1)', 'mass': 2.988261 }, { 'name': 'APTA-d0', 'abbr': 'QAT', 'mass': 171.149738 }, { 'name': 'Michael addition of BHT quinone methide to Cysteine and Lysine', 'abbr': 'BHT', 'mass': 218.167065 }, { 'name': 'S-Ethylcystine from Serine', 'abbr': 'Delta:H(4)C(2)O(-1)S(1)', 'mass': 44.008456 }, { 'name': 'phosphorylation to amine thiol', 'abbr': 'DAET', 'mass': 87.050655 }, { 'name': 'Pyrrolidone from Proline', 'abbr': 'Pro->Pyrrolidone', 'mass': -27.994915 }, { 'name': '13C(9) Silac label', 'abbr': 'Label:13C(9)', 'mass': 9.030193 }, { 'name': 'C13 label (Phosphotyrosine)', 'abbr': 'Label:13C(9)+Phospho', 'mass': 88.996524 }, { 'name': '13C(6) Silac label', 'abbr': 'Label:13C(6)', 'mass': 6.020129 }, { 'name': 'Hydroxyphenylglyoxal arginine', 'abbr': 'HPG', 'mass': 132.021129 }, { 'name': 'bis(hydroxphenylglyoxal) arginine', 'abbr': '2HPG', 'mass': 282.052824 }, { 'name': 'APTA d3', 'abbr': 'QAT:2H(3)', 'mass': 174.168569 }, { 'name': 'O18 label at both C-terminal oxygens', 'abbr': 'Label:18O(2)', 'mass': 4.008491 }, { 'name': '6-aminoquinolyl-N-hydroxysuccinimidyl carbamate', 'abbr': 'AccQTag', 'mass': 170.048013 }, { 'name': 'DiMethyl-CHD2', 'abbr': 'Dimethyl:2H(4)', 'mass': 32.056407 }, { 'name': 'EAPTA d0', 'abbr': 'EQAT', 'mass': 184.157563 }, { 'name': 'EAPTA d5', 'abbr': 'EQAT:2H(5)', 'mass': 189.188947 }, { 'name': 'EDT', 'abbr': 'Ethanedithiol', 'mass': 75.980527 }, { 'name': 'N-ethyl iodoacetamide-d5', 'abbr': 'NEIAA:2H(5)', 'mass': 90.084148 }, { 'name': 'Acrolein addition +94', 'abbr': 'Delta:H(6)C(6)O(1)', 'mass': 94.041865 }, { 'name': 'Acrolein addition +56', 'abbr': 'Delta:H(4)C(3)O(1)', 'mass': 56.026215 }, { 'name': 'Acrolein addition +38', 'abbr': 'Delta:H(2)C(3)', 'mass': 38.01565 }, { 'name': 'Acrolein addition +76', 'abbr': 'Delta:H(4)C(6)', 'mass': 76.0313 }, { 'name': 'Acrolein addition +112', 'abbr': 'Delta:H(8)C(6)O(2)', 'mass': 112.05243 }, { 'name': 'ADP  Ribose addition', 'abbr': 'ADP-Ribosyl', 'mass': 541.06111 }, { 'name': 'N-ethyl iodoacetamide-d0', 'abbr': 'NEIAA', 'mass': 85.052764 }, { 'name': 'Representative mass and accurate mass for 116 & 117', 'abbr': 'iTRAQ4plex', 'mass': 144.102063 }, { 'name': 'Crotonaldehyde', 'abbr': 'Crotonaldehyde', 'mass': 70.041865 }, { 'name': 'bromination', 'abbr': 'Bromo', 'mass': 77.910511 }, { 'name': 'Tyrosine oxidation to 2-aminotyrosine', 'abbr': 'Amino', 'mass': 15.010899 }, { 'name': 'oxidized Arginine biotinylated with biotin hydrazide', 'abbr': 'Argbiotinhydrazide', 'mass': 199.066699 }, { 'name': 'O18 Labeling', 'abbr': 'Label:18O(1)', 'mass': 2.004246 }, { 'name': '13C(6) 15N(2) Silac label', 'abbr': 'Label:13C(6)15N(2)', 'mass': 8.014199 }, { 'name': 'Thiophosphorylation', 'abbr': 'Thiophospho', 'mass': 95.943487 }, { 'name': '4-sulfophenyl isothiocyanate', 'abbr': 'SPITC', 'mass': 214.971084 }, { 'name': 'Light IDBEST tag for quantitation', 'abbr': 'IGBP', 'mass': 296.016039 }, { 'name': 'nucleophilic addtion to cytopiloyne', 'abbr': 'Cytopiloyne', 'mass': 362.136553 }, { 'name': 'nucleophilic addition to cytopiloyne+H2O', 'abbr': 'Cytopiloyne+water', 'mass': 380.147118 }, { 'name': '13C(6) 15N(4) Silac label', 'abbr': 'Label:13C(6)15N(4)', 'mass': 10.008269 }, { 'name': '13C(9) 15N(1) Silac label', 'abbr': 'Label:13C(9)15N(1)', 'mass': 10.027228 }, { 'name': 'Trideuteration', 'abbr': 'Label:2H(3)', 'mass': 3.01883 }, { 'name': '13C(5) 15N(1) Silac label', 'abbr': 'Label:13C(5)15N(1)', 'mass': 6.013809 }, { 'name': 'phosphorylation to pyridyl thiol', 'abbr': 'PET', 'mass': 121.035005 }, { 'name': 'sulfonation of N-terminus', 'abbr': 'CAF', 'mass': 135.983029 }, { 'name': 'Intact BS2-G crosslinker', 'abbr': 'Xlink:BS2G[96]', 'mass': 96.021129 }, { 'name': 'nitrosylation', 'abbr': 'Nitrosyl', 'mass': 28.990164 }, { 'name': 'Glycosylation with KDO', 'abbr': 'Kdo', 'mass': 220.058303 }, { 'name': 'Aminoethylbenzenesulfonylation', 'abbr': 'AEBS', 'mass': 183.035399 }, { 'name': 'Ethanolation', 'abbr': 'Ethanolyl', 'mass': 44.026215 }, { 'name': 'Dimethyl 13C(6)15N(2) Silac label', 'abbr': 'Label:13C(6)15N(2)+Dimethyl', 'mass': 36.045499 }, { 'name': 'Michael addition of hydroxymethylvinyl ketone to cysteine', 'abbr': 'HMVK', 'mass': 86.036779 }, { 'name': 'Ethylation', 'abbr': 'Ethyl', 'mass': 28.0313 }, { 'name': 'Cysteine modified Coenzyme A', 'abbr': 'CoenzymeA', 'mass': 765.09956 }, { 'name': 'Deamidation followed by a methylation', 'abbr': 'Methyl+Deamidated', 'mass': 14.999666 }, { 'name': 'Dimethylation of proline residue', 'abbr': 'Delta:H(5)C(2)', 'mass': 29.039125 }, { 'name': 'Deuterium Methylation of Lysine', 'abbr': 'Methyl:2H(2)', 'mass': 16.028204 }, { 'name': 'Light Sulfanilic Acid (SA) C12', 'abbr': 'SulfanilicAcid', 'mass': 155.004099 }, { 'name': 'Heavy Sulfanilic Acid (SA) C13', 'abbr': 'SulfanilicAcid:13C(6)', 'mass': 161.024228 }, { 'name': 'Biotin polyethyleneoxide amine', 'abbr': 'Biotin-PEO-Amine', 'mass': 356.188212 }, { 'name': 'Tryptophan oxidation to oxolactone', 'abbr': 'Trp->Oxolactone', 'mass': 13.979265 }, { 'name': 'Pierce EZ-Link Biotin-HPDP', 'abbr': 'Biotin-HPDP', 'mass': 428.191582 }, { 'name': 'Mercury Mercaptan', 'abbr': 'Delta:Hg(1)', 'mass': 201.970617 }, { 'name': '(Iodo)-uracil MP', 'abbr': 'IodoU-AMP', 'mass': 322.020217 }, { 'name': '3-(carbamidomethylthio)propanoyl', 'abbr': 'CAMthiopropanoyl', 'mass': 145.019749 }, { 'name': 'biotinoyl-iodoacetyl-ethylenediamine', 'abbr': 'IED-Biotin', 'mass': 326.141261 }, { 'name': 'Fucose', 'abbr': 'dHex', 'mass': 146.057909 }, { 'name': 'deuterated methyl ester', 'abbr': 'Methyl:2H(3)', 'mass': 17.03448 }, { 'name': 'Carboxylation', 'abbr': 'Carboxy', 'mass': 43.989829 }, { 'name': 'Monobromobimane derivative', 'abbr': 'Bromobimane', 'mass': 190.074228 }, { 'name': 'Menadione quinone derivative', 'abbr': 'Menadione', 'mass': 170.036779 }, { 'name': 'Cysteine mercaptoethanol', 'abbr': 'DeStreak', 'mass': 75.998285 }, { 'name': 'FA2/G0F', 'abbr': 'dHex(1)Hex(3)HexNAc(4)', 'mass': 1444.53387 }, { 'name': 'FA2G1/G1F', 'abbr': 'dHex(1)Hex(4)HexNAc(4)', 'mass': 1606.586693 }, { 'name': 'Photo-induced Proline adduct', 'abbr': 'Pro+O(2)', 'mass': 129.042593 }, { 'name': 'FA2G2/G2F', 'abbr': 'dHex(1)Hex(5)HexNAc(4)', 'mass': 1768.639517 }, { 'name': 'A2/G0', 'abbr': 'Hex(3)HexNAc(4)', 'mass': 1298.475961 }, { 'name': 'A2G1/G1', 'abbr': 'Hex(4)HexNAc(4)', 'mass': 1460.528784 }, { 'name': 'A2G2/G2', 'abbr': 'Hex(5)HexNAc(4)', 'mass': 1622.581608 }, { 'name': 'Cysteinylation', 'abbr': 'Cysteinyl', 'mass': 119.004099 }, { 'name': 'Loss of C-terminal K from Heavy Chain of MAb', 'abbr': 'Lys-loss', 'mass': -128.094963 }, { 'name': 'Nmethylmaleimide', 'abbr': 'Nmethylmaleimide', 'mass': 111.032028 }, { 'name': 'Cy3 CyDye DIGE Fluor saturation dye', 'abbr': 'CyDye-Cy3', 'mass': 672.298156 }, { 'name': '2,5-dimethypyrrole', 'abbr': 'DimethylpyrroleAdduct', 'mass': 78.04695 }, { 'name': 'MDA adduct +62', 'abbr': 'Delta:H(2)C(5)', 'mass': 62.01565 }, { 'name': 'MDA adduct +54', 'abbr': 'Delta:H(2)C(3)O(1)', 'mass': 54.010565 }, { 'name': 'Nethylmaleimidehydrolysis', 'abbr': 'Nethylmaleimide+water', 'mass': 143.058243 }, { 'name': 'Mono-methylated lysine labelled with Acetyl_heavy', 'abbr': 'Methyl+Acetyl:2H(3)', 'mass': 59.045045 }, { 'name': 'bis-((N-iodoacetyl)piperazinyl)sulfonerhodamine', 'abbr': 'Xlink:B10621', 'mass': 713.093079 }, { 'name': 'Cleaved and reduced DTBP crosslinker', 'abbr': 'Xlink:DTBP[87]', 'mass': 87.01427 }, { 'name': '10-ethoxyphosphinyl-N-(biotinamidopentyl)decanamide', 'abbr': 'FP-Biotin', 'mass': 572.316129 }, { 'name': 'thiophosphate labeled with biotin-HPDP', 'abbr': 'Thiophos-S-S-biotin', 'mass': 525.142894 }, { 'name': '6-N-biotinylaminohexyl isopropyl phosphate', 'abbr': 'Can-FP-biotin', 'mass': 447.195679 }, { 'name': 'reduced 4-Hydroxynonenal', 'abbr': 'HNE+Delta:H(2)', 'mass': 158.13068 }, { 'name': 'oxidized Threonine biotinylated with biotin hydrazide', 'abbr': 'Thrbiotinhydrazide', 'mass': 240.104482 }, { 'name': 'Michael addition with methylamine', 'abbr': 'Methylamine', 'mass': 13.031634 }, { 'name': 'O-Diisopropylphosphorylation', 'abbr': 'Diisopropylphosphate', 'mass': 164.060231 }, { 'name': 'O-Isopropylphosphorylation', 'abbr': 'Isopropylphospho', 'mass': 122.013281 }, { 'name': 'Bruker Daltonics SERVA-ICPL(TM) quantification chemistry, heavy form', 'abbr': 'ICPL:13C(6)', 'mass': 111.041593 }, { 'name': 'Carbamidomethylated DTT modification of cysteine', 'abbr': 'CarbamidomethylDTT', 'mass': 209.018035 }, { 'name': 'Bruker Daltonics SERVA-ICPL(TM) quantification chemistry, light form', 'abbr': 'ICPL', 'mass': 105.021464 }, { 'name': 'Deamidation in presence of O18', 'abbr': 'Deamidated:18O(1)', 'mass': 2.988261 }, { 'name': 'Ornithine from Arginine', 'abbr': 'Arg->Orn', 'mass': -42.021798 }, { 'name': 'Replacement of proton by copper', 'abbr': 'Cation:Cu[I]', 'mass': 61.921774 }, { 'name': 'Half of a disulfide bridge', 'abbr': 'Dehydro', 'mass': -1.007825 }, { 'name': 'Diphthamide', 'abbr': 'Diphthamide', 'mass': 142.110613 }, { 'name': 'hydroxyfarnesyl', 'abbr': 'Hydroxyfarnesyl', 'mass': 220.182715 }, { 'name': 'diacylglycerol', 'abbr': 'Diacylglycerol', 'mass': 576.511761 }, { 'name': 'carboxyethyl', 'abbr': 'Carboxyethyl', 'mass': 72.021129 }, { 'name': 'hypusine', 'abbr': 'Hypusine', 'mass': 87.068414 }, { 'name': 'retinal', 'abbr': 'Retinylidene', 'mass': 266.203451 }, { 'name': 'alpha-amino adipic acid', 'abbr': 'Lys->AminoadipicAcid', 'mass': 14.96328 }, { 'name': 'pyruvic acid from N-term cys', 'abbr': 'Cys->PyruvicAcid', 'mass': -33.003705 }, { 'name': 'Loss of ammonia', 'abbr': 'Ammonia-loss', 'mass': -17.026549 }, { 'name': 'phycocyanobilin', 'abbr': 'Phycocyanobilin', 'mass': 586.279135 }, { 'name': 'phycoerythrobilin', 'abbr': 'Phycoerythrobilin', 'mass': 588.294785 }, { 'name': 'phytochromobilin', 'abbr': 'Phytochromobilin', 'mass': 584.263485 }, { 'name': 'heme', 'abbr': 'Heme', 'mass': 616.177295 }, { 'name': 'molybdopterin', 'abbr': 'Molybdopterin', 'mass': 521.884073 }, { 'name': 'quinone', 'abbr': 'Quinone', 'mass': 29.974179 }, { 'name': 'glucosylgalactosyl hydroxylysine', 'abbr': 'Glucosylgalactosyl', 'mass': 340.100562 }, { 'name': 'glycosylphosphatidylinositol', 'abbr': 'GPIanchor', 'mass': 123.00853 }, { 'name': 'phosphoribosyl dephospho-coenzyme A', 'abbr': 'PhosphoribosyldephosphoCoA', 'mass': 881.146904 }, { 'name': 'glycerylphosphorylethanolamine', 'abbr': 'GlycerylPE', 'mass': 197.04531 }, { 'name': 'triiodo', 'abbr': 'Triiodothyronine', 'mass': 469.716159 }, { 'name': 'tetraiodo', 'abbr': 'Thyroxine', 'mass': 595.612807 }, { 'name': 'Dehydroalanine (from Tyrosine)', 'abbr': 'Tyr->Dha', 'mass': -94.041865 }, { 'name': '2-amino-3-oxo-butanoic_acid', 'abbr': 'Didehydro', 'mass': -2.01565 }, { 'name': 'oxoalanine', 'abbr': 'Cys->Oxoalanine', 'mass': -17.992806 }, { 'name': 'lactic acid from N-term Ser', 'abbr': 'Ser->LacticAcid', 'mass': -15.010899 }, { 'name': 'diglutamyl', 'abbr': 'GluGlu', 'mass': 258.085186 }, { 'name': 'AMP', 'abbr': 'Phosphoadenosine', 'mass': 329.05252 }, { 'name': 'monoglutamyl', 'abbr': 'Glu', 'mass': 129.042593 }, { 'name': 'hydroxycinnamyl', 'abbr': 'Hydroxycinnamyl', 'mass': 146.036779 }, { 'name': 'glycosyl-L-hydroxyproline', 'abbr': 'Glycosyl', 'mass': 148.037173 }, { 'name': 'flavin mononucleotide', 'abbr': 'FMNH', 'mass': 454.088965 }, { 'name': 'S-diphytanylglycerol diether', 'abbr': 'Archaeol', 'mass': 634.662782 }, { 'name': 'phenyl isocyanate', 'abbr': 'Phenylisocyanate', 'mass': 119.037114 }, { 'name': 'd5-phenyl isocyanate', 'abbr': 'Phenylisocyanate:2H(5)', 'mass': 124.068498 }, { 'name': 'phospho-guanosine', 'abbr': 'Phosphoguanosine', 'mass': 345.047435 }, { 'name': 'hydroxymethyl', 'abbr': 'Hydroxymethyl', 'mass': 30.010565 }, { 'name': 'L-selenocysteinyl molybdenum bis(molybdopterin guanine dinucleotide)', 'abbr': 'MolybdopterinGD+Delta:S(-1)Se(1)', 'mass': 1620.930224 }, { 'name': 'dipyrrolylmethanemethyl', 'abbr': 'Dipyrrolylmethanemethyl', 'mass': 418.137616 }, { 'name': 'uridine phosphodiester', 'abbr': 'PhosphoUridine', 'mass': 306.025302 }, { 'name': 'glycerophospho', 'abbr': 'Glycerophospho', 'mass': 154.00311 }, { 'name': 'thiocarboxylic acid', 'abbr': 'Carboxy->Thiocarboxy', 'mass': 15.977156 }, { 'name': 'persulfide', 'abbr': 'Sulfide', 'mass': 31.972071 }, { 'name': 'N-pyruvic acid 2-iminyl', 'abbr': 'PyruvicAcidIminyl', 'mass': 70.005479 }, { 'name': 'selenyl', 'abbr': 'Delta:Se(1)', 'mass': 79.91652 }, { 'name': 'molybdenum bis(molybdopterin guanine dinucleotide)', 'abbr': 'MolybdopterinGD', 'mass': 1572.985775 }, { 'name': 'dihydroxy', 'abbr': 'Dioxidation', 'mass': 31.989829 }, { 'name': 'octanoyl', 'abbr': 'Octanoyl', 'mass': 126.104465 }, { 'name': 'N-acetylglucosamine-1-phosphoryl', 'abbr': 'PhosphoHexNAc', 'mass': 283.045704 }, { 'name': 'phosphoglycosyl-D-mannose-1-phosphoryl', 'abbr': 'PhosphoHex', 'mass': 242.019154 }, { 'name': 'palmitoleyl', 'abbr': 'Palmitoleyl', 'mass': 236.214016 }, { 'name': 'cholesterol ester', 'abbr': 'Cholesterol', 'mass': 368.344302 }, { 'name': '3,4-didehydroretinylidene', 'abbr': 'Didehydroretinylidene', 'mass': 264.187801 }, { 'name': 'cis-14-hydroxy-10,13-dioxo-7-heptadecenoic ester', 'abbr': 'CHDH', 'mass': 294.183109 }, { 'name': '4-methyl-delta-1-pyrroline-5-carboxyl', 'abbr': 'Methylpyrroline', 'mass': 109.052764 }, { 'name': 'hydroxyheme', 'abbr': 'Hydroxyheme', 'mass': 614.161645 }, { 'name': '(3-aminopropyl)(L-aspartyl-1-amino)phosphoryl-5-adenosine', 'abbr': 'MicrocinC7', 'mass': 386.110369 }, { 'name': 'cyano', 'abbr': 'Cyano', 'mass': 24.995249 }, { 'name': 'hydrogenase diiron subcluster', 'abbr': 'Diironsubcluster', 'mass': 342.786916 }, { 'name': 'amidino', 'abbr': 'Amidino', 'mass': 42.021798 }, { 'name': 'O3-(riboflavin phosphoryl)', 'abbr': 'FMN', 'mass': 438.094051 }, { 'name': 'S-(4a-FMN)', 'abbr': 'FMNC', 'mass': 456.104615 }, { 'name': 'copper sulfido molybdopterin cytosine dinuncleotide', 'abbr': 'CuSMo', 'mass': 922.834855 }, { 'name': '5-hydroxy-N6,N6,N6-trimethyl', 'abbr': 'Hydroxytrimethyl', 'mass': 59.04969 }, { 'name': 'reduction', 'abbr': 'Deoxy', 'mass': -15.994915 }, { 'name': 'microcin E492 siderophore ester from serine', 'abbr': 'Microcin', 'mass': 831.197041 }, { 'name': 'lipid', 'abbr': 'Decanoyl', 'mass': 154.135765 }, { 'name': 'triglutamyl', 'abbr': 'GluGluGlu', 'mass': 387.127779 }, { 'name': 'tetraglutamyl', 'abbr': 'GluGluGluGlu', 'mass': 516.170373 }, { 'name': 'Hexosamine', 'abbr': 'HexN', 'mass': 161.068808 }, { 'name': 'Free monolink of DMP crosslinker', 'abbr': 'Xlink:DMP[154]', 'mass': 154.110613 }, { 'name': 'naphthalene-2,3-dicarboxaldehyde', 'abbr': 'NDA', 'mass': 175.042199 }, { 'name': '4-sulfophenyl isothiocyanate (Heavy C13)', 'abbr': 'SPITC:13C(6)', 'mass': 220.991213 }, { 'name': 'd9-4-trimethyllammoniumbutyryl-', 'abbr': 'TMAB:2H(9)', 'mass': 137.16403 }, { 'name': '4-trimethyllammoniumbutyryl-', 'abbr': 'TMAB', 'mass': 128.107539 }, { 'name': 'fluorescein-5-thiosemicarbazide', 'abbr': 'FTC', 'mass': 421.073241 }, { 'name': 'aminoethylcysteine', 'abbr': 'AEC-MAEC', 'mass': 59.019355 }, { 'name': 'Bisphenol A diglycidyl ether derivative', 'abbr': 'BADGE', 'mass': 340.167459 }, { 'name': '4,4,5,5-D4 Lysine', 'abbr': 'Label:2H(4)', 'mass': 4.025107 }, { 'name': 'Heptose', 'abbr': 'Hep', 'mass': 192.063388 }, { 'name': 'Cy5 CyDye DIGE Fluor saturation dye', 'abbr': 'CyDye-Cy5', 'mass': 684.298156 }, { 'name': 'Dehydropyrrolizidine alkaloid (dehydroretronecine) on cysteines', 'abbr': 'DHP', 'mass': 118.065674 }, { 'name': 'Michael addition of t-butyl hydroxylated BHT (BHTOH) to C, H or K', 'abbr': 'BHTOH', 'mass': 234.16198 }, { 'name': 'Heavy IDBEST tag for quantitation', 'abbr': 'IGBP:13C(2)', 'mass': 298.022748 }, { 'name': 'Nmethylmaleimidehydrolysis', 'abbr': 'Nmethylmaleimide+water', 'mass': 129.042593 }, { 'name': '3-methyl-2-pyridyl isocyanate', 'abbr': 'PyMIC', 'mass': 134.048013 }, { 'name': 'Levuglandinyl - lysine lactam adduct', 'abbr': 'LG-lactam-K', 'mass': 332.19876 }, { 'name': '4,4\'-dianilino-1,1\'-binaphthyl-5,5\'-disulfonic acid', 'abbr': 'BisANS', 'mass': 594.091928 }, { 'name': 'Piperidination', 'abbr': 'Piperidine', 'mass': 68.0626 }, { 'name': 'Diethylation, analogous to Dimethylation', 'abbr': 'Diethyl', 'mass': 56.0626 }, { 'name': 'Levuglandinyl - lysine hydroxylactam adduct', 'abbr': 'LG-Hlactam-K', 'mass': 348.193674 }, { 'name': 'DiMethyl-C13HD2', 'abbr': 'Dimethyl:2H(4)13C(2)', 'mass': 34.063117 }, { 'name': '[3-(2,5)-Dioxopyrrolidin-1-yloxycarbonyl)-propyl]dimethyloctylammonium', 'abbr': 'C8-QAT', 'mass': 227.224915 }, { 'name': 'Lactosylation', 'abbr': 'Hex(2)', 'mass': 324.105647 }, { 'name': 'Levuglandinyl - arginine lactam adduct', 'abbr': 'LG-lactam-R', 'mass': 290.176961 }, { 'name': 'Modification of cystein by withaferin', 'abbr': 'Withaferin', 'mass': 470.266839 }, { 'name': 'desthiobiotin fluorophosphonate', 'abbr': 'Biotin:Thermo-88317', 'mass': 443.291294 }, { 'name': 'CLIP_TRAQ_2', 'abbr': 'CLIP_TRAQ_2', 'mass': 141.098318 }, { 'name': 'Levuglandinyl - arginine hydroxylactam adduct', 'abbr': 'LG-Hlactam-R', 'mass': 306.171876 }, { 'name': 'Maleimide-Biotin', 'abbr': 'Maleimide-PEO2-Biotin', 'mass': 525.225719 }, { 'name': 'Biot_LC_LC', 'abbr': 'Sulfo-NHS-LC-LC-Biotin', 'mass': 452.245726 }, { 'name': 'fluorescein-5-maleimide', 'abbr': 'FNEM', 'mass': 427.069202 }, { 'name': 'propyl-1,2-dideoxy-2\'-methyl-alpha-D-glucopyranoso-[2,1-d]-Delta2\'-thiazoline', 'abbr': 'PropylNAGthiazoline', 'mass': 232.064354 }, { 'name': 'Prompt loss of side chain from oxidised Met', 'abbr': 'Dethiomethyl', 'mass': -48.003371 }, { 'name': 'Accurate mass for 114', 'abbr': 'iTRAQ4plex114', 'mass': 144.105918 }, { 'name': 'Accurate mass for 115', 'abbr': 'iTRAQ4plex115', 'mass': 144.099599 }, { 'name': 'Dibromo', 'abbr': 'Dibromo', 'mass': 155.821022 }, { 'name': 'Ubiquitination', 'abbr': 'LRGG', 'mass': 383.228103 }, { 'name': 'CLIP_TRAQ_3', 'abbr': 'CLIP_TRAQ_3', 'mass': 271.148736 }, { 'name': 'CLIP_TRAQ_4', 'abbr': 'CLIP_TRAQ_4', 'mass': 244.101452 }, { 'name': 'was 15dB-biotin', 'abbr': 'Biotin:Cayman-10141', 'mass': 626.386577 }, { 'name': 'was PGA1-biotin', 'abbr': 'Biotin:Cayman-10013', 'mass': 660.428442 }, { 'name': 'Ala->Ser substitution', 'abbr': 'Ala->Ser', 'mass': 15.994915 }, { 'name': 'Ala->Thr substitution', 'abbr': 'Ala->Thr', 'mass': 30.010565 }, { 'name': 'Ala->Asp substitution', 'abbr': 'Ala->Asp', 'mass': 43.989829 }, { 'name': 'Ala->Pro substitution', 'abbr': 'Ala->Pro', 'mass': 26.01565 }, { 'name': 'Ala->Gly substitution', 'abbr': 'Ala->Gly', 'mass': -14.01565 }, { 'name': 'Ala->Glu substitution', 'abbr': 'Ala->Glu', 'mass': 58.005479 }, { 'name': 'Ala->Val substitution', 'abbr': 'Ala->Val', 'mass': 28.0313 }, { 'name': 'Cys->Phe substitution', 'abbr': 'Cys->Phe', 'mass': 44.059229 }, { 'name': 'Cys->Ser substitution', 'abbr': 'Cys->Ser', 'mass': -15.977156 }, { 'name': 'Cys->Trp substitution', 'abbr': 'Cys->Trp', 'mass': 83.070128 }, { 'name': 'Cys->Tyr substitution', 'abbr': 'Cys->Tyr', 'mass': 60.054144 }, { 'name': 'Cys->Arg substitution', 'abbr': 'Cys->Arg', 'mass': 53.091927 }, { 'name': 'Cys->Gly substitution', 'abbr': 'Cys->Gly', 'mass': -45.987721 }, { 'name': 'Asp->Ala substitution', 'abbr': 'Asp->Ala', 'mass': -43.989829 }, { 'name': 'Asp->His substitution', 'abbr': 'Asp->His', 'mass': 22.031969 }, { 'name': 'Asp->Asn substitution', 'abbr': 'Asp->Asn', 'mass': -0.984016 }, { 'name': 'Asp->Gly substitution', 'abbr': 'Asp->Gly', 'mass': -58.005479 }, { 'name': 'Asp->Tyr substitution', 'abbr': 'Asp->Tyr', 'mass': 48.036386 }, { 'name': 'Asp->Glu substitution', 'abbr': 'Asp->Glu', 'mass': 14.01565 }, { 'name': 'Asp->Val substitution', 'abbr': 'Asp->Val', 'mass': -15.958529 }, { 'name': 'Glu->Ala substitution', 'abbr': 'Glu->Ala', 'mass': -58.005479 }, { 'name': 'Glu->Gln substitution', 'abbr': 'Glu->Gln', 'mass': -0.984016 }, { 'name': 'Glu->Asp substitution', 'abbr': 'Glu->Asp', 'mass': -14.01565 }, { 'name': 'Glu->Lys substitution', 'abbr': 'Glu->Lys', 'mass': -0.94763 }, { 'name': 'Glu->Gly substitution', 'abbr': 'Glu->Gly', 'mass': -72.021129 }, { 'name': 'Glu->Val substitution', 'abbr': 'Glu->Val', 'mass': -29.974179 }, { 'name': 'Phe->Ser substitution', 'abbr': 'Phe->Ser', 'mass': -60.036386 }, { 'name': 'Phe->Cys substitution', 'abbr': 'Phe->Cys', 'mass': -44.059229 }, { 'name': 'Phe->Leu/Ile substitution', 'abbr': 'Phe->Xle', 'mass': -33.98435 }, { 'name': 'Phe->Tyr substitution', 'abbr': 'Phe->Tyr', 'mass': 15.994915 }, { 'name': 'Phe->Val substitution', 'abbr': 'Phe->Val', 'mass': -48 }, { 'name': 'Gly->Ala substitution', 'abbr': 'Gly->Ala', 'mass': 14.01565 }, { 'name': 'Gly->Ser substitution', 'abbr': 'Gly->Ser', 'mass': 30.010565 }, { 'name': 'Gly->Trp substitution', 'abbr': 'Gly->Trp', 'mass': 129.057849 }, { 'name': 'Gly->Glu substitution', 'abbr': 'Gly->Glu', 'mass': 72.021129 }, { 'name': 'Gly->Val substitution', 'abbr': 'Gly->Val', 'mass': 42.04695 }, { 'name': 'Gly->Asp substitution', 'abbr': 'Gly->Asp', 'mass': 58.005479 }, { 'name': 'Gly->Cys substitution', 'abbr': 'Gly->Cys', 'mass': 45.987721 }, { 'name': 'Gly->Arg substitution', 'abbr': 'Gly->Arg', 'mass': 99.079647 }, { 'name': 'deuterated Nicotinic Acid', 'abbr': 'dNIC', 'mass': 109.048119 }, { 'name': 'His->Pro substitution', 'abbr': 'His->Pro', 'mass': -40.006148 }, { 'name': 'His->Tyr substitution', 'abbr': 'His->Tyr', 'mass': 26.004417 }, { 'name': 'His->Gln substitution', 'abbr': 'His->Gln', 'mass': -9.000334 }, { 'name': 'Nicotinic Acid', 'abbr': 'NIC', 'mass': 105.021464 }, { 'name': 'His->Arg substitution', 'abbr': 'His->Arg', 'mass': 19.042199 }, { 'name': 'His->Leu/Ile substitution', 'abbr': 'His->Xle', 'mass': -23.974848 }, { 'name': 'Leu/Ile->Ala substitution', 'abbr': 'Xle->Ala', 'mass': -42.04695 }, { 'name': 'Leu/Ile->Thr substitution', 'abbr': 'Xle->Thr', 'mass': -12.036386 }, { 'name': 'Leu/Ile->Asn substitution', 'abbr': 'Xle->Asn', 'mass': 0.958863 }, { 'name': 'Leu/Ile->Lys substitution', 'abbr': 'Xle->Lys', 'mass': 15.010899 }, { 'name': 'Lys->Thr substitution', 'abbr': 'Lys->Thr', 'mass': -27.047285 }, { 'name': 'Lys->Asn substitution', 'abbr': 'Lys->Asn', 'mass': -14.052036 }, { 'name': 'Lys->Glu substitution', 'abbr': 'Lys->Glu', 'mass': 0.94763 }, { 'name': 'Lys->Gln substitution', 'abbr': 'Lys->Gln', 'mass': -0.036386 }, { 'name': 'Lys->Met substitution', 'abbr': 'Lys->Met', 'mass': 2.945522 }, { 'name': 'Lys->Arg substitution', 'abbr': 'Lys->Arg', 'mass': 28.006148 }, { 'name': 'Lys->Leu/Ile substitution', 'abbr': 'Lys->Xle', 'mass': -15.010899 }, { 'name': 'Leu/Ile->Ser substitution', 'abbr': 'Xle->Ser', 'mass': -26.052036 }, { 'name': 'Leu/Ile->Phe substitution', 'abbr': 'Xle->Phe', 'mass': 33.98435 }, { 'name': 'Leu/Ile->Trp substitution', 'abbr': 'Xle->Trp', 'mass': 72.995249 }, { 'name': 'Leu/Ile->Pro substitution', 'abbr': 'Xle->Pro', 'mass': -16.0313 }, { 'name': 'Leu/Ile->Val substitution', 'abbr': 'Xle->Val', 'mass': -14.01565 }, { 'name': 'Leu/Ile->His substitution', 'abbr': 'Xle->His', 'mass': 23.974848 }, { 'name': 'Leu/Ile->Gln substitution', 'abbr': 'Xle->Gln', 'mass': 14.974514 }, { 'name': 'Leu/Ile->Met substitution', 'abbr': 'Xle->Met', 'mass': 17.956421 }, { 'name': 'Leu/Ile->Arg substitution', 'abbr': 'Xle->Arg', 'mass': 43.017047 }, { 'name': 'Met->Thr substitution', 'abbr': 'Met->Thr', 'mass': -29.992806 }, { 'name': 'Met->Arg substitution', 'abbr': 'Met->Arg', 'mass': 25.060626 }, { 'name': 'Met->Lys substitution', 'abbr': 'Met->Lys', 'mass': -2.945522 }, { 'name': 'Met->Leu/Ile substitution', 'abbr': 'Met->Xle', 'mass': -17.956421 }, { 'name': 'Met->Val substitution', 'abbr': 'Met->Val', 'mass': -31.972071 }, { 'name': 'Asn->Ser substitution', 'abbr': 'Asn->Ser', 'mass': -27.010899 }, { 'name': 'Asn->Thr substitution', 'abbr': 'Asn->Thr', 'mass': -12.995249 }, { 'name': 'Asn->Lys substitution', 'abbr': 'Asn->Lys', 'mass': 14.052036 }, { 'name': 'Asn->Tyr substitution', 'abbr': 'Asn->Tyr', 'mass': 49.020401 }, { 'name': 'Asn->His substitution', 'abbr': 'Asn->His', 'mass': 23.015984 }, { 'name': 'Asn->Asp substitution', 'abbr': 'Asn->Asp', 'mass': 0.984016 }, { 'name': 'Asn->Leu/Ile substitution', 'abbr': 'Asn->Xle', 'mass': -0.958863 }, { 'name': 'Pro->Ser substitution', 'abbr': 'Pro->Ser', 'mass': -10.020735 }, { 'name': 'Pro->Ala substitution', 'abbr': 'Pro->Ala', 'mass': -26.01565 }, { 'name': 'Pro->His substitution', 'abbr': 'Pro->His', 'mass': 40.006148 }, { 'name': 'Pro->Gln substitution', 'abbr': 'Pro->Gln', 'mass': 31.005814 }, { 'name': 'Pro->Thr substitution', 'abbr': 'Pro->Thr', 'mass': 3.994915 }, { 'name': 'Pro->Arg substitution', 'abbr': 'Pro->Arg', 'mass': 59.048347 }, { 'name': 'Pro->Leu/Ile substitution', 'abbr': 'Pro->Xle', 'mass': 16.0313 }, { 'name': 'Gln->Pro substitution', 'abbr': 'Gln->Pro', 'mass': -31.005814 }, { 'name': 'Gln->Lys substitution', 'abbr': 'Gln->Lys', 'mass': 0.036386 }, { 'name': 'Gln->Glu substitution', 'abbr': 'Gln->Glu', 'mass': 0.984016 }, { 'name': 'Gln->His substitution', 'abbr': 'Gln->His', 'mass': 9.000334 }, { 'name': 'Gln->Arg substitution', 'abbr': 'Gln->Arg', 'mass': 28.042534 }, { 'name': 'Gln->Leu/Ile substitution', 'abbr': 'Gln->Xle', 'mass': -14.974514 }, { 'name': 'Arg->Ser substitution', 'abbr': 'Arg->Ser', 'mass': -69.069083 }, { 'name': 'Arg->Trp substitution', 'abbr': 'Arg->Trp', 'mass': 29.978202 }, { 'name': 'Arg->Thr substitution', 'abbr': 'Arg->Thr', 'mass': -55.053433 }, { 'name': 'Arg->Pro substitution', 'abbr': 'Arg->Pro', 'mass': -59.048347 }, { 'name': 'Arg->Lys substitution', 'abbr': 'Arg->Lys', 'mass': -28.006148 }, { 'name': 'Arg->His substitution', 'abbr': 'Arg->His', 'mass': -19.042199 }, { 'name': 'Arg->Gln substitution', 'abbr': 'Arg->Gln', 'mass': -28.042534 }, { 'name': 'Arg->Met substitution', 'abbr': 'Arg->Met', 'mass': -25.060626 }, { 'name': 'Arg->Cys substitution', 'abbr': 'Arg->Cys', 'mass': -53.091927 }, { 'name': 'Arg->Leu/Ile substitution', 'abbr': 'Arg->Xle', 'mass': -43.017047 }, { 'name': 'Arg->Gly substitution', 'abbr': 'Arg->Gly', 'mass': -99.079647 }, { 'name': 'Ser->Phe substitution', 'abbr': 'Ser->Phe', 'mass': 60.036386 }, { 'name': 'Ser->Ala substitution', 'abbr': 'Ser->Ala', 'mass': -15.994915 }, { 'name': 'Ser->Trp substitution', 'abbr': 'Ser->Trp', 'mass': 99.047285 }, { 'name': 'Ser->Thr substitution', 'abbr': 'Ser->Thr', 'mass': 14.01565 }, { 'name': 'Ser->Asn substitution', 'abbr': 'Ser->Asn', 'mass': 27.010899 }, { 'name': 'Ser->Pro substitution', 'abbr': 'Ser->Pro', 'mass': 10.020735 }, { 'name': 'Ser->Tyr substitution', 'abbr': 'Ser->Tyr', 'mass': 76.0313 }, { 'name': 'Ser->Cys substitution', 'abbr': 'Ser->Cys', 'mass': 15.977156 }, { 'name': 'Ser->Arg substitution', 'abbr': 'Ser->Arg', 'mass': 69.069083 }, { 'name': 'Ser->Leu/Ile substitution', 'abbr': 'Ser->Xle', 'mass': 26.052036 }, { 'name': 'Ser->Gly substitution', 'abbr': 'Ser->Gly', 'mass': -30.010565 }, { 'name': 'Thr->Ser substitution', 'abbr': 'Thr->Ser', 'mass': -14.01565 }, { 'name': 'Thr->Ala substitution', 'abbr': 'Thr->Ala', 'mass': -30.010565 }, { 'name': 'Thr->Asn substitution', 'abbr': 'Thr->Asn', 'mass': 12.995249 }, { 'name': 'Thr->Lys substitution', 'abbr': 'Thr->Lys', 'mass': 27.047285 }, { 'name': 'Thr->Pro substitution', 'abbr': 'Thr->Pro', 'mass': -3.994915 }, { 'name': 'Thr->Met substitution', 'abbr': 'Thr->Met', 'mass': 29.992806 }, { 'name': 'Thr->Leu/Ile substitution', 'abbr': 'Thr->Xle', 'mass': 12.036386 }, { 'name': 'Thr->Arg substitution', 'abbr': 'Thr->Arg', 'mass': 55.053433 }, { 'name': 'Val->Phe substitution', 'abbr': 'Val->Phe', 'mass': 48 }, { 'name': 'Val->Ala substitution', 'abbr': 'Val->Ala', 'mass': -28.0313 }, { 'name': 'Val->Glu substitution', 'abbr': 'Val->Glu', 'mass': 29.974179 }, { 'name': 'Val->Met substitution', 'abbr': 'Val->Met', 'mass': 31.972071 }, { 'name': 'Val->Asp substitution', 'abbr': 'Val->Asp', 'mass': 15.958529 }, { 'name': 'Val->Leu/Ile substitution', 'abbr': 'Val->Xle', 'mass': 14.01565 }, { 'name': 'Val->Gly substitution', 'abbr': 'Val->Gly', 'mass': -42.04695 }, { 'name': 'Trp->Ser substitution', 'abbr': 'Trp->Ser', 'mass': -99.047285 }, { 'name': 'Trp->Cys substitution', 'abbr': 'Trp->Cys', 'mass': -83.070128 }, { 'name': 'Trp->Arg substitution', 'abbr': 'Trp->Arg', 'mass': -29.978202 }, { 'name': 'Trp->Gly substitution', 'abbr': 'Trp->Gly', 'mass': -129.057849 }, { 'name': 'Trp->Leu/Ile substitution', 'abbr': 'Trp->Xle', 'mass': -72.995249 }, { 'name': 'Tyr->Phe substitution', 'abbr': 'Tyr->Phe', 'mass': -15.994915 }, { 'name': 'Tyr->Ser substitution', 'abbr': 'Tyr->Ser', 'mass': -76.0313 }, { 'name': 'Tyr->Asn substitution', 'abbr': 'Tyr->Asn', 'mass': -49.020401 }, { 'name': 'Tyr->His substitution', 'abbr': 'Tyr->His', 'mass': -26.004417 }, { 'name': 'Tyr->Asp substitution', 'abbr': 'Tyr->Asp', 'mass': -48.036386 }, { 'name': 'Tyr->Cys substitution', 'abbr': 'Tyr->Cys', 'mass': -60.054144 }, { 'name': 'Mass Defect Tag on lysine e-amino', 'abbr': 'BDMAPP', 'mass': 253.010225 }, { 'name': 'Nitroalkylation by Nitro Linoleic Acid', 'abbr': 'NA-LNO2', 'mass': 325.225309 }, { 'name': 'Nitroalkylation by Nitro Oleic Acid', 'abbr': 'NA-OA-NO2', 'mass': 327.240959 }, { 'name': 'Bruker Daltonics SERVA-ICPL(TM) quantification chemistry, medium form', 'abbr': 'ICPL:2H(4)', 'mass': 109.046571 }, { 'name': 'Carboxymethylated DTT modification of cysteine', 'abbr': 'CarboxymethylDTT', 'mass': 210.00205 }, { 'name': 'Representative mass and accurate mass for 113, 114, 116 & 117', 'abbr': 'iTRAQ8plex', 'mass': 304.20536 }, { 'name': '13C(6) 15N(1) Silac label', 'abbr': 'Label:13C(6)15N(1)', 'mass': 7.017164 }, { 'name': '13C(6) 15N(2) (D)9 SILAC label', 'abbr': 'Label:2H(9)13C(6)15N(2)', 'mass': 17.07069 }, { 'name': 'Dehydrated 4-hydroxynonenal', 'abbr': 'HNE-Delta:H(2)O', 'mass': 138.104465 }, { 'name': '4-Oxononenal (ONE)', 'abbr': '4-ONE', 'mass': 154.09938 }, { 'name': 'O-Dimethylphosphorylation', 'abbr': 'O-Dimethylphosphate', 'mass': 107.997631 }, { 'name': 'O-Methylphosphorylation', 'abbr': 'O-Methylphosphate', 'mass': 93.981981 }, { 'name': 'O-Diethylphosphorylation', 'abbr': 'Diethylphosphate', 'mass': 136.028931 }, { 'name': 'O-Ethylphosphorylation', 'abbr': 'Ethylphosphate', 'mass': 107.997631 }, { 'name': 'O-pinacolylmethylphosphonylation', 'abbr': 'O-pinacolylmethylphosphonate', 'mass': 162.080967 }, { 'name': 'Methylphosphonylation', 'abbr': 'Methylphosphonate', 'mass': 77.987066 }, { 'name': 'O-Isopropylmethylphosphonylation', 'abbr': 'O-Isopropylmethylphosphonate', 'mass': 120.034017 }, { 'name': 'Accurate mass for 115, 118, 119 & 121', 'abbr': 'iTRAQ8plex:13C(6)15N(2)', 'mass': 304.19904 }, { 'name': 'Beta elimination of modified S or T followed by Michael addition of DTT', 'abbr': 'BEMAD_ST', 'mass': 136.001656 }, { 'name': 'Carboxyl modification with ethanolamine', 'abbr': 'Ethanolamine', 'mass': 43.042199 }, { 'name': 'Sixplex Tandem Mass Tag®', 'abbr': 'TMT6plex', 'mass': 229.162932 }, { 'name': 'Beta elimination of alkylated Cys followed by Michael addition of DTT', 'abbr': 'BEMAD_C', 'mass': 120.0245 }, { 'name': 'Duplex Tandem Mass Tag®', 'abbr': 'TMT2plex', 'mass': 225.155833 }, { 'name': 'Native Tandem Mass Tag®', 'abbr': 'TMT', 'mass': 224.152478 }, { 'name': 'ExacTag Thiol label mass for 2-4-7-10 plex', 'abbr': 'ExacTagThiol', 'mass': 972.365219 }, { 'name': 'ExacTag Amine label mass for 2-4-7-10 plex', 'abbr': 'ExacTagAmine', 'mass': 1046.347854 }, { 'name': 'Nitroso Sulfamethoxazole Sulphenamide thiol adduct', 'abbr': 'NO_SMX_SEMD', 'mass': 251.036462 }, { 'name': 'Dehydrated 4-Oxononenal Michael adduct', 'abbr': '4-ONE+Delta:H(-2)O(-1)', 'mass': 136.088815 }, { 'name': 'Intact DADPS Biotin Alkyne tag', 'abbr': 'Biotin:Aha-DADPS', 'mass': 922.465403 }, { 'name': 'Nitroso Sulfamethoxazole Sulfinamide thiol adduct', 'abbr': 'NO_SMX_SIMD', 'mass': 267.031377 }, { 'name': 'Malonylation', 'abbr': 'Malonyl', 'mass': 86.000394 }, { 'name': 'derivatization by N-term modification using 3-Sulfobenzoic succinimidyl ester', 'abbr': '3sulfo', 'mass': 183.983029 }, { 'name': 'trifluoroleucine replacement of leucine', 'abbr': 'trifluoro', 'mass': 53.971735 }, { 'name': 'tri nitro benzene', 'abbr': 'TNBS', 'mass': 210.986535 }, { 'name': 'Alkylation by biotinylated form of phenacyl bromide', 'abbr': 'Biotin-phenacyl', 'mass': 626.263502 }, { 'name': 'Beta elimination of alkylated Cys followed by Michael addition of labelled DTT', 'abbr': 'BEMAD_C:2H(6)', 'mass': 126.062161 }, { 'name': 'lapachenole photochemically added to cysteine', 'abbr': 'lapachenole', 'mass': 240.11503 }, { 'name': '13C(5) Silac label', 'abbr': 'Label:13C(5)', 'mass': 5.016774 }, { 'name': 'maleimide', 'abbr': 'maleimide', 'mass': 97.016378 }, { 'name': 'Isotope Distribution Encoded Tag', 'abbr': 'IDEnT', 'mass': 214.990469 }, { 'name': 'Beta elimination of modified S or T followed by Michael addition of labelled DTT', 'abbr': 'BEMAD_ST:2H(6)', 'mass': 142.039317 }, { 'name': 'Removal of initiator methionine from protein N-terminus', 'abbr': 'Met-loss', 'mass': -131.040485 }, { 'name': 'Removal of initiator methionine from protein N-terminus, then acetylation of the new N-terminus', 'abbr': 'Met-loss+Acetyl', 'mass': -89.02992 }, { 'name': 'Menadione hydroquinone derivative', 'abbr': 'Menadione-HQ', 'mass': 172.05243 }, { 'name': 'Iodoacetic acid derivative w/ 13C label', 'abbr': 'Carboxymethyl:13C(2)', 'mass': 60.012189 }, { 'name': 'D5 N-ethylmaleimide on cysteines', 'abbr': 'NEM:2H(5)', 'mass': 130.079062 }, { 'name': 'Enzymatic glycine removal leaving an amidated C-terminus', 'abbr': 'Gly-loss+Amide', 'mass': -58.005479 }, { 'name': 'tris(2,4,6-trimethoxyphenyl)phosphonium acetic acid N-hydroxysuccinimide ester derivative', 'abbr': 'TMPP-Ac', 'mass': 572.181134 }, { 'name': '13C6 labeled ubiquitinylation residue', 'abbr': 'Label:13C(6)+GG', 'mass': 120.063056 }, { 'name': 'Arginine replacement by Nitropyrimidyl ornithine', 'abbr': 'Arg->Npo', 'mass': 80.985078 }, { 'name': 'Acetyl 4,4,5,5-D4 Lysine', 'abbr': 'Label:2H(4)+Acetyl', 'mass': 46.035672 }, { 'name': 'Labeling transglutaminase substrate on glutamine side chain', 'abbr': 'Pentylamine', 'mass': 70.07825 }, { 'name': 'was PentylamineBiotin', 'abbr': 'Biotin:Thermo-21345', 'mass': 311.166748 }, { 'name': 'Dihydroxy methylglyoxal adduct', 'abbr': 'Dihydroxyimidazolidine', 'mass': 72.021129 }, { 'name': 'Intact DFDNB crosslinker', 'abbr': 'Xlink:DFDNB', 'mass': 163.985807 }, { 'name': 'fluorescent dye that labels cysteines', 'abbr': 'Cy3b-maleimide', 'mass': 682.24612 }, { 'name': 'Hex1HexNAc1', 'abbr': 'Hex(1)HexNAc(1)', 'mass': 365.132196 }, { 'name': 'deuterium cysteamine modification to S or T', 'abbr': 'AEC-MAEC:2H(4)', 'mass': 63.044462 }, { 'name': 'Intact or monolink BMOE crosslinker', 'abbr': 'Xlink:BMOE', 'mass': 220.048407 }, { 'name': 'was Biotin-PEO4-hydrazide', 'abbr': 'Biotin:Thermo-21360', 'mass': 487.246455 }, { 'name': 'Acetyl 13C(6) Silac label', 'abbr': 'Label:13C(6)+Acetyl', 'mass': 48.030694 }, { 'name': 'Acetyl_13C(6) 15N(2) Silac label', 'abbr': 'Label:13C(6)15N(2)+Acetyl', 'mass': 50.024764 }, { 'name': 'Sumo mutant Smt3-WT tail following trypsin digestion', 'abbr': 'EQIGG', 'mass': 484.228162 }, { 'name': 'S-guanylation', 'abbr': 'cGMP', 'mass': 343.031785 }, { 'name': 'S-guanylation-2', 'abbr': 'cGMP+RMP-loss', 'mass': 150.041585 }, { 'name': 'mTRAQ light', 'abbr': 'mTRAQ', 'mass': 140.094963 }, { 'name': 'Adduct of phenylglyoxal with Arg', 'abbr': 'Arg2PG', 'mass': 266.057909 }, { 'name': 'Ubiquitination 2H4 lysine', 'abbr': 'Label:2H(4)+GG', 'mass': 118.068034 }, { 'name': 'spermine adduct', 'abbr': 'spermine', 'mass': 185.189198 }, { 'name': 'SILAC', 'abbr': 'Label:13C(1)2H(3)', 'mass': 4.022185 }, { 'name': 'NHS ester linked Green Fluorescent Bodipy Dye', 'abbr': 'ZGB', 'mass': 758.380841 }, { 'name': 'Methylglyoxal-derived hydroimidazolone', 'abbr': 'MG-H1', 'mass': 54.010565 }, { 'name': 'Glyoxal-derived hydroimiadazolone', 'abbr': 'G-H1', 'mass': 39.994915 }, { 'name': '13C(6) 15N(2) Lysine glygly', 'abbr': 'Label:13C(6)15N(2)+GG', 'mass': 122.057126 }, { 'name': 'Bruker Daltonics SERVA-ICPL(TM) quantification chemistry, +10 Da form', 'abbr': 'ICPL:13C(6)2H(4)', 'mass': 115.0667 }, { 'name': 'Thiol-reactive dye for fluorescence labelling of proteins', 'abbr': 'DyLight-maleimide', 'mass': 940.1999 }, { 'name': 'mTRAQ medium', 'abbr': 'mTRAQ:13C(3)15N(1)', 'mass': 144.102063 }, { 'name': 'Methyl-PEO12-Maleimide', 'abbr': 'Methyl-PEO12-Maleimide', 'mass': 710.383719 }, { 'name': 'covalent linkage of maleimidyl coumarin probe (Molecular Probes D-10253)', 'abbr': 'MDCC', 'mass': 383.148121 }, { 'name': 'SUMOylation by SUMO-2/3', 'abbr': 'QQQTGG', 'mass': 599.266339 }, { 'name': 'SUMOylation by SUMO-1', 'abbr': 'QEQTGG', 'mass': 600.250354 }, { 'name': '2-ammonio-6-[4-(hydroxymethyl)-3-oxidopyridinium-1-yl]- hexanoate', 'abbr': 'HydroxymethylOP', 'mass': 108.021129 }, { 'name': 'was ChromoBiotin', 'abbr': 'Biotin:Thermo-21325', 'mass': 695.310118 }, { 'name': 'Oxidised methionine 13C(1)2H(3) SILAC label', 'abbr': 'Label:13C(1)2H(3)+Oxidation', 'mass': 20.0171 }, { 'name': 'Super Heavy TMTpro', 'abbr': 'shTMTpro', 'mass': 313.231019 }, { 'name': 'Biotin polyethyleneoxide (n', 'abbr': 'Biotin-PEG-PRA', 'mass': 578.317646 }, { 'name': 'Methionine replacement by azido homoalanine', 'abbr': 'Met->Aha', 'mass': -4.986324 }, { 'name': 'SILAC 15N(4)', 'abbr': 'Label:15N(4)', 'mass': 3.98814 }, { 'name': 'pyrophosphorylation of Ser/Thr', 'abbr': 'pyrophospho', 'mass': 159.932662 }, { 'name': 'methionine replacement by homopropargylglycine', 'abbr': 'Met->Hpg', 'mass': -21.987721 }, { 'name': '2,3,4,6-tetra-O-Acetyl-1-allyl-alpha-D-galactopyranoside modification of cysteine', 'abbr': '4AcAllylGal', 'mass': 372.142033 }, { 'name': 'Reaction with dimethylarsinous (AsIII) acid', 'abbr': 'DimethylArsino', 'mass': 103.960719 }, { 'name': 'Lys->Cys substitution and carbamidomethylation', 'abbr': 'Lys->CamCys', 'mass': 31.935685 }, { 'name': 'Phe->Cys substitution and carbamidomethylation', 'abbr': 'Phe->CamCys', 'mass': 12.962234 }, { 'name': 'Leu->Met substitution and sulfoxidation', 'abbr': 'Leu->MetOx', 'mass': 33.951335 }, { 'name': 'Lys->Met substitution and sulfoxidation', 'abbr': 'Lys->MetOx', 'mass': 18.940436 }, { 'name': 'Gluconoylation', 'abbr': 'Galactosyl', 'mass': 178.047738 }, { 'name': 'Monolink of SMCC terminated with 3-(dimethylamino)-1-propylamine', 'abbr': 'Xlink:SMCC[321]', 'mass': 321.205242 }, { 'name': '2,4-diacetamido-2,4,6-trideoxyglucopyranose', 'abbr': 'Bacillosamine', 'mass': 228.111007 }, { 'name': 'Cys modification by (1-oxyl-2,2,5,5-tetramethyl-3-pyrroline-3-methyl)methanesulfonate (MTSL)', 'abbr': 'MTSL', 'mass': 184.07961 }, { 'name': '4-hydroxy-2-nonenal and biotinamidohexanoic acid hydrazide, reduced', 'abbr': 'HNE-BAHAH', 'mass': 511.319226 }, { 'name': 'addition of lophotoxin to tyrosine', 'abbr': 'LTX+Lophotoxin', 'mass': 416.147118 }, { 'name': 'Methylmalonylation on Serine', 'abbr': 'Methylmalonylation', 'mass': 100.016044 }, { 'name': 'Cysteine modifier', 'abbr': 'AROD', 'mass': 820.336015 }, { 'name': 'carbamidomethylated Cys that undergoes beta-elimination and Michael addition of methylamine', 'abbr': 'Cys->methylaminoAla', 'mass': -2.945522 }, { 'name': 'Carbamidomethylated Cys that undergoes beta-elimination and Michael addition of ethylamine', 'abbr': 'Cys->ethylaminoAla', 'mass': 11.070128 }, { 'name': '13C(4) 15N(2) Lysine glygly', 'abbr': 'Label:13C(4)15N(2)+GG', 'mass': 120.050417 }, { 'name': 'ethyl amino', 'abbr': 'ethylamino', 'mass': 27.047285 }, { 'name': '2-OH-ethyl thio-Ser', 'abbr': 'MercaptoEthanol', 'mass': 60.003371 }, { 'name': 'High molecular absorption maleimide label for proteins', 'abbr': 'Atto495Maleimide', 'mass': 474.250515 }, { 'name': 'Photocleavable Biotin + GalNAz on O-GlcNAc', 'abbr': 'AMTzHexNAc2', 'mass': 502.202341 }, { 'name': 'deamidation followed by esterification with ethanol', 'abbr': 'Ethyl+Deamidated', 'mass': 29.015316 }, { 'name': 'SUMOylation by SUMO-2/3 (formic acid cleavage)', 'abbr': 'VFQQQTGG', 'mass': 845.403166 }, { 'name': 'SUMOylation by SUMO-1 (formic acid cleavage)', 'abbr': 'VIEVYQEQTGG', 'mass': 1203.577168 }, { 'name': 'Chlorination of tyrosine residues', 'abbr': 'Chlorination', 'mass': 33.961028 }, { 'name': 'Dichlorination', 'abbr': 'dichlorination', 'mass': 67.922055 }, { 'name': '2,4-Dinitrobenzenesulfenyl', 'abbr': 'DNPS', 'mass': 198.981352 }, { 'name': 'High molecular absorption label for proteins', 'abbr': 'SulfoGMBS', 'mass': 458.162391 }, { 'name': 'Modified GMBS X linker', 'abbr': 'DimethylamineGMBS', 'mass': 267.158292 }, { 'name': 'SILAC label', 'abbr': 'Label:15N(2)2H(9)', 'mass': 11.050561 }, { 'name': 'Levuglandinyl-lysine anhydrolactam adduct', 'abbr': 'LG-anhydrolactam', 'mass': 314.188195 }, { 'name': 'Levuglandinyl-lysine pyrrole adduct', 'abbr': 'LG-pyrrole', 'mass': 316.203845 }, { 'name': 'Levuglandinyl-lysine anhyropyrrole adduct', 'abbr': 'LG-anhyropyrrole', 'mass': 298.19328 }, { 'name': 'Condensation product of 3-deoxyglucosone', 'abbr': '3-deoxyglucosone', 'mass': 144.042259 }, { 'name': 'Replacement of proton by lithium', 'abbr': 'Cation:Li', 'mass': 6.008178 }, { 'name': 'Replacement of 2 protons by calcium', 'abbr': 'Cation:Ca[II]', 'mass': 37.946941 }, { 'name': 'Replacement of 2 protons by iron', 'abbr': 'Cation:Fe[II]', 'mass': 53.919289 }, { 'name': 'Replacement of 2 protons by nickel', 'abbr': 'Cation:Ni[II]', 'mass': 55.919696 }, { 'name': 'Replacement of 2 protons by zinc', 'abbr': 'Cation:Zn[II]', 'mass': 61.913495 }, { 'name': 'Replacement of proton by silver', 'abbr': 'Cation:Ag', 'mass': 105.897267 }, { 'name': 'Replacement of 2 protons by magnesium', 'abbr': 'Cation:Mg[II]', 'mass': 21.969392 }, { 'name': 'S-(2-succinyl) cysteine', 'abbr': '2-succinyl', 'mass': 116.010959 }, { 'name': 'propargylamine', 'abbr': 'Propargylamine', 'mass': 37.031634 }, { 'name': 'phospho-propargylamine', 'abbr': 'Phosphopropargyl', 'mass': 116.997965 }, { 'name': 'SUMOylation by SUMO-1 after tryptic cleavage', 'abbr': 'SUMO2135', 'mass': 2135.920496 }, { 'name': 'SUMOylation by SUMO-2/3 after tryptic cleavage', 'abbr': 'SUMO3549', 'mass': 3549.536568 }, { 'name': '5-glutamyl serotonin', 'abbr': 'serotonylation', 'mass': 159.068414 }, { 'name': 'Benzyl isothiocyanate', 'abbr': 'BITC', 'mass': 149.02992 }, { 'name': '2,3-dihydro-2,2-dimethyl-7-benzofuranol N-methyl carbamate', 'abbr': 'Carbofuran', 'mass': 57.021464 }, { 'name': 'Phenethyl isothiocyanate', 'abbr': 'PEITC', 'mass': 163.04557 }, { 'name': 'membrane protein extraction', 'abbr': 'thioacylPA', 'mass': 159.035399 }, { 'name': 'maleimide-3-saccharide', 'abbr': 'maleimide3', 'mass': 969.366232 }, { 'name': 'maleimide-5-saccharide', 'abbr': 'maleimide5', 'mass': 1293.471879 }, { 'name': 'Puromycin', 'abbr': 'Puromycin', 'mass': 453.212452 }, { 'name': 'Condensation product of glucosone', 'abbr': 'glucosone', 'mass': 160.037173 }, { 'name': 'Dimethyl 13C(6) Silac label', 'abbr': 'Label:13C(6)+Dimethyl', 'mass': 34.051429 }, { 'name': 'Native cysteine-reactive Tandem Mass Tag®', 'abbr': 'cysTMT', 'mass': 299.166748 }, { 'name': 'cysteine-reactive Sixplex Tandem Mass Tag®', 'abbr': 'cysTMT6plex', 'mass': 304.177202 }, { 'name': 'ISD (z+2)-series', 'abbr': 'ISD_z+2_ion', 'mass': -15.010899 }, { 'name': 'replacement of proton with ammonium ion', 'abbr': 'Ammonium', 'mass': 17.026549 }, { 'name': 'was Biotin-maleimide', 'abbr': 'Biotin:Sigma-B1267', 'mass': 449.17329 }, { 'name': '15N(1)', 'abbr': 'Label:15N(1)', 'mass': 0.997035 }, { 'name': '15N(2)', 'abbr': 'Label:15N(2)', 'mass': 1.99407 }, { 'name': '15N(3)', 'abbr': 'Label:15N(3)', 'mass': 2.991105 }, { 'name': 'aminotyrosine with sulfation', 'abbr': 'sulfo+amino', 'mass': 94.967714 }, { 'name': 'Azidohomoalanine (AHA) bound to propargylglycine-NH2 (alkyne)', 'abbr': 'AHA-Alkyne', 'mass': 107.077339 }, { 'name': 'Azidohomoalanine (AHA) bound to DDDDK-propargylglycine-NH2 (alkyne)', 'abbr': 'AHA-Alkyne-KDDDD', 'mass': 695.280074 }, { 'name': '(-)-epigallocatechin-3-gallate', 'abbr': 'EGCG1', 'mass': 456.069261 }, { 'name': '(-)-dehydroepigallocatechin', 'abbr': 'EGCG2', 'mass': 287.055563 }, { 'name': 'Monomethylated Arg13C(6) 15N(4)', 'abbr': 'Label:13C(6)15N(4)+Methyl', 'mass': 24.023919 }, { 'name': 'Dimethylated Arg13C(6) 15N(4)', 'abbr': 'Label:13C(6)15N(4)+Dimethyl', 'mass': 38.039569 }, { 'name': '2H(3) 13C(1) monomethylated Arg13C(6) 15N(4)', 'abbr': 'Label:13C(6)15N(4)+Methyl:2H(3)13C(1)', 'mass': 28.046104 }, { 'name': '2H(6) 13C(2) Dimethylated Arg13C(6) 15N(4)', 'abbr': 'Label:13C(6)15N(4)+Dimethyl:2H(6)13C(2)', 'mass': 46.083939 }, { 'name': 'Sec Iodoacetamide derivative', 'abbr': 'Cys->CamSec', 'mass': 104.965913 }, { 'name': 'formaldehyde adduct', 'abbr': 'Thiazolidine', 'mass': 12 }, { 'name': 'Addition of DEDGFLYMVYASQETFG', 'abbr': 'DEDGFLYMVYASQETFG', 'mass': 1970.824411 }, { 'name': 'Nalpha-(3-maleimidylpropionyl)biocytin', 'abbr': 'Biotin:Invitrogen-M1602', 'mass': 523.210069 }, { 'name': 'Water-quenched monolink of DSS/BS3 crosslinker', 'abbr': 'Xlink:DSS[156]', 'mass': 156.078644 }, { 'name': 'DMPO spin-trap nitrone adduct', 'abbr': 'DMPO', 'mass': 111.068414 }, { 'name': 'glycidamide adduct', 'abbr': 'glycidamide', 'mass': 87.032028 }, { 'name': 'C-terminal homoserine lactone and two aminohexanoic acids', 'abbr': 'Ahx2+Hsl', 'mass': 309.205242 }, { 'name': 'Isotope-Coded Dimedone light form', 'abbr': 'ICDID', 'mass': 138.06808 }, { 'name': 'Isotope-Coded Dimedone heavy form', 'abbr': 'ICDID:2H(6)', 'mass': 144.10574 }, { 'name': 'Water quenched monolink of EGS cross-linker', 'abbr': 'Xlink:EGS[244]', 'mass': 244.058303 }, { 'name': 'Water quenched monolink of DST crosslinker', 'abbr': 'Xlink:DST[132]', 'mass': 132.005873 }, { 'name': 'Water quenched monolink of DSP/DTSSP crosslinker', 'abbr': 'Xlink:DTSSP[192]', 'mass': 191.991486 }, { 'name': 'Water quenched monolink of SMCC', 'abbr': 'Xlink:SMCC[237]', 'mass': 237.100108 }, { 'name': 'Tyrosine caged with 2-nitrobenzyl (ONB)', 'abbr': '2-nitrobenzyl', 'mass': 135.032028 }, { 'name': 'Water quenched monolink of DMP crosslinker', 'abbr': 'Xlink:DMP[140]', 'mass': 140.094963 }, { 'name': 'Cleavage product of EGS protein crosslinks by hydroylamine treatment', 'abbr': 'Xlink:EGS[115]', 'mass': 115.026943 }, { 'name': 'N-ethylmaleimide on selenocysteines', 'abbr': 'Cys->SecNEM', 'mass': 172.992127 }, { 'name': 'D5 N-ethylmaleimide on selenocysteines', 'abbr': 'Cys->SecNEM:2H(5)', 'mass': 178.023511 }, { 'name': 'Thiadiazolydation of Cys', 'abbr': 'Thiadiazole', 'mass': 174.025169 }, { 'name': 'desthiobiotin modification of lysine', 'abbr': 'Biotin:Thermo-88310', 'mass': 196.121178 }, { 'name': 'TAMRA fluorophosphonate modification of serine', 'abbr': 'TAMRA-FP', 'mass': 659.312423 }, { 'name': 'Maleimide-Biotin + Water', 'abbr': 'Biotin:Thermo-21901+H2O', 'mass': 543.236284 }, { 'name': 'Deoxyhypusine', 'abbr': 'Deoxyhypusine', 'mass': 71.073499 }, { 'name': 'Acetyldeoxyhypusine', 'abbr': 'Acetyldeoxyhypusine', 'mass': 113.084064 }, { 'name': 'Acetylhypusine', 'abbr': 'Acetylhypusine', 'mass': 129.078979 }, { 'name': 'Ala->Cys substitution', 'abbr': 'Ala->Cys', 'mass': 31.972071 }, { 'name': 'Ala->Phe substitution', 'abbr': 'Ala->Phe', 'mass': 76.0313 }, { 'name': 'Ala->His substitution', 'abbr': 'Ala->His', 'mass': 66.021798 }, { 'name': 'Ala->Leu/Ile substitution', 'abbr': 'Ala->Xle', 'mass': 42.04695 }, { 'name': 'Ala->Lys substitution', 'abbr': 'Ala->Lys', 'mass': 57.057849 }, { 'name': 'Ala->Met substitution', 'abbr': 'Ala->Met', 'mass': 60.003371 }, { 'name': 'Ala->Asn substitution', 'abbr': 'Ala->Asn', 'mass': 43.005814 }, { 'name': 'Ala->Gln substitution', 'abbr': 'Ala->Gln', 'mass': 57.021464 }, { 'name': 'Ala->Arg substitution', 'abbr': 'Ala->Arg', 'mass': 85.063997 }, { 'name': 'Ala->Trp substitution', 'abbr': 'Ala->Trp', 'mass': 115.042199 }, { 'name': 'Ala->Tyr substitution', 'abbr': 'Ala->Tyr', 'mass': 92.026215 }, { 'name': 'Cys->Ala substitution', 'abbr': 'Cys->Ala', 'mass': -31.972071 }, { 'name': 'Cys->Asp substitution', 'abbr': 'Cys->Asp', 'mass': 12.017759 }, { 'name': 'Cys->Glu substitution', 'abbr': 'Cys->Glu', 'mass': 26.033409 }, { 'name': 'Cys->His substitution', 'abbr': 'Cys->His', 'mass': 34.049727 }, { 'name': 'Cys->Leu/Ile substitution', 'abbr': 'Cys->Xle', 'mass': 10.07488 }, { 'name': 'Cys->Lys substitution', 'abbr': 'Cys->Lys', 'mass': 25.085779 }, { 'name': 'Cys->Met substitution', 'abbr': 'Cys->Met', 'mass': 28.0313 }, { 'name': 'Cys->Asn substitution', 'abbr': 'Cys->Asn', 'mass': 11.033743 }, { 'name': 'Cys->Pro substitution', 'abbr': 'Cys->Pro', 'mass': -5.956421 }, { 'name': 'Cys->Gln substitution', 'abbr': 'Cys->Gln', 'mass': 25.049393 }, { 'name': 'Cys->Thr substitution', 'abbr': 'Cys->Thr', 'mass': -1.961506 }, { 'name': 'Cys->Val substitution', 'abbr': 'Cys->Val', 'mass': -3.940771 }, { 'name': 'Asp->Cys substitution', 'abbr': 'Asp->Cys', 'mass': -12.017759 }, { 'name': 'Asp->Phe substitution', 'abbr': 'Asp->Phe', 'mass': 32.041471 }, { 'name': 'Asp->Leu/Ile substitution', 'abbr': 'Asp->Xle', 'mass': -1.942879 }, { 'name': 'Asp->Lys substitution', 'abbr': 'Asp->Lys', 'mass': 13.06802 }, { 'name': 'Asp->Met substitution', 'abbr': 'Asp->Met', 'mass': 16.013542 }, { 'name': 'Asp->Pro substitution', 'abbr': 'Asp->Pro', 'mass': -17.974179 }, { 'name': 'Asp->Gln substitution', 'abbr': 'Asp->Gln', 'mass': 13.031634 }, { 'name': 'Asp->Arg substitution', 'abbr': 'Asp->Arg', 'mass': 41.074168 }, { 'name': 'Asp->Ser substitution', 'abbr': 'Asp->Ser', 'mass': -27.994915 }, { 'name': 'Asp->Thr substitution', 'abbr': 'Asp->Thr', 'mass': -13.979265 }, { 'name': 'Asp->Trp substitution', 'abbr': 'Asp->Trp', 'mass': 71.05237 }, { 'name': 'Glu->Cys substitution', 'abbr': 'Glu->Cys', 'mass': -26.033409 }, { 'name': 'Glu->Phe substitution', 'abbr': 'Glu->Phe', 'mass': 18.025821 }, { 'name': 'Glu->His substitution', 'abbr': 'Glu->His', 'mass': 8.016319 }, { 'name': 'Glu->Leu/Ile substitution', 'abbr': 'Glu->Xle', 'mass': -15.958529 }, { 'name': 'Glu->Met substitution', 'abbr': 'Glu->Met', 'mass': 1.997892 }, { 'name': 'Glu->Asn substitution', 'abbr': 'Glu->Asn', 'mass': -14.999666 }, { 'name': 'Glu->Pro substitution', 'abbr': 'Glu->Pro', 'mass': -31.989829 }, { 'name': 'Glu->Arg substitution', 'abbr': 'Glu->Arg', 'mass': 27.058518 }, { 'name': 'Glu->Ser substitution', 'abbr': 'Glu->Ser', 'mass': -42.010565 }, { 'name': 'Glu->Thr substitution', 'abbr': 'Glu->Thr', 'mass': -27.994915 }, { 'name': 'Glu->Trp substitution', 'abbr': 'Glu->Trp', 'mass': 57.03672 }, { 'name': 'Glu->Tyr substitution', 'abbr': 'Glu->Tyr', 'mass': 34.020735 }, { 'name': 'Phe->Ala substitution', 'abbr': 'Phe->Ala', 'mass': -76.0313 }, { 'name': 'Phe->Asp substitution', 'abbr': 'Phe->Asp', 'mass': -32.041471 }, { 'name': 'Phe->Glu substitution', 'abbr': 'Phe->Glu', 'mass': -18.025821 }, { 'name': 'Phe->Gly substitution', 'abbr': 'Phe->Gly', 'mass': -90.04695 }, { 'name': 'Phe->His substitution', 'abbr': 'Phe->His', 'mass': -10.009502 }, { 'name': 'Phe->Lys substitution', 'abbr': 'Phe->Lys', 'mass': -18.973451 }, { 'name': 'Phe->Met substitution', 'abbr': 'Phe->Met', 'mass': -16.027929 }, { 'name': 'Phe->Asn substitution', 'abbr': 'Phe->Asn', 'mass': -33.025486 }, { 'name': 'Phe->Pro substitution', 'abbr': 'Phe->Pro', 'mass': -50.01565 }, { 'name': 'Phe->Gln substitution', 'abbr': 'Phe->Gln', 'mass': -19.009836 }, { 'name': 'Phe->Arg substitution', 'abbr': 'Phe->Arg', 'mass': 9.032697 }, { 'name': 'Phe->Thr substitution', 'abbr': 'Phe->Thr', 'mass': -46.020735 }, { 'name': 'Phe->Trp substitution', 'abbr': 'Phe->Trp', 'mass': 39.010899 }, { 'name': 'Gly->Phe substitution', 'abbr': 'Gly->Phe', 'mass': 90.04695 }, { 'name': 'Gly->His substitution', 'abbr': 'Gly->His', 'mass': 80.037448 }, { 'name': 'Gly->Leu/Ile substitution', 'abbr': 'Gly->Xle', 'mass': 56.0626 }, { 'name': 'Gly->Lys substitution', 'abbr': 'Gly->Lys', 'mass': 71.073499 }, { 'name': 'Gly->Met substitution', 'abbr': 'Gly->Met', 'mass': 74.019021 }, { 'name': 'Gly->Asn substitution', 'abbr': 'Gly->Asn', 'mass': 57.021464 }, { 'name': 'Gly->Pro substitution', 'abbr': 'Gly->Pro', 'mass': 40.0313 }, { 'name': 'Gly->Gln substitution', 'abbr': 'Gly->Gln', 'mass': 71.037114 }, { 'name': 'Gly->Thr substitution', 'abbr': 'Gly->Thr', 'mass': 44.026215 }, { 'name': 'Gly->Tyr substitution', 'abbr': 'Gly->Tyr', 'mass': 106.041865 }, { 'name': 'His->Ala substitution', 'abbr': 'His->Ala', 'mass': -66.021798 }, { 'name': 'His->Cys substitution', 'abbr': 'His->Cys', 'mass': -34.049727 }, { 'name': 'His->Glu substitution', 'abbr': 'His->Glu', 'mass': -8.016319 }, { 'name': 'His->Phe substitution', 'abbr': 'His->Phe', 'mass': 10.009502 }, { 'name': 'His->Gly substitution', 'abbr': 'His->Gly', 'mass': -80.037448 }, { 'name': 'His->Lys substitution', 'abbr': 'His->Lys', 'mass': -8.963949 }, { 'name': 'His->Met substitution', 'abbr': 'His->Met', 'mass': -6.018427 }, { 'name': 'His->Ser substitution', 'abbr': 'His->Ser', 'mass': -50.026883 }, { 'name': 'His->Thr substitution', 'abbr': 'His->Thr', 'mass': -36.011233 }, { 'name': 'His->Val substitution', 'abbr': 'His->Val', 'mass': -37.990498 }, { 'name': 'His->Trp substitution', 'abbr': 'His->Trp', 'mass': 49.020401 }, { 'name': 'Leu/Ile->Cys substitution', 'abbr': 'Xle->Cys', 'mass': -10.07488 }, { 'name': 'Leu/Ile->Asp substitution', 'abbr': 'Xle->Asp', 'mass': 1.942879 }, { 'name': 'Leu/Ile->Glu substitution', 'abbr': 'Xle->Glu', 'mass': 15.958529 }, { 'name': 'Leu/Ile->Gly substitution', 'abbr': 'Xle->Gly', 'mass': -56.0626 }, { 'name': 'Leu/Ile->Tyr substitution', 'abbr': 'Xle->Tyr', 'mass': 49.979265 }, { 'name': 'Lys->Ala substitution', 'abbr': 'Lys->Ala', 'mass': -57.057849 }, { 'name': 'Lys->Cys substitution', 'abbr': 'Lys->Cys', 'mass': -25.085779 }, { 'name': 'Lys->Asp substitution', 'abbr': 'Lys->Asp', 'mass': -13.06802 }, { 'name': 'Lys->Phe substitution', 'abbr': 'Lys->Phe', 'mass': 18.973451 }, { 'name': 'Lys->Gly substitution', 'abbr': 'Lys->Gly', 'mass': -71.073499 }, { 'name': 'Lys->His substitution', 'abbr': 'Lys->His', 'mass': 8.963949 }, { 'name': 'Lys->Pro substitution', 'abbr': 'Lys->Pro', 'mass': -31.042199 }, { 'name': 'Lys->Ser substitution', 'abbr': 'Lys->Ser', 'mass': -41.062935 }, { 'name': 'Lys->Val substitution', 'abbr': 'Lys->Val', 'mass': -29.026549 }, { 'name': 'Lys->Trp substitution', 'abbr': 'Lys->Trp', 'mass': 57.98435 }, { 'name': 'Lys->Tyr substitution', 'abbr': 'Lys->Tyr', 'mass': 34.968366 }, { 'name': 'Met->Ala substitution', 'abbr': 'Met->Ala', 'mass': -60.003371 }, { 'name': 'Met->Cys substitution', 'abbr': 'Met->Cys', 'mass': -28.0313 }, { 'name': 'Met->Asp substitution', 'abbr': 'Met->Asp', 'mass': -16.013542 }, { 'name': 'Met->Glu substitution', 'abbr': 'Met->Glu', 'mass': -1.997892 }, { 'name': 'Met->Phe substitution', 'abbr': 'Met->Phe', 'mass': 16.027929 }, { 'name': 'Met->Gly substitution', 'abbr': 'Met->Gly', 'mass': -74.019021 }, { 'name': 'Met->His substitution', 'abbr': 'Met->His', 'mass': 6.018427 }, { 'name': 'Met->Asn substitution', 'abbr': 'Met->Asn', 'mass': -16.997557 }, { 'name': 'Met->Pro substitution', 'abbr': 'Met->Pro', 'mass': -33.987721 }, { 'name': 'Met->Gln substitution', 'abbr': 'Met->Gln', 'mass': -2.981907 }, { 'name': 'Met->Ser substitution', 'abbr': 'Met->Ser', 'mass': -44.008456 }, { 'name': 'Met->Trp substitution', 'abbr': 'Met->Trp', 'mass': 55.038828 }, { 'name': 'Met->Tyr substitution', 'abbr': 'Met->Tyr', 'mass': 32.022844 }, { 'name': 'Asn->Ala substitution', 'abbr': 'Asn->Ala', 'mass': -43.005814 }, { 'name': 'Asn->Cys substitution', 'abbr': 'Asn->Cys', 'mass': -11.033743 }, { 'name': 'Asn->Glu substitution', 'abbr': 'Asn->Glu', 'mass': 14.999666 }, { 'name': 'Asn->Phe substitution', 'abbr': 'Asn->Phe', 'mass': 33.025486 }, { 'name': 'Asn->Gly substitution', 'abbr': 'Asn->Gly', 'mass': -57.021464 }, { 'name': 'Asn->Met substitution', 'abbr': 'Asn->Met', 'mass': 16.997557 }, { 'name': 'Asn->Pro substitution', 'abbr': 'Asn->Pro', 'mass': -16.990164 }, { 'name': 'Asn->Gln substitution', 'abbr': 'Asn->Gln', 'mass': 14.01565 }, { 'name': 'Asn->Arg substitution', 'abbr': 'Asn->Arg', 'mass': 42.058184 }, { 'name': 'Asn->Val substitution', 'abbr': 'Asn->Val', 'mass': -14.974514 }, { 'name': 'Asn->Trp substitution', 'abbr': 'Asn->Trp', 'mass': 72.036386 }, { 'name': 'Pro->Cys substitution', 'abbr': 'Pro->Cys', 'mass': 5.956421 }, { 'name': 'Pro->Asp substitution', 'abbr': 'Pro->Asp', 'mass': 17.974179 }, { 'name': 'Pro->Glu substitution', 'abbr': 'Pro->Glu', 'mass': 31.989829 }, { 'name': 'Pro->Phe substitution', 'abbr': 'Pro->Phe', 'mass': 50.01565 }, { 'name': 'Pro->Gly substitution', 'abbr': 'Pro->Gly', 'mass': -40.0313 }, { 'name': 'Pro->Lys substitution', 'abbr': 'Pro->Lys', 'mass': 31.042199 }, { 'name': 'Pro->Met substitution', 'abbr': 'Pro->Met', 'mass': 33.987721 }, { 'name': 'Pro->Asn substitution', 'abbr': 'Pro->Asn', 'mass': 16.990164 }, { 'name': 'Pro->Val substitution', 'abbr': 'Pro->Val', 'mass': 2.01565 }, { 'name': 'Pro->Trp substitution', 'abbr': 'Pro->Trp', 'mass': 89.026549 }, { 'name': 'Pro->Tyr substitution', 'abbr': 'Pro->Tyr', 'mass': 66.010565 }, { 'name': 'Gln->Ala substitution', 'abbr': 'Gln->Ala', 'mass': -57.021464 }, { 'name': 'Gln->Cys substitution', 'abbr': 'Gln->Cys', 'mass': -25.049393 }, { 'name': 'Gln->Asp substitution', 'abbr': 'Gln->Asp', 'mass': -13.031634 }, { 'name': 'Gln->Phe substitution', 'abbr': 'Gln->Phe', 'mass': 19.009836 }, { 'name': 'Gln->Gly substitution', 'abbr': 'Gln->Gly', 'mass': -71.037114 }, { 'name': 'Gln->Met substitution', 'abbr': 'Gln->Met', 'mass': 2.981907 }, { 'name': 'Gln->Asn substitution', 'abbr': 'Gln->Asn', 'mass': -14.01565 }, { 'name': 'Gln->Ser substitution', 'abbr': 'Gln->Ser', 'mass': -41.026549 }, { 'name': 'Gln->Thr substitution', 'abbr': 'Gln->Thr', 'mass': -27.010899 }, { 'name': 'Gln->Val substitution', 'abbr': 'Gln->Val', 'mass': -28.990164 }, { 'name': 'Gln->Trp substitution', 'abbr': 'Gln->Trp', 'mass': 58.020735 }, { 'name': 'Gln->Tyr substitution', 'abbr': 'Gln->Tyr', 'mass': 35.004751 }, { 'name': 'Arg->Ala substitution', 'abbr': 'Arg->Ala', 'mass': -85.063997 }, { 'name': 'Arg->Asp substitution', 'abbr': 'Arg->Asp', 'mass': -41.074168 }, { 'name': 'Arg->Glu substitution', 'abbr': 'Arg->Glu', 'mass': -27.058518 }, { 'name': 'Arg->Asn substitution', 'abbr': 'Arg->Asn', 'mass': -42.058184 }, { 'name': 'Arg->Val substitution', 'abbr': 'Arg->Val', 'mass': -57.032697 }, { 'name': 'Arg->Tyr substitution', 'abbr': 'Arg->Tyr', 'mass': 6.962218 }, { 'name': 'Arg->Phe substitution', 'abbr': 'Arg->Phe', 'mass': -9.032697 }, { 'name': 'Ser->Asp substitution', 'abbr': 'Ser->Asp', 'mass': 27.994915 }, { 'name': 'Ser->Glu substitution', 'abbr': 'Ser->Glu', 'mass': 42.010565 }, { 'name': 'Ser->His substitution', 'abbr': 'Ser->His', 'mass': 50.026883 }, { 'name': 'Ser->Lys substitution', 'abbr': 'Ser->Lys', 'mass': 41.062935 }, { 'name': 'Ser->Met substitution', 'abbr': 'Ser->Met', 'mass': 44.008456 }, { 'name': 'Ser->Gln substitution', 'abbr': 'Ser->Gln', 'mass': 41.026549 }, { 'name': 'Ser->Val substitution', 'abbr': 'Ser->Val', 'mass': 12.036386 }, { 'name': 'Thr->Cys substitution', 'abbr': 'Thr->Cys', 'mass': 1.961506 }, { 'name': 'Thr->Asp substitution', 'abbr': 'Thr->Asp', 'mass': 13.979265 }, { 'name': 'Thr->Glu substitution', 'abbr': 'Thr->Glu', 'mass': 27.994915 }, { 'name': 'Thr->Phe substitution', 'abbr': 'Thr->Phe', 'mass': 46.020735 }, { 'name': 'Thr->Gly substitution', 'abbr': 'Thr->Gly', 'mass': -44.026215 }, { 'name': 'Thr->His substitution', 'abbr': 'Thr->His', 'mass': 36.011233 }, { 'name': 'Thr->Gln substitution', 'abbr': 'Thr->Gln', 'mass': 27.010899 }, { 'name': 'Thr->Val substitution', 'abbr': 'Thr->Val', 'mass': -1.979265 }, { 'name': 'Thr->Trp substitution', 'abbr': 'Thr->Trp', 'mass': 85.031634 }, { 'name': 'Thr->Tyr substitution', 'abbr': 'Thr->Tyr', 'mass': 62.01565 }, { 'name': 'Val->Cys substitution', 'abbr': 'Val->Cys', 'mass': 3.940771 }, { 'name': 'Val->His substitution', 'abbr': 'Val->His', 'mass': 37.990498 }, { 'name': 'Val->Lys substitution', 'abbr': 'Val->Lys', 'mass': 29.026549 }, { 'name': 'Val->Asn substitution', 'abbr': 'Val->Asn', 'mass': 14.974514 }, { 'name': 'Val->Pro substitution', 'abbr': 'Val->Pro', 'mass': -2.01565 }, { 'name': 'Val->Gln substitution', 'abbr': 'Val->Gln', 'mass': 28.990164 }, { 'name': 'Val->Arg substitution', 'abbr': 'Val->Arg', 'mass': 57.032697 }, { 'name': 'Val->Ser substitution', 'abbr': 'Val->Ser', 'mass': -12.036386 }, { 'name': 'Val->Thr substitution', 'abbr': 'Val->Thr', 'mass': 1.979265 }, { 'name': 'Val->Trp substitution', 'abbr': 'Val->Trp', 'mass': 87.010899 }, { 'name': 'Val->Tyr substitution', 'abbr': 'Val->Tyr', 'mass': 63.994915 }, { 'name': 'Trp->Ala substitution', 'abbr': 'Trp->Ala', 'mass': -115.042199 }, { 'name': 'Trp->Asp substitution', 'abbr': 'Trp->Asp', 'mass': -71.05237 }, { 'name': 'Trp->Glu substitution', 'abbr': 'Trp->Glu', 'mass': -57.03672 }, { 'name': 'Trp->Phe substitution', 'abbr': 'Trp->Phe', 'mass': -39.010899 }, { 'name': 'Trp->His substitution', 'abbr': 'Trp->His', 'mass': -49.020401 }, { 'name': 'Trp->Lys substitution', 'abbr': 'Trp->Lys', 'mass': -57.98435 }, { 'name': 'Trp->Met substitution', 'abbr': 'Trp->Met', 'mass': -55.038828 }, { 'name': 'Trp->Asn substitution', 'abbr': 'Trp->Asn', 'mass': -72.036386 }, { 'name': 'Trp->Pro substitution', 'abbr': 'Trp->Pro', 'mass': -89.026549 }, { 'name': 'Trp->Gln substitution', 'abbr': 'Trp->Gln', 'mass': -58.020735 }, { 'name': 'Trp->Thr substitution', 'abbr': 'Trp->Thr', 'mass': -85.031634 }, { 'name': 'Trp->Val substitution', 'abbr': 'Trp->Val', 'mass': -87.010899 }, { 'name': 'Trp->Tyr substitution', 'abbr': 'Trp->Tyr', 'mass': -23.015984 }, { 'name': 'Tyr->Ala substitution', 'abbr': 'Tyr->Ala', 'mass': -92.026215 }, { 'name': 'Tyr->Glu substitution', 'abbr': 'Tyr->Glu', 'mass': -34.020735 }, { 'name': 'Tyr->Gly substitution', 'abbr': 'Tyr->Gly', 'mass': -106.041865 }, { 'name': 'Tyr->Lys substitution', 'abbr': 'Tyr->Lys', 'mass': -34.968366 }, { 'name': 'Tyr->Met substitution', 'abbr': 'Tyr->Met', 'mass': -32.022844 }, { 'name': 'Tyr->Pro substitution', 'abbr': 'Tyr->Pro', 'mass': -66.010565 }, { 'name': 'Tyr->Gln substitution', 'abbr': 'Tyr->Gln', 'mass': -35.004751 }, { 'name': 'Tyr->Arg substitution', 'abbr': 'Tyr->Arg', 'mass': -6.962218 }, { 'name': 'Tyr->Thr substitution', 'abbr': 'Tyr->Thr', 'mass': -62.01565 }, { 'name': 'Tyr->Val substitution', 'abbr': 'Tyr->Val', 'mass': -63.994915 }, { 'name': 'Tyr->Trp substitution', 'abbr': 'Tyr->Trp', 'mass': 23.015984 }, { 'name': 'Tyr->Leu/Ile substitution', 'abbr': 'Tyr->Xle', 'mass': -49.979265 }, { 'name': 'Azidohomoalanine coupled to reductively cleaved tag', 'abbr': 'AHA-SS', 'mass': 195.075625 }, { 'name': 'carbamidomethylated form of reductively cleaved tag coupled to azidohomoalanine', 'abbr': 'AHA-SS_CAM', 'mass': 252.097088 }, { 'name': 'Sulfo-SBED Label Photoreactive Biotin Crosslinker', 'abbr': 'Biotin:Thermo-33033', 'mass': 548.223945 }, { 'name': 'Sulfo-SBED Label Photoreactive Biotin Crosslinker minus Hydrogen', 'abbr': 'Biotin:Thermo-33033-H', 'mass': 546.208295 }, { 'name': 'S-(2-monomethylsuccinyl) cysteine', 'abbr': '2-monomethylsuccinyl', 'mass': 130.026609 }, { 'name': 'o-toluene', 'abbr': 'Saligenin', 'mass': 106.041865 }, { 'name': 'o-toluyl-phosphorylation', 'abbr': 'Cresylphosphate', 'mass': 170.013281 }, { 'name': 'Cresyl-Saligenin-phosphorylation', 'abbr': 'CresylSaligeninPhosphate', 'mass': 276.055146 }, { 'name': 'Ub Bromide probe addition', 'abbr': 'Ub-Br2', 'mass': 100.063663 }, { 'name': 'Ubiquitin vinylmethylester', 'abbr': 'Ub-VME', 'mass': 172.084792 }, { 'name': 'Ub Fluorescein probe addition', 'abbr': 'Ub-fluorescein', 'mass': 597.209772 }, { 'name': 'S-(2-dimethylsuccinyl) cysteine', 'abbr': '2-dimethylsuccinyl', 'mass': 144.042259 }, { 'name': 'Addition of Glycine', 'abbr': 'Gly', 'mass': 57.021464 }, { 'name': 'addition of GGE', 'abbr': 'pupylation', 'mass': 243.085521 }, { 'name': '13C4 Methionine label', 'abbr': 'Label:13C(4)', 'mass': 4.013419 }, { 'name': 'S-homocysteinylation', 'abbr': 'HCysteinyl', 'mass': 133.019749 }, { 'name': 'Oxidised 13C4 labelled Methionine', 'abbr': 'Label:13C(4)+Oxidation', 'mass': 20.008334 }, { 'name': 'Side reaction of HisTag', 'abbr': 'UgiJoullie', 'mass': 1106.48935 }, { 'name': 'N-Homocysteine thiolactone', 'abbr': 'HCysThiolactone', 'mass': 117.024835 }, { 'name': 'Side reaction of PG with Side chain of aspartic or glutamic acid', 'abbr': 'UgiJoullieProGly', 'mass': 154.074228 }, { 'name': 'Cys modified with dipy ligand', 'abbr': 'Dipyridyl', 'mass': 225.090212 }, { 'name': 'Chemical modification of the iodinated sites of thyroglobulin by Suzuki reaction', 'abbr': 'Furan', 'mass': 66.010565 }, { 'name': 'Chemical modification of the diiodinated sites of thyroglobulin by Suzuki reaction', 'abbr': 'Difuran', 'mass': 132.021129 }, { 'name': '1-methyl-3-benzoyl-4-hydroxy-4-phenylpiperidine', 'abbr': 'BMP-piperidinol', 'mass': 263.131014 }, { 'name': 'Side reaction of PGPG with Side chain of aspartic or glutamic acid', 'abbr': 'UgiJoullieProGlyProGly', 'mass': 308.148455 }, { 'name': 'Loss of arginine due to transpeptidation', 'abbr': 'Arg-loss', 'mass': -156.101111 }, { 'name': 'Addition of arginine due to transpeptidation', 'abbr': 'Arg', 'mass': 156.101111 }, { 'name': 'Glycosylation with IME linked Hex(2) NeuAc', 'abbr': 'IMEHex(2)NeuAc(1)', 'mass': 688.199683 }, { 'name': 'Butyryl', 'abbr': 'Butyryl', 'mass': 70.041865 }, { 'name': 'Double Carbamidomethylation', 'abbr': 'Dicarbamidomethyl', 'mass': 114.042927 }, { 'name': 'Dimethyl-Medium', 'abbr': 'Dimethyl:2H(6)', 'mass': 34.068961 }, { 'name': 'SUMOylation leaving GlyGlyGln', 'abbr': 'GGQ', 'mass': 242.101505 }, { 'name': 'SUMOylation leaving GlnThrGlyGly', 'abbr': 'QTGG', 'mass': 343.149184 }, { 'name': 'SILAC or AQUA label', 'abbr': 'Label:13C(3)15N(1)', 'mass': 4.007099 }, { 'name': '13C3 label for SILAC', 'abbr': 'Label:13C(3)', 'mass': 3.010064 }, { 'name': '13C4 15N1 label for SILAC', 'abbr': 'Label:13C(4)15N(1)', 'mass': 5.010454 }, { 'name': '2H(10) label', 'abbr': 'Label:2H(10)', 'mass': 10.062767 }, { 'name': 'Label:2H(4)13C(1)', 'abbr': 'Label:2H(4)13C(1)', 'mass': 5.028462 }, { 'name': 'Addition of lysine due to transpeptidation', 'abbr': 'Lys', 'mass': 128.094963 }, { 'name': 'mTRAQ heavy', 'abbr': 'mTRAQ:13C(6)15N(2)', 'mass': 148.109162 }, { 'name': 'N-acetyl neuraminic acid', 'abbr': 'NeuAc', 'mass': 291.095417 }, { 'name': 'N-glycoyl neuraminic acid', 'abbr': 'NeuGc', 'mass': 307.090331 }, { 'name': 'Propyl', 'abbr': 'Propyl', 'mass': 42.04695 }, { 'name': 'Propyl:2H(6)', 'abbr': 'Propyl:2H(6)', 'mass': 48.084611 }, { 'name': 'Propiophenone', 'abbr': 'Propiophenone', 'mass': 132.057515 }, { 'name': 'reaction with phenyl salicylate (PS)', 'abbr': 'PS_Hapten', 'mass': 120.021129 }, { 'name': 'Cy3 Maleimide mono-Reactive dye', 'abbr': 'Cy3-maleimide', 'mass': 753.262796 }, { 'name': 'Reduced acrolein addition +58', 'abbr': 'Delta:H(6)C(3)O(1)', 'mass': 58.041865 }, { 'name': 'Reduced acrolein addition +96', 'abbr': 'Delta:H(8)C(6)O(1)', 'mass': 96.057515 }, { 'name': 'biotin hydrazide labeled acrolein addition +298', 'abbr': 'biotinAcrolein298', 'mass': 298.146347 }, { 'name': '3-methyl-5-(methylamino)-1,3-diphenylpentan-1-one', 'abbr': 'MM-diphenylpentanone', 'mass': 265.146664 }, { 'name': '2-ethyl-3-hydroxy-1,3-diphenylpentan-1-one', 'abbr': 'EHD-diphenylpentanone', 'mass': 266.13068 }, { 'name': 'modification of the lysine side chain from NH2 to guanidine with a H removed in favor of a benzyl group', 'abbr': 'benzylguanidine', 'mass': 132.068748 }, { 'name': 'A fixed +1 charge tag attached to the N-terminus of peptides', 'abbr': 'CarboxymethylDMAP', 'mass': 162.079313 }, { 'name': 'Maleimide-Biotin + 2Water', 'abbr': 'Biotin:Thermo-21901+2H2O', 'mass': 561.246849 }, { 'name': 'Accurate mass for DiLeu 115 isobaric tag', 'abbr': 'DiLeu4plex115', 'mass': 145.12 }, { 'name': 'Accurate mass for DiLeu 116 isobaric tag', 'abbr': 'DiLeu4plex', 'mass': 145.132163 }, { 'name': 'Accurate mass for DiLeu 117 isobaric tag', 'abbr': 'DiLeu4plex117', 'mass': 145.128307 }, { 'name': 'Accurate mass for DiLeu 118 isobaric tag', 'abbr': 'DiLeu4plex118', 'mass': 145.140471 }, { 'name': 'Ammonia quenched monolink of BuUrBu crosslinker', 'abbr': 'Xlink:BuUrBu[213]', 'mass': 213.111341 }, { 'name': 'BisANS with loss of both sulfonates', 'abbr': 'bisANS-sulfonates', 'mass': 434.178299 }, { 'name': 'Chemical reaction with 2,4-dinitro-1-chloro benzene (DNCB)', 'abbr': 'DNCB_hapten', 'mass': 166.001457 }, { 'name': 'N-ethylmaleimideSulfur', 'abbr': 'NEMsulfur', 'mass': 157.019749 }, { 'name': 'SulfurDioxide', 'abbr': 'SulfurDioxide', 'mass': 63.9619 }, { 'name': 'N-ethylmaleimideSulfurWater', 'abbr': 'NEMsulfurWater', 'mass': 175.030314 }, { 'name': 'Modification by hydroxylated tris-(2-chloroethyl)amine (HN-3)', 'abbr': 'HN3_mustard', 'mass': 131.094629 }, { 'name': '3-phosphoglyceryl', 'abbr': '3-phosphoglyceryl', 'mass': 167.982375 }, { 'name': 'Modification by hydroxylated mechloroethamine (HN-2)', 'abbr': 'HN2_mustard', 'mass': 101.084064 }, { 'name': 'D5 N-ethylmaleimide+water on cysteines', 'abbr': 'NEM:2H(5)+H2O', 'mass': 148.089627 }, { 'name': 'Crotonylation', 'abbr': 'Crotonyl', 'mass': 68.026215 }, { 'name': 'O-ethyl, N-dimethyl phosphate', 'abbr': 'O-Et-N-diMePhospho', 'mass': 135.044916 }, { 'name': 'N-dimethylphosphate', 'abbr': 'N-dimethylphosphate', 'mass': 107.013615 }, { 'name': 'phosphate-ribosylation', 'abbr': 'phosphoRibosyl', 'mass': 212.00859 }, { 'name': 'Formation of five membered aromatic heterocycle', 'abbr': 'azole', 'mass': -20.026215 }, { 'name': 'Biotin-PEG11-maleimide', 'abbr': 'Biotin:Thermo-21911', 'mass': 921.461652 }, { 'name': 'Native iodoacetyl Tandem Mass Tag®', 'abbr': 'iodoTMT', 'mass': 324.216141 }, { 'name': 'Sixplex iodoacetyl Tandem Mass Tag®', 'abbr': 'iodoTMT6plex', 'mass': 329.226595 }, { 'name': '13C(2) 15N(2)', 'abbr': 'Label:13C(2)15N(2)', 'mass': 4.00078 }, { 'name': 'Phosphogluconoylation', 'abbr': 'Phosphogluconoylation', 'mass': 258.014069 }, { 'name': '3-fold methylated lysine labelled with Acetyl_heavy', 'abbr': 'Methyl:2H(3)+Acetyl:2H(3)', 'mass': 62.063875 }, { 'name': 'Hex1dHex1', 'abbr': 'dHex(1)Hex(1)', 'mass': 308.110732 }, { 'name': 'reaction with methyl vinyl sulfone', 'abbr': 'methylsulfonylethyl', 'mass': 106.00885 }, { 'name': 'Oxidised 2H(3) labelled Methionine', 'abbr': 'Label:2H(3)+Oxidation', 'mass': 19.013745 }, { 'name': '3-fold methylation with deuterated methyl groups', 'abbr': 'Trimethyl:2H(9)', 'mass': 51.103441 }, { 'name': 'heavy acetylation', 'abbr': 'Acetyl:13C(2)', 'mass': 44.017274 }, { 'name': 'Hex2dHex1', 'abbr': 'dHex(1)Hex(2)', 'mass': 470.163556 }, { 'name': 'Hex3dHex1', 'abbr': 'dHex(1)Hex(3)', 'mass': 632.216379 }, { 'name': 'Hex4dHex1', 'abbr': 'dHex(1)Hex(4)', 'mass': 794.269203 }, { 'name': 'Hex5dHex1', 'abbr': 'dHex(1)Hex(5)', 'mass': 956.322026 }, { 'name': 'Hex6dHex1', 'abbr': 'dHex(1)Hex(6)', 'mass': 1118.37485 }, { 'name': 'reaction with ethyl vinyl sulfone', 'abbr': 'ethylsulfonylethyl', 'mass': 120.0245 }, { 'name': 'reaction with phenyl vinyl sulfone', 'abbr': 'phenylsulfonylethyl', 'mass': 168.0245 }, { 'name': 'PLP bound to lysine reduced by sodium borohydride (NaBH4) to create amine linkage', 'abbr': 'PyridoxalPhosphateH2', 'mass': 231.02966 }, { 'name': 'methionine oxidation to homocysteic acid', 'abbr': 'Homocysteic_acid', 'mass': 33.969094 }, { 'name': 'ADP-ribosylation followed by conversion to hydroxamic acid via hydroxylamine', 'abbr': 'Hydroxamic_acid', 'mass': 15.010899 }, { 'name': 'N-ethylmaleimide on cysteine sulfenic acid', 'abbr': 'Oxidation+NEM', 'mass': 141.042593 }, { 'name': 'fluorescein-hexanoate-NHS hydrolysis', 'abbr': 'NHS-fluorescein', 'mass': 471.131802 }, { 'name': 'Representative mass and accurate mass for 114', 'abbr': 'DiART6plex', 'mass': 217.162932 }, { 'name': 'Accurate mass for DiART6plex 115', 'abbr': 'DiART6plex115', 'mass': 217.156612 }, { 'name': 'Accurate mass for DiART6plex 116 and 119', 'abbr': 'DiART6plex116/119', 'mass': 217.168776 }, { 'name': 'Accurate mass for DiART6plex 117', 'abbr': 'DiART6plex117', 'mass': 217.162456 }, { 'name': 'Accurate mass for DiART6plex 118', 'abbr': 'DiART6plex118', 'mass': 217.175096 }, { 'name': 'iodoacetanilide derivative', 'abbr': 'Iodoacetanilide', 'mass': 133.052764 }, { 'name': '13C labelled iodoacetanilide derivative', 'abbr': 'Iodoacetanilide:13C(6)', 'mass': 139.072893 }, { 'name': 'Diaminopimelic acid-DSP monolinked', 'abbr': 'Dap-DSP', 'mass': 364.076278 }, { 'name': 'N-Acetylmuramic acid', 'abbr': 'MurNAc', 'mass': 275.100502 }, { 'name': 'Sumoylation by SUMO-1 after Cyanogen bromide (CNBr) cleavage', 'abbr': 'EEEDVIEVYQEQTGG', 'mass': 1705.73189 }, { 'name': 'Label:2H(7)15N(4)', 'abbr': 'Label:2H(7)15N(4)', 'mass': 11.032077 }, { 'name': 'Label:2H(6)15N(1)', 'abbr': 'Label:2H(6)15N(1)', 'mass': 7.034695 }, { 'name': 'Sumoylation by SUMO-2/3 after Cyanogen bromide (CNBr) cleavage', 'abbr': 'EDEDTIDVFQQQTGG', 'mass': 1662.700924 }, { 'name': 'A2G2S2/G2S2', 'abbr': 'Hex(5)HexNAc(4)NeuAc(2)', 'mass': 2204.772441 }, { 'name': 'A2G2S1/G2S1', 'abbr': 'Hex(5)HexNAc(4)NeuAc(1)', 'mass': 1913.677025 }, { 'name': 'FA2G2S1/G2FS1', 'abbr': 'dHex(1)Hex(5)HexNAc(4)NeuAc(1)', 'mass': 2059.734933 }, { 'name': 'FA2G2S2/G2FS2', 'abbr': 'dHex(1)Hex(5)HexNAc(4)NeuAc(2)', 'mass': 2350.83035 }, { 'name': 'O3S1HexNAc1', 'abbr': 's-GlcNAc', 'mass': 283.036187 }, { 'name': 'H1O3P1Hex2', 'abbr': 'PhosphoHex(2)', 'mass': 404.071978 }, { 'name': '3-fold methylation with fully labelled methyl groups', 'abbr': 'Trimethyl:13C(3)2H(9)', 'mass': 54.113505 }, { 'name': 'Loss of ammonia (15N)', 'abbr': '15N-oxobutanoic', 'mass': -18.023584 }, { 'name': 'spermidine adduct', 'abbr': 'spermidine', 'mass': 128.131349 }, { 'name': 'Biotin_PEG4', 'abbr': 'Biotin:Thermo-21330', 'mass': 473.219571 }, { 'name': 'Hex Pent(2)', 'abbr': 'Hex(1)Pent(2)', 'mass': 426.137341 }, { 'name': 'Pentose', 'abbr': 'Pentose', 'mass': 132.042259 }, { 'name': 'Hex Pent', 'abbr': 'Hex(1)Pent(1)', 'mass': 294.095082 }, { 'name': 'Hex HexA', 'abbr': 'Hex(1)HexA(1)', 'mass': 338.084912 }, { 'name': 'Hex HexNAc Phos', 'abbr': 'Hex(1)HexNAc(1)Phos(1)', 'mass': 445.098527 }, { 'name': 'Hex HexNAc Sulf', 'abbr': 'Hex(1)HexNAc(1)Sulf(1)', 'mass': 445.089011 }, { 'name': 'Hex NeuAc ---OR--- HexNAc Kdn', 'abbr': 'Hex(1)NeuAc(1)', 'mass': 453.14824 }, { 'name': 'Hex NeuGc', 'abbr': 'Hex(1)NeuGc(1)', 'mass': 469.143155 }, { 'name': 'HexNAc(3)', 'abbr': 'HexNAc(3)', 'mass': 609.238118 }, { 'name': 'HexNAc NeuAc', 'abbr': 'HexNAc(1)NeuAc(1)', 'mass': 494.174789 }, { 'name': 'HexNAc NeuGc', 'abbr': 'HexNAc(1)NeuGc(1)', 'mass': 510.169704 }, { 'name': 'Hex(2) NeuAc ---OR--- Hex HexNAc Kdn', 'abbr': 'Hex(2)NeuAc(1)', 'mass': 615.201064 }, { 'name': 'Hex HexNAc dHex Me', 'abbr': 'Hex(1)HexNAc(1)dHex(1)Me(1)', 'mass': 525.205755 }, { 'name': 'Hex HexNAc dHex Me(2)', 'abbr': 'Hex(1)HexNAc(1)dHex(1)Me(2)', 'mass': 539.221405 }, { 'name': 'Ammonium-quenched monolink of DSS/BS3 crosslinker', 'abbr': 'Xlink:DSS[155]', 'mass': 155.094629 }, { 'name': 'Hex(2) HexNAc', 'abbr': 'Hex(2)HexNAc(1)', 'mass': 527.18502 }, { 'name': 'Hex HexA HexNAc', 'abbr': 'Hex(1)HexA(1)HexNAc(1)', 'mass': 541.164284 }, { 'name': 'Hex(2) HexNAc Me', 'abbr': 'Hex(2)HexNAc(1)Me(1)', 'mass': 541.20067 }, { 'name': 'Hex Pent(3)', 'abbr': 'Hex(1)Pent(3)', 'mass': 558.1796 }, { 'name': 'Hex NeuAc Pent', 'abbr': 'Hex(1)NeuAc(1)Pent(1)', 'mass': 585.190499 }, { 'name': 'Hex(2) HexNAc Sulf', 'abbr': 'Hex(2)HexNAc(1)Sulf(1)', 'mass': 607.141834 }, { 'name': 'Hex2 dHex2', 'abbr': 'dHex(2)Hex(2)', 'mass': 616.221465 }, { 'name': 'dHex Hex(2) HexA', 'abbr': 'dHex(1)Hex(2)HexA(1)', 'mass': 646.195644 }, { 'name': 'Hex HexNAc(2) Sulf', 'abbr': 'Hex(1)HexNAc(2)Sulf(1)', 'mass': 648.168383 }, { 'name': 'Hex(4)', 'abbr': 'Hex(4)', 'mass': 648.211294 }, { 'name': 'dHex Hex(2) HexNAc(2) Pent', 'abbr': 'dHex(1)Hex(2)HexNAc(2)Pent(1)', 'mass': 1008.36456 }, { 'name': 'Hex(2) HexNAc(2) NeuAc ---OR--- dHex Hex HexNAc(2) NeuGc', 'abbr': 'Hex(2)HexNAc(2)NeuAc(1)', 'mass': 1021.359809 }, { 'name': 'Hex(3) HexNAc(2) Pent', 'abbr': 'Hex(3)HexNAc(2)Pent(1)', 'mass': 1024.359475 }, { 'name': 'Hex(4) HexNAc(2)', 'abbr': 'Hex(4)HexNAc(2)', 'mass': 1054.370039 }, { 'name': 'dHex Hex(4) HexNAc Pent', 'abbr': 'dHex(1)Hex(4)HexNAc(1)Pent(1)', 'mass': 1129.390834 }, { 'name': 'dHex Hex(3) HexNAc(2) Pent', 'abbr': 'dHex(1)Hex(3)HexNAc(2)Pent(1)', 'mass': 1170.417383 }, { 'name': 'Hex(3) HexNAc(2) NeuAc', 'abbr': 'Hex(3)HexNAc(2)NeuAc(1)', 'mass': 1183.412632 }, { 'name': 'Hex(4) HexNAc(2) Pent', 'abbr': 'Hex(4)HexNAc(2)Pent(1)', 'mass': 1186.412298 }, { 'name': 'Hex(3) HexNAc(3) Pent', 'abbr': 'Hex(3)HexNAc(3)Pent(1)', 'mass': 1227.438847 }, { 'name': 'Hex(5) HexNAc(2) Phos', 'abbr': 'Hex(5)HexNAc(2)Phos(1)', 'mass': 1296.389194 }, { 'name': 'dHex Hex(4) HexNAc(2) Pent', 'abbr': 'dHex(1)Hex(4)HexNAc(2)Pent(1)', 'mass': 1332.470207 }, { 'name': 'Hex(7) HexNAc', 'abbr': 'Hex(7)HexNAc(1)', 'mass': 1337.449137 }, { 'name': 'Hex(4) HexNAc(2) NeuAc ---OR--- Hex(3) HexNAc(2) dHex NeuGc', 'abbr': 'Hex(4)HexNAc(2)NeuAc(1)', 'mass': 1345.465456 }, { 'name': 'dHex Hex(5) HexNAc(2)', 'abbr': 'dHex(1)Hex(5)HexNAc(2)', 'mass': 1362.480772 }, { 'name': 'dHex Hex(3) HexNAc(3) Pent', 'abbr': 'dHex(1)Hex(3)HexNAc(3)Pent(1)', 'mass': 1373.496756 }, { 'name': 'Hex(3) HexNAc(4) Sulf', 'abbr': 'Hex(3)HexNAc(4)Sulf(1)', 'mass': 1378.432776 }, { 'name': 'M6/Man6', 'abbr': 'Hex(6)HexNAc(2)', 'mass': 1378.475686 }, { 'name': 'Hex(4) HexNAc(3) Pent', 'abbr': 'Hex(4)HexNAc(3)Pent(1)', 'mass': 1389.491671 }, { 'name': 'dHex Hex(4) HexNAc(3)', 'abbr': 'dHex(1)Hex(4)HexNAc(3)', 'mass': 1403.507321 }, { 'name': 'Hex(5) HexNAc(3)', 'abbr': 'Hex(5)HexNAc(3)', 'mass': 1419.502235 }, { 'name': 'Hex(3) HexNAc(4) Pent', 'abbr': 'Hex(3)HexNAc(4)Pent(1)', 'mass': 1430.51822 }, { 'name': 'Hex(6) HexNAc(2) Phos', 'abbr': 'Hex(6)HexNAc(2)Phos(1)', 'mass': 1458.442017 }, { 'name': 'dHex Hex(4) HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(4)HexNAc(3)Sulf(1)', 'mass': 1483.464135 }, { 'name': 'dHex Hex(5) HexNAc(2) Pent', 'abbr': 'dHex(1)Hex(5)HexNAc(2)Pent(1)', 'mass': 1494.52303 }, { 'name': 'Hex(8) HexNAc', 'abbr': 'Hex(8)HexNAc(1)', 'mass': 1499.501961 }, { 'name': 'dHex Hex(3) HexNAc(3) Pent(2)', 'abbr': 'dHex(1)Hex(3)HexNAc(3)Pent(2)', 'mass': 1505.539015 }, { 'name': 'dHex(2) Hex(3) HexNAc(3) Pent', 'abbr': 'dHex(2)Hex(3)HexNAc(3)Pent(1)', 'mass': 1519.554665 }, { 'name': 'dHex Hex(3) HexNAc(4) Sulf', 'abbr': 'dHex(1)Hex(3)HexNAc(4)Sulf(1)', 'mass': 1524.490684 }, { 'name': 'dHex Hex(6) HexNAc(2)', 'abbr': 'dHex(1)Hex(6)HexNAc(2)', 'mass': 1524.533595 }, { 'name': 'dHex Hex(4) HexNAc(3) Pent', 'abbr': 'dHex(1)Hex(4)HexNAc(3)Pent(1)', 'mass': 1535.549579 }, { 'name': 'Hex(4) HexNAc(4) Sulf', 'abbr': 'Hex(4)HexNAc(4)Sulf(1)', 'mass': 1540.485599 }, { 'name': 'M7/Man7', 'abbr': 'Hex(7)HexNAc(2)', 'mass': 1540.52851 }, { 'name': 'dHex(2) Hex(4) HexNAc(3)', 'abbr': 'dHex(2)Hex(4)HexNAc(3)', 'mass': 1549.56523 }, { 'name': 'Hex(5) HexNAc(3) Pent', 'abbr': 'Hex(5)HexNAc(3)Pent(1)', 'mass': 1551.544494 }, { 'name': 'Hex(4) HexNAc(3) NeuGc', 'abbr': 'Hex(4)HexNAc(3)NeuGc(1)', 'mass': 1564.539743 }, { 'name': 'dHex Hex(5) HexNAc(3)', 'abbr': 'dHex(1)Hex(5)HexNAc(3)', 'mass': 1565.560144 }, { 'name': 'dHex Hex(3) HexNAc(4) Pent', 'abbr': 'dHex(1)Hex(3)HexNAc(4)Pent(1)', 'mass': 1576.576129 }, { 'name': 'Hex(3) HexNAc(5) Sulf', 'abbr': 'Hex(3)HexNAc(5)Sulf(1)', 'mass': 1581.512148 }, { 'name': 'Hex(6) HexNAc(3)', 'abbr': 'Hex(6)HexNAc(3)', 'mass': 1581.555059 }, { 'name': 'Hex(3) HexNAc(4) NeuAc ---OR--- Hex(2) HexNAc(4) dHex NeuGc', 'abbr': 'Hex(3)HexNAc(4)NeuAc(1)', 'mass': 1589.571378 }, { 'name': 'Hex(4) HexNAc(4) Pent', 'abbr': 'Hex(4)HexNAc(4)Pent(1)', 'mass': 1592.571043 }, { 'name': 'Hex(7) HexNAc(2) Phos', 'abbr': 'Hex(7)HexNAc(2)Phos(1)', 'mass': 1620.494841 }, { 'name': 'Hex(4) HexNAc(4) Me(2) Pent', 'abbr': 'Hex(4)HexNAc(4)Me(2)Pent(1)', 'mass': 1620.602343 }, { 'name': 'dHex Hex(3) HexNAc(3) Pent(3) ---OR--- Hex(4) HexNAc(2) dHex(2) NeuAc', 'abbr': 'dHex(1)Hex(3)HexNAc(3)Pent(3)', 'mass': 1637.581274 }, { 'name': 'dHex Hex(5) HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(5)HexNAc(3)Sulf(1)', 'mass': 1645.516959 }, { 'name': 'dHex(2) Hex(3) HexNAc(3) Pent(2)', 'abbr': 'dHex(2)Hex(3)HexNAc(3)Pent(2)', 'mass': 1651.596924 }, { 'name': 'Hex(6) HexNAc(3) Phos', 'abbr': 'Hex(6)HexNAc(3)Phos(1)', 'mass': 1661.52139 }, { 'name': 'Hex(4) HexNAc(5)', 'abbr': 'Hex(4)HexNAc(5)', 'mass': 1663.608157 }, { 'name': 'dHex(3) Hex(3) HexNAc(3) Pent', 'abbr': 'dHex(3)Hex(3)HexNAc(3)Pent(1)', 'mass': 1665.612574 }, { 'name': 'dHex(2) Hex(4) HexNAc(3) Pent', 'abbr': 'dHex(2)Hex(4)HexNAc(3)Pent(1)', 'mass': 1681.607488 }, { 'name': 'dHex Hex(4) HexNAc(4) Sulf', 'abbr': 'dHex(1)Hex(4)HexNAc(4)Sulf(1)', 'mass': 1686.543508 }, { 'name': 'dHex Hex(7) HexNAc(2)', 'abbr': 'dHex(1)Hex(7)HexNAc(2)', 'mass': 1686.586419 }, { 'name': 'dHex Hex(4) HexNAc(3) NeuAc ---OR--- dHex(2) Hex(3) HexNAc(3) NeuGc', 'abbr': 'dHex(1)Hex(4)HexNAc(3)NeuAc(1)', 'mass': 1694.602737 }, { 'name': 'Hex(7) HexNAc(2) Phos(2)', 'abbr': 'Hex(7)HexNAc(2)Phos(2)', 'mass': 1700.461172 }, { 'name': 'Hex(5) HexNAc(4) Sulf', 'abbr': 'Hex(5)HexNAc(4)Sulf(1)', 'mass': 1702.538423 }, { 'name': 'M8/Man8', 'abbr': 'Hex(8)HexNAc(2)', 'mass': 1702.581333 }, { 'name': 'dHex Hex(3) HexNAc(4) Pent(2)', 'abbr': 'dHex(1)Hex(3)HexNAc(4)Pent(2)', 'mass': 1708.618387 }, { 'name': 'dHex Hex(4) HexNAc(3) NeuGc ---OR--- Hex(5) HexNAc(3) NeuAc', 'abbr': 'dHex(1)Hex(4)HexNAc(3)NeuGc(1)', 'mass': 1710.597652 }, { 'name': 'dHex(2) Hex(3) HexNAc(4) Pent', 'abbr': 'dHex(2)Hex(3)HexNAc(4)Pent(1)', 'mass': 1722.634037 }, { 'name': 'dHex Hex(3) HexNAc(5) Sulf', 'abbr': 'dHex(1)Hex(3)HexNAc(5)Sulf(1)', 'mass': 1727.570057 }, { 'name': 'dHex Hex(6) HexNAc(3)', 'abbr': 'dHex(1)Hex(6)HexNAc(3)', 'mass': 1727.612968 }, { 'name': 'dHex Hex(3) HexNAc(4) NeuAc', 'abbr': 'dHex(1)Hex(3)HexNAc(4)NeuAc(1)', 'mass': 1735.629286 }, { 'name': 'dHex(3) Hex(3) HexNAc(4)', 'abbr': 'dHex(3)Hex(3)HexNAc(4)', 'mass': 1736.649688 }, { 'name': 'dHex Hex(4) HexNAc(4) Pent', 'abbr': 'dHex(1)Hex(4)HexNAc(4)Pent(1)', 'mass': 1738.628952 }, { 'name': 'Hex(4) HexNAc(5) Sulf', 'abbr': 'Hex(4)HexNAc(5)Sulf(1)', 'mass': 1743.564972 }, { 'name': 'Hex(7) HexNAc(3)', 'abbr': 'Hex(7)HexNAc(3)', 'mass': 1743.607882 }, { 'name': 'dHex Hex(4) HexNAc(3) NeuAc Sulf', 'abbr': 'dHex(1)Hex(4)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1774.559552 }, { 'name': 'Hex(5) HexNAc(4) Me(2) Pent', 'abbr': 'Hex(5)HexNAc(4)Me(2)Pent(1)', 'mass': 1782.655167 }, { 'name': 'Hex(3) HexNAc(6) Sulf', 'abbr': 'Hex(3)HexNAc(6)Sulf(1)', 'mass': 1784.591521 }, { 'name': 'dHex Hex(6) HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(6)HexNAc(3)Sulf(1)', 'mass': 1807.569782 }, { 'name': 'dHex Hex(4) HexNAc(5)', 'abbr': 'dHex(1)Hex(4)HexNAc(5)', 'mass': 1809.666066 }, { 'name': 'dHex Hex(5) HexA HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(5)HexA(1)HexNAc(3)Sulf(1)', 'mass': 1821.549047 }, { 'name': 'Hex(7) HexNAc(3) Phos', 'abbr': 'Hex(7)HexNAc(3)Phos(1)', 'mass': 1823.574213 }, { 'name': 'Hex(6) HexNAc(4) Me(3)', 'abbr': 'Hex(6)HexNAc(4)Me(3)', 'mass': 1826.681382 }, { 'name': 'dHex(2) Hex(4) HexNAc(4) Sulf', 'abbr': 'dHex(2)Hex(4)HexNAc(4)Sulf(1)', 'mass': 1832.601417 }, { 'name': 'Hex(4) HexNAc(3) NeuAc(2)', 'abbr': 'Hex(4)HexNAc(3)NeuAc(2)', 'mass': 1839.640245 }, { 'name': 'dHex Hex(3) HexNAc(4) Pent(3)', 'abbr': 'dHex(1)Hex(3)HexNAc(4)Pent(3)', 'mass': 1840.660646 }, { 'name': 'dHex(2) Hex(5) HexNAc(3) Pent', 'abbr': 'dHex(2)Hex(5)HexNAc(3)Pent(1)', 'mass': 1843.660312 }, { 'name': 'dHex Hex(5) HexNAc(4) Sulf', 'abbr': 'dHex(1)Hex(5)HexNAc(4)Sulf(1)', 'mass': 1848.596331 }, { 'name': 'dHex(2) Hex(3) HexNAc(4) Pent(2)', 'abbr': 'dHex(2)Hex(3)HexNAc(4)Pent(2)', 'mass': 1854.676296 }, { 'name': 'dHex Hex(5) HexNAc(3) NeuAc', 'abbr': 'dHex(1)Hex(5)HexNAc(3)NeuAc(1)', 'mass': 1856.655561 }, { 'name': 'Hex(3) HexNAc(6) Sulf(2)', 'abbr': 'Hex(3)HexNAc(6)Sulf(2)', 'mass': 1864.548335 }, { 'name': 'M9/Man9', 'abbr': 'Hex(9)HexNAc(2)', 'mass': 1864.634157 }, { 'name': 'Hex(4) HexNAc(6)', 'abbr': 'Hex(4)HexNAc(6)', 'mass': 1866.68753 }, { 'name': 'dHex(3) Hex(3) HexNAc(4) Pent', 'abbr': 'dHex(3)Hex(3)HexNAc(4)Pent(1)', 'mass': 1868.691946 }, { 'name': 'dHex Hex(5) HexNAc(3) NeuGc ---OR--- Hex(6) HexNAc(3) NeuAc', 'abbr': 'dHex(1)Hex(5)HexNAc(3)NeuGc(1)', 'mass': 1872.650475 }, { 'name': 'dHex(2) Hex(4) HexNAc(4) Pent', 'abbr': 'dHex(2)Hex(4)HexNAc(4)Pent(1)', 'mass': 1884.686861 }, { 'name': 'dHex Hex(4) HexNAc(5) Sulf', 'abbr': 'dHex(1)Hex(4)HexNAc(5)Sulf(1)', 'mass': 1889.62288 }, { 'name': 'dHex Hex(7) HexNAc(3)', 'abbr': 'dHex(1)Hex(7)HexNAc(3)', 'mass': 1889.665791 }, { 'name': 'dHex Hex(5) HexNAc(4) Pent', 'abbr': 'dHex(1)Hex(5)HexNAc(4)Pent(1)', 'mass': 1900.681776 }, { 'name': 'dHex Hex(5) HexA HexNAc(3) Sulf(2)', 'abbr': 'dHex(1)Hex(5)HexA(1)HexNAc(3)Sulf(2)', 'mass': 1901.505861 }, { 'name': 'Hex(3) HexNAc(7)', 'abbr': 'Hex(3)HexNAc(7)', 'mass': 1907.714079 }, { 'name': 'dHex(2) Hex(5) HexNAc(4)', 'abbr': 'dHex(2)Hex(5)HexNAc(4)', 'mass': 1914.697426 }, { 'name': 'dHex(2) Hex(4) HexNAc(3) NeuAc Sulf', 'abbr': 'dHex(2)Hex(4)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1920.617461 }, { 'name': 'dHex Hex(5) HexNAc(4) Sulf(2)', 'abbr': 'dHex(1)Hex(5)HexNAc(4)Sulf(2)', 'mass': 1928.553146 }, { 'name': 'dHex Hex(5) HexNAc(4) Me(2) Pent', 'abbr': 'dHex(1)Hex(5)HexNAc(4)Me(2)Pent(1)', 'mass': 1928.713076 }, { 'name': 'Hex(5) HexNAc(4) NeuGc', 'abbr': 'Hex(5)HexNAc(4)NeuGc(1)', 'mass': 1929.671939 }, { 'name': 'dHex Hex(3) HexNAc(6) Sulf', 'abbr': 'dHex(1)Hex(3)HexNAc(6)Sulf(1)', 'mass': 1930.64943 }, { 'name': 'dHex Hex(6) HexNAc(4)', 'abbr': 'dHex(1)Hex(6)HexNAc(4)', 'mass': 1930.69234 }, { 'name': 'dHex Hex(5) HexNAc(3) NeuAc Sulf', 'abbr': 'dHex(1)Hex(5)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1936.612375 }, { 'name': 'Hex(7) HexNAc(4)', 'abbr': 'Hex(7)HexNAc(4)', 'mass': 1946.687255 }, { 'name': 'dHex Hex(5) HexNAc(3) NeuGc Sulf', 'abbr': 'dHex(1)Hex(5)HexNAc(3)NeuGc(1)Sulf(1)', 'mass': 1952.60729 }, { 'name': 'Hex(4) HexNAc(5) NeuAc', 'abbr': 'Hex(4)HexNAc(5)NeuAc(1)', 'mass': 1954.703574 }, { 'name': 'Hex(6) HexNAc(4) Me(3) Pent', 'abbr': 'Hex(6)HexNAc(4)Me(3)Pent(1)', 'mass': 1958.72364 }, { 'name': 'dHex Hex(7) HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(7)HexNAc(3)Sulf(1)', 'mass': 1969.622606 }, { 'name': 'dHex Hex(7) HexNAc(3) Phos', 'abbr': 'dHex(1)Hex(7)HexNAc(3)Phos(1)', 'mass': 1969.632122 }, { 'name': 'dHex Hex(5) HexNAc(5)', 'abbr': 'dHex(1)Hex(5)HexNAc(5)', 'mass': 1971.718889 }, { 'name': 'dHex Hex(4) HexNAc(4) NeuAc Sulf', 'abbr': 'dHex(1)Hex(4)HexNAc(4)NeuAc(1)Sulf(1)', 'mass': 1977.638925 }, { 'name': 'dHex(3) Hex(4) HexNAc(4) Sulf', 'abbr': 'dHex(3)Hex(4)HexNAc(4)Sulf(1)', 'mass': 1978.659326 }, { 'name': 'Hex(3) HexNAc(7) Sulf', 'abbr': 'Hex(3)HexNAc(7)Sulf(1)', 'mass': 1987.670893 }, { 'name': 'A3G3', 'abbr': 'Hex(6)HexNAc(5)', 'mass': 1987.713804 }, { 'name': 'Hex(5) HexNAc(4) NeuAc Sulf', 'abbr': 'Hex(5)HexNAc(4)NeuAc(1)Sulf(1)', 'mass': 1993.633839 }, { 'name': 'Hex(3) HexNAc(6) NeuAc', 'abbr': 'Hex(3)HexNAc(6)NeuAc(1)', 'mass': 1995.730123 }, { 'name': 'dHex(2) Hex(3) HexNAc(6)', 'abbr': 'dHex(2)Hex(3)HexNAc(6)', 'mass': 1996.750524 }, { 'name': 'Hex HexNAc NeuGc', 'abbr': 'Hex(1)HexNAc(1)NeuGc(1)', 'mass': 672.222527 }, { 'name': 'dHex Hex(2) HexNAc', 'abbr': 'dHex(1)Hex(2)HexNAc(1)', 'mass': 673.242928 }, { 'name': 'HexNAc(3) Sulf', 'abbr': 'HexNAc(3)Sulf(1)', 'mass': 689.194932 }, { 'name': 'Hex(3) HexNAc', 'abbr': 'Hex(3)HexNAc(1)', 'mass': 689.237843 }, { 'name': 'Hex HexNAc Kdn Sulf', 'abbr': 'Hex(1)HexNAc(1)Kdn(1)Sulf(1)', 'mass': 695.157878 }, { 'name': 'HexNAc(2) NeuAc', 'abbr': 'HexNAc(2)NeuAc(1)', 'mass': 697.254162 }, { 'name': 'HexNAc Kdn(2) ---OR--- Hex(2) HexNAc HexA', 'abbr': 'HexNAc(1)Kdn(2)', 'mass': 703.217108 }, { 'name': 'Hex(3) HexNAc Me', 'abbr': 'Hex(3)HexNAc(1)Me(1)', 'mass': 703.253493 }, { 'name': 'Hex(2) HexA Pent Sulf', 'abbr': 'Hex(2)HexA(1)Pent(1)Sulf(1)', 'mass': 712.136808 }, { 'name': 'HexNAc(2) NeuGc', 'abbr': 'HexNAc(2)NeuGc(1)', 'mass': 713.249076 }, { 'name': 'Hex(4) Phos', 'abbr': 'Hex(4)Phos(1)', 'mass': 728.177625 }, { 'name': 'Hex HexNAc NeuAc Sulf', 'abbr': 'Hex(1)HexNAc(1)NeuAc(1)Sulf(1)', 'mass': 736.184427 }, { 'name': 'Hex HexA HexNAc(2)', 'abbr': 'Hex(1)HexA(1)HexNAc(2)', 'mass': 744.243657 }, { 'name': 'dHex Hex(2) HexNAc Sulf', 'abbr': 'dHex(1)Hex(2)HexNAc(1)Sulf(1)', 'mass': 753.199743 }, { 'name': 'dHex HexNAc(3)', 'abbr': 'dHex(1)HexNAc(3)', 'mass': 755.296027 }, { 'name': 'dHex Hex HexNAc Kdn ---OR--- Hex(2) dHex NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(1)Kdn(1)', 'mass': 761.258973 }, { 'name': 'Hex HexNAc(3)', 'abbr': 'Hex(1)HexNAc(3)', 'mass': 771.290941 }, { 'name': 'HexNAc(2) NeuAc Sulf', 'abbr': 'HexNAc(2)NeuAc(1)Sulf(1)', 'mass': 777.210976 }, { 'name': 'dHex(2) Hex(3)', 'abbr': 'dHex(2)Hex(3)', 'mass': 778.274288 }, { 'name': 'Hex(2) HexA HexNAc Sulf', 'abbr': 'Hex(2)HexA(1)HexNAc(1)Sulf(1)', 'mass': 783.173922 }, { 'name': 'dHex(2) Hex(2) HexA', 'abbr': 'dHex(2)Hex(2)HexA(1)', 'mass': 792.253553 }, { 'name': 'dHex Hex HexNAc(2) Sulf', 'abbr': 'dHex(1)Hex(1)HexNAc(2)Sulf(1)', 'mass': 794.226292 }, { 'name': 'dHex Hex HexNAc NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(1)NeuAc(1)', 'mass': 802.285522 }, { 'name': 'Hex(2) HexNAc(2) Sulf', 'abbr': 'Hex(2)HexNAc(2)Sulf(1)', 'mass': 810.221207 }, { 'name': 'Hex(5)', 'abbr': 'Hex(5)', 'mass': 810.264117 }, { 'name': 'HexNAc(4)', 'abbr': 'HexNAc(4)', 'mass': 812.31749 }, { 'name': 'HexNAc NeuGc(2)', 'abbr': 'HexNAc(1)NeuGc(2)', 'mass': 817.260035 }, { 'name': 'dHex Hex HexNAc NeuGc ---OR--- Hex(2) HexNAc NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(1)NeuGc(1)', 'mass': 818.280436 }, { 'name': 'dHex(2) Hex(2) HexNAc', 'abbr': 'dHex(2)Hex(2)HexNAc(1)', 'mass': 819.300837 }, { 'name': 'Hex(2) HexNAc NeuGc', 'abbr': 'Hex(2)HexNAc(1)NeuGc(1)', 'mass': 834.275351 }, { 'name': 'dHex Hex(3) HexNAc', 'abbr': 'dHex(1)Hex(3)HexNAc(1)', 'mass': 835.295752 }, { 'name': 'dHex Hex(2) HexA HexNAc', 'abbr': 'dHex(1)Hex(2)HexA(1)HexNAc(1)', 'mass': 849.275017 }, { 'name': 'Hex HexNAc(3) Sulf', 'abbr': 'Hex(1)HexNAc(3)Sulf(1)', 'mass': 851.247756 }, { 'name': 'Hex(4) HexNAc', 'abbr': 'Hex(4)HexNAc(1)', 'mass': 851.290667 }, { 'name': 'Hex HexNAc(2) NeuAc', 'abbr': 'Hex(1)HexNAc(2)NeuAc(1)', 'mass': 859.306985 }, { 'name': 'Hex HexNAc(2) NeuGc', 'abbr': 'Hex(1)HexNAc(2)NeuGc(1)', 'mass': 875.3019 }, { 'name': 'Hex(5) Phos', 'abbr': 'Hex(5)Phos(1)', 'mass': 890.230448 }, { 'name': 'dHex(2) Hex HexNAc Kdn', 'abbr': 'dHex(2)Hex(1)HexNAc(1)Kdn(1)', 'mass': 907.316881 }, { 'name': 'dHex Hex(3) HexNAc Sulf', 'abbr': 'dHex(1)Hex(3)HexNAc(1)Sulf(1)', 'mass': 915.252567 }, { 'name': 'dHex Hex HexNAc(3)', 'abbr': 'dHex(1)Hex(1)HexNAc(3)', 'mass': 917.34885 }, { 'name': 'dHex Hex(2) HexA HexNAc Sulf', 'abbr': 'dHex(1)Hex(2)HexA(1)HexNAc(1)Sulf(1)', 'mass': 929.231831 }, { 'name': 'Hex(2) HexNAc(3)', 'abbr': 'Hex(2)HexNAc(3)', 'mass': 933.343765 }, { 'name': 'Hex HexNAc(2) NeuAc Sulf', 'abbr': 'Hex(1)HexNAc(2)NeuAc(1)Sulf(1)', 'mass': 939.2638 }, { 'name': 'dHex(2) Hex(4)', 'abbr': 'dHex(2)Hex(4)', 'mass': 940.327112 }, { 'name': 'Ac Hex HexNAc NeuAc', 'abbr': 'Hex(1)HexNAc(1)NeuAc(1)Ac(1)', 'mass': 698.238177 }, { 'name': 'dHex(2) HexNAc(2) Kdn', 'abbr': 'dHex(2)HexNAc(2)Kdn(1)', 'mass': 948.34343 }, { 'name': 'dHex Hex(2) HexNAc(2) Sulf', 'abbr': 'dHex(1)Hex(2)HexNAc(2)Sulf(1)', 'mass': 956.279116 }, { 'name': 'dHex HexNAc(4)', 'abbr': 'dHex(1)HexNAc(4)', 'mass': 958.375399 }, { 'name': 'Hex HexNAc NeuAc NeuGc', 'abbr': 'Hex(1)HexNAc(1)NeuAc(1)NeuGc(1)', 'mass': 963.317944 }, { 'name': 'dHex Hex HexNAc(2) Kdn ---OR--- Hex(2) HexNAc dHex NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(2)Kdn(1)', 'mass': 964.338345 }, { 'name': 'Hex HexNAc NeuGc(2)', 'abbr': 'Hex(1)HexNAc(1)NeuGc(2)', 'mass': 979.312859 }, { 'name': 'Ac Hex HexNAc NeuAc(2)', 'abbr': 'Hex(1)HexNAc(1)NeuAc(2)Ac(1)', 'mass': 989.333594 }, { 'name': 'dHex(2) Hex(2) HexA HexNAc', 'abbr': 'dHex(2)Hex(2)HexA(1)HexNAc(1)', 'mass': 995.332925 }, { 'name': 'dHex Hex HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(1)HexNAc(3)Sulf(1)', 'mass': 997.305665 }, { 'name': 'Hex(2) HexA NeuAc Pent Sulf', 'abbr': 'Hex(2)HexA(1)NeuAc(1)Pent(1)Sulf(1)', 'mass': 1003.232225 }, { 'name': 'dHex Hex HexNAc(2) NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(2)NeuAc(1)', 'mass': 1005.364894 }, { 'name': 'dHex Hex(3) HexA HexNAc', 'abbr': 'dHex(1)Hex(3)HexA(1)HexNAc(1)', 'mass': 1011.32784 }, { 'name': 'Hex(2) HexNAc(3) Sulf', 'abbr': 'Hex(2)HexNAc(3)Sulf(1)', 'mass': 1013.300579 }, { 'name': 'Hex(5) HexNAc', 'abbr': 'Hex(5)HexNAc(1)', 'mass': 1013.34349 }, { 'name': 'HexNAc(5)', 'abbr': 'HexNAc(5)', 'mass': 1015.396863 }, { 'name': 'Ac(2) Hex HexNAc NeuAc(2)', 'abbr': 'Hex(1)HexNAc(1)NeuAc(2)Ac(2)', 'mass': 1031.344159 }, { 'name': 'Hex(2) HexNAc(2) NeuGc', 'abbr': 'Hex(2)HexNAc(2)NeuGc(1)', 'mass': 1037.354723 }, { 'name': 'Hex(5) Phos(3)', 'abbr': 'Hex(5)Phos(3)', 'mass': 1050.16311 }, { 'name': 'Hex(6) Phos', 'abbr': 'Hex(6)Phos(1)', 'mass': 1052.283272 }, { 'name': 'dHex Hex(2) HexA HexNAc(2)', 'abbr': 'dHex(1)Hex(2)HexA(1)HexNAc(2)', 'mass': 1052.354389 }, { 'name': 'dHex(2) Hex(3) HexNAc Sulf', 'abbr': 'dHex(2)Hex(3)HexNAc(1)Sulf(1)', 'mass': 1061.310475 }, { 'name': 'Hex HexNAc(3) NeuAc', 'abbr': 'Hex(1)HexNAc(3)NeuAc(1)', 'mass': 1062.386358 }, { 'name': 'dHex(2) Hex HexNAc(3)', 'abbr': 'dHex(2)Hex(1)HexNAc(3)', 'mass': 1063.406759 }, { 'name': 'Hex HexNAc(3) NeuGc', 'abbr': 'Hex(1)HexNAc(3)NeuGc(1)', 'mass': 1078.381273 }, { 'name': 'dHex Hex HexNAc(2) NeuAc Sulf', 'abbr': 'dHex(1)Hex(1)HexNAc(2)NeuAc(1)Sulf(1)', 'mass': 1085.321709 }, { 'name': 'dHex Hex(3) HexA HexNAc Sulf', 'abbr': 'dHex(1)Hex(3)HexA(1)HexNAc(1)Sulf(1)', 'mass': 1091.284655 }, { 'name': 'dHex Hex HexA HexNAc(3)', 'abbr': 'dHex(1)Hex(1)HexA(1)HexNAc(3)', 'mass': 1093.380938 }, { 'name': 'Hex(2) HexNAc(2) NeuAc Sulf', 'abbr': 'Hex(2)HexNAc(2)NeuAc(1)Sulf(1)', 'mass': 1101.316623 }, { 'name': 'dHex(2) Hex(2) HexNAc(2) Sulf', 'abbr': 'dHex(2)Hex(2)HexNAc(2)Sulf(1)', 'mass': 1102.337025 }, { 'name': 'dHex(2) Hex HexNAc(2) Kdn ---OR--- Hex(2) HexNAc dHex(2) NeuAc', 'abbr': 'dHex(2)Hex(1)HexNAc(2)Kdn(1)', 'mass': 1110.396254 }, { 'name': 'dHex Hex HexNAc(4)', 'abbr': 'dHex(1)Hex(1)HexNAc(4)', 'mass': 1120.428223 }, { 'name': 'Hex(2) HexNAc(4)', 'abbr': 'Hex(2)HexNAc(4)', 'mass': 1136.423137 }, { 'name': 'Hex(2) HexNAc NeuGc(2)', 'abbr': 'Hex(2)HexNAc(1)NeuGc(2)', 'mass': 1141.365682 }, { 'name': 'dHex(2) Hex(4) HexNAc', 'abbr': 'dHex(2)Hex(4)HexNAc(1)', 'mass': 1143.406484 }, { 'name': 'Hex HexNAc(2) NeuAc(2)', 'abbr': 'Hex(1)HexNAc(2)NeuAc(2)', 'mass': 1150.402402 }, { 'name': 'dHex(2) Hex HexNAc(2) NeuAc', 'abbr': 'dHex(2)Hex(1)HexNAc(2)NeuAc(1)', 'mass': 1151.422803 }, { 'name': 'dHex Hex(2) HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(2)HexNAc(3)Sulf(1)', 'mass': 1159.358488 }, { 'name': 'dHex HexNAc(5)', 'abbr': 'dHex(1)HexNAc(5)', 'mass': 1161.454772 }, { 'name': 'dHex(2) Hex HexNAc(2) NeuGc ---OR--- Hex(2) HexNAc(2) dHex NeuAc ---OR--- Hex HexNAc(3) dHex Kdn', 'abbr': 'dHex(2)Hex(1)HexNAc(2)NeuGc(1)', 'mass': 1167.417718 }, { 'name': 'dHex(3) Hex(2) HexNAc(2)', 'abbr': 'dHex(3)Hex(2)HexNAc(2)', 'mass': 1168.438119 }, { 'name': 'Hex(3) HexNAc(3) Sulf', 'abbr': 'Hex(3)HexNAc(3)Sulf(1)', 'mass': 1175.353403 }, { 'name': 'dHex(2) Hex(2) HexNAc(2) Sulf(2)', 'abbr': 'dHex(2)Hex(2)HexNAc(2)Sulf(2)', 'mass': 1182.293839 }, { 'name': 'dHex Hex(2) HexNAc(2) NeuGc ---OR--- Hex(3) HexNAc(2) NeuAc', 'abbr': 'dHex(1)Hex(2)HexNAc(2)NeuGc(1)', 'mass': 1183.412632 }, { 'name': 'dHex Hex HexNAc(3) NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(3)NeuAc(1)', 'mass': 1208.444267 }, { 'name': 'Hex(6) Phos(3)', 'abbr': 'Hex(6)Phos(3)', 'mass': 1212.215934 }, { 'name': 'dHex Hex(3) HexA HexNAc(2)', 'abbr': 'dHex(1)Hex(3)HexA(1)HexNAc(2)', 'mass': 1214.407213 }, { 'name': 'dHex Hex HexNAc(3) NeuGc ---OR--- Hex(2) HexNAc(3) NeuAc', 'abbr': 'dHex(1)Hex(1)HexNAc(3)NeuGc(1)', 'mass': 1224.439181 }, { 'name': 'Hex HexNAc(2) NeuAc(2) Sulf', 'abbr': 'Hex(1)HexNAc(2)NeuAc(2)Sulf(1)', 'mass': 1230.359217 }, { 'name': 'dHex(2) Hex(3) HexA HexNAc Sulf', 'abbr': 'dHex(2)Hex(3)HexA(1)HexNAc(1)Sulf(1)', 'mass': 1237.342563 }, { 'name': 'Hex HexNAc NeuAc(3)', 'abbr': 'Hex(1)HexNAc(1)NeuAc(3)', 'mass': 1238.418446 }, { 'name': 'Hex(2) HexNAc(3) NeuGc', 'abbr': 'Hex(2)HexNAc(3)NeuGc(1)', 'mass': 1240.434096 }, { 'name': 'dHex Hex(2) HexNAc(2) NeuAc Sulf', 'abbr': 'dHex(1)Hex(2)HexNAc(2)NeuAc(1)Sulf(1)', 'mass': 1247.374532 }, { 'name': 'dHex(3) Hex HexNAc(2) Kdn', 'abbr': 'dHex(3)Hex(1)HexNAc(2)Kdn(1)', 'mass': 1256.454163 }, { 'name': 'dHex(2) Hex(3) HexNAc(2) Sulf', 'abbr': 'dHex(2)Hex(3)HexNAc(2)Sulf(1)', 'mass': 1264.389848 }, { 'name': 'dHex(2) Hex(2) HexNAc(2) Kdn', 'abbr': 'dHex(2)Hex(2)HexNAc(2)Kdn(1)', 'mass': 1272.449077 }, { 'name': 'dHex(2) Hex(2) HexA HexNAc(2) Sulf', 'abbr': 'dHex(2)Hex(2)HexA(1)HexNAc(2)Sulf(1)', 'mass': 1278.369113 }, { 'name': 'dHex Hex(2) HexNAc(4)', 'abbr': 'dHex(1)Hex(2)HexNAc(4)', 'mass': 1282.481046 }, { 'name': 'Hex HexNAc NeuGc(3)', 'abbr': 'Hex(1)HexNAc(1)NeuGc(3)', 'mass': 1286.40319 }, { 'name': 'dHex Hex HexNAc(3) NeuAc Sulf', 'abbr': 'dHex(1)Hex(1)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1288.401081 }, { 'name': 'dHex Hex(3) HexA HexNAc(2) Sulf', 'abbr': 'dHex(1)Hex(3)HexA(1)HexNAc(2)Sulf(1)', 'mass': 1294.364027 }, { 'name': 'dHex Hex HexNAc(2) NeuAc(2)', 'abbr': 'dHex(1)Hex(1)HexNAc(2)NeuAc(2)', 'mass': 1296.460311 }, { 'name': 'dHex(3) HexNAc(3) Kdn', 'abbr': 'dHex(3)HexNAc(3)Kdn(1)', 'mass': 1297.480712 }, { 'name': 'Hex(2) HexNAc(3) NeuAc Sulf', 'abbr': 'Hex(2)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1304.395996 }, { 'name': 'dHex(2) Hex(2) HexNAc(3) Sulf', 'abbr': 'dHex(2)Hex(2)HexNAc(3)Sulf(1)', 'mass': 1305.416397 }, { 'name': 'dHex(2) HexNAc(5)', 'abbr': 'dHex(2)HexNAc(5)', 'mass': 1307.512681 }, { 'name': 'Hex(2) HexNAc(2) NeuAc(2)', 'abbr': 'Hex(2)HexNAc(2)NeuAc(2)', 'mass': 1312.455225 }, { 'name': 'dHex(2) Hex(2) HexNAc(2) NeuAc ---OR--- Hex HexNAc(3) dHex(2) Kdn', 'abbr': 'dHex(2)Hex(2)HexNAc(2)NeuAc(1)', 'mass': 1313.475627 }, { 'name': 'dHex Hex(3) HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(3)HexNAc(3)Sulf(1)', 'mass': 1321.411312 }, { 'name': 'dHex(2) Hex(2) HexNAc(2) NeuGc ---OR--- Hex(3) HexNAc(2) dHex NeuAc ---OR--- Hex(2) HexNAc(3) dHex Kdn', 'abbr': 'dHex(2)Hex(2)HexNAc(2)NeuGc(1)', 'mass': 1329.470541 }, { 'name': 'Hex(2) HexNAc(5)', 'abbr': 'Hex(2)HexNAc(5)', 'mass': 1339.50251 }, { 'name': 'dHex Hex(3) HexNAc(2) NeuGc', 'abbr': 'dHex(1)Hex(3)HexNAc(2)NeuGc(1)', 'mass': 1345.465456 }, { 'name': 'Hex HexNAc(3) NeuAc(2)', 'abbr': 'Hex(1)HexNAc(3)NeuAc(2)', 'mass': 1353.481775 }, { 'name': 'dHex Hex(2) HexNAc(3) NeuAc', 'abbr': 'dHex(1)Hex(2)HexNAc(3)NeuAc(1)', 'mass': 1370.49709 }, { 'name': 'dHex(3) Hex(2) HexNAc(3)', 'abbr': 'dHex(3)Hex(2)HexNAc(3)', 'mass': 1371.517491 }, { 'name': 'Hex(7) Phos(3)', 'abbr': 'Hex(7)Phos(3)', 'mass': 1374.268757 }, { 'name': 'dHex Hex(4) HexA HexNAc(2)', 'abbr': 'dHex(1)Hex(4)HexA(1)HexNAc(2)', 'mass': 1376.460036 }, { 'name': 'Hex(3) HexNAc(3) NeuAc ---OR--- Hex(2) HexNAc(3) dHex NeuGc ---OR--- Hex(2) HexNAc(4) Kdn', 'abbr': 'Hex(3)HexNAc(3)NeuAc(1)', 'mass': 1386.492005 }, { 'name': 'dHex Hex(3) HexA(2) HexNAc(2)', 'abbr': 'dHex(1)Hex(3)HexA(2)HexNAc(2)', 'mass': 1390.439301 }, { 'name': 'Hex(2) HexNAc(2) NeuAc(2) Sulf', 'abbr': 'Hex(2)HexNAc(2)NeuAc(2)Sulf(1)', 'mass': 1392.41204 }, { 'name': 'dHex(2) Hex(2) HexNAc(2) NeuAc Sulf', 'abbr': 'dHex(2)Hex(2)HexNAc(2)NeuAc(1)Sulf(1)', 'mass': 1393.432441 }, { 'name': 'Hex(3) HexNAc(3) NeuGc', 'abbr': 'Hex(3)HexNAc(3)NeuGc(1)', 'mass': 1402.48692 }, { 'name': 'dHex(4) Hex HexNAc(2) Kdn', 'abbr': 'dHex(4)Hex(1)HexNAc(2)Kdn(1)', 'mass': 1402.512072 }, { 'name': 'dHex(3) Hex(2) HexNAc(2) Kdn', 'abbr': 'dHex(3)Hex(2)HexNAc(2)Kdn(1)', 'mass': 1418.506986 }, { 'name': 'dHex(3) Hex(2) HexA HexNAc(2) Sulf', 'abbr': 'dHex(3)Hex(2)HexA(1)HexNAc(2)Sulf(1)', 'mass': 1424.427021 }, { 'name': 'Hex(2) HexNAc(4) NeuAc', 'abbr': 'Hex(2)HexNAc(4)NeuAc(1)', 'mass': 1427.518554 }, { 'name': 'dHex(2) Hex(2) HexNAc(4)', 'abbr': 'dHex(2)Hex(2)HexNAc(4)', 'mass': 1428.538955 }, { 'name': 'dHex(2) Hex(3) HexA HexNAc(2) Sulf', 'abbr': 'dHex(2)Hex(3)HexA(1)HexNAc(2)Sulf(1)', 'mass': 1440.421936 }, { 'name': 'dHex(4) HexNAc(3) Kdn', 'abbr': 'dHex(4)HexNAc(3)Kdn(1)', 'mass': 1443.538621 }, { 'name': 'Hex(2) HexNAc NeuGc(3)', 'abbr': 'Hex(2)HexNAc(1)NeuGc(3)', 'mass': 1448.456013 }, { 'name': 'dHex(4) Hex HexNAc Kdn(2)', 'abbr': 'dHex(4)Hex(1)HexNAc(1)Kdn(2)', 'mass': 1449.501567 }, { 'name': 'dHex Hex(2) HexNAc(3) NeuAc Sulf', 'abbr': 'dHex(1)Hex(2)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1450.453905 }, { 'name': 'dHex Hex(2) HexNAc(2) NeuAc(2)', 'abbr': 'dHex(1)Hex(2)HexNAc(2)NeuAc(2)', 'mass': 1458.513134 }, { 'name': 'dHex(3) Hex HexNAc(3) Kdn', 'abbr': 'dHex(3)Hex(1)HexNAc(3)Kdn(1)', 'mass': 1459.533535 }, { 'name': 'Hex(3) HexNAc(3) NeuAc Sulf', 'abbr': 'Hex(3)HexNAc(3)NeuAc(1)Sulf(1)', 'mass': 1466.44882 }, { 'name': 'Hex(3) HexNAc(2) NeuAc(2)', 'abbr': 'Hex(3)HexNAc(2)NeuAc(2)', 'mass': 1474.508049 }, { 'name': 'Hex(3) HexNAc(3) NeuGc Sulf', 'abbr': 'Hex(3)HexNAc(3)NeuGc(1)Sulf(1)', 'mass': 1482.443734 }, { 'name': 'dHex Hex(2) HexNAc(2) NeuGc(2)', 'abbr': 'dHex(1)Hex(2)HexNAc(2)NeuGc(2)', 'mass': 1490.502964 }, { 'name': 'dHex(2) Hex(3) HexNAc(2) NeuGc ---OR--- Hex(4) HexNAc(2) dHex NeuAc', 'abbr': 'dHex(2)Hex(3)HexNAc(2)NeuGc(1)', 'mass': 1491.523365 }, { 'name': 'dHex Hex(3) HexA HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(3)HexA(1)HexNAc(3)Sulf(1)', 'mass': 1497.4434 }, { 'name': 'Hex(2) HexNAc(3) NeuAc(2)', 'abbr': 'Hex(2)HexNAc(3)NeuAc(2)', 'mass': 1515.534598 }, { 'name': 'dHex(2) Hex(2) HexNAc(3) NeuAc', 'abbr': 'dHex(2)Hex(2)HexNAc(3)NeuAc(1)', 'mass': 1516.554999 }, { 'name': 'dHex(4) Hex(2) HexNAc(3)', 'abbr': 'dHex(4)Hex(2)HexNAc(3)', 'mass': 1517.5754 }, { 'name': 'Hex(2) HexNAc(3) NeuAc NeuGc', 'abbr': 'Hex(2)HexNAc(3)NeuAc(1)NeuGc(1)', 'mass': 1531.529513 }, { 'name': 'dHex(2) Hex(2) HexNAc(3) NeuGc ---OR--- Hex(3) HexNAc(3) dHex NeuAc ---OR--- Hex(2) HexNAc(4) dHex Kdn', 'abbr': 'dHex(2)Hex(2)HexNAc(3)NeuGc(1)', 'mass': 1532.549914 }, { 'name': 'dHex(3) Hex(3) HexNAc(3)', 'abbr': 'dHex(3)Hex(3)HexNAc(3)', 'mass': 1533.570315 }, { 'name': 'Hex(8) Phos(3)', 'abbr': 'Hex(8)Phos(3)', 'mass': 1536.321581 }, { 'name': 'dHex Hex(2) HexNAc(2) NeuAc(2) Sulf', 'abbr': 'dHex(1)Hex(2)HexNAc(2)NeuAc(2)Sulf(1)', 'mass': 1538.469949 }, { 'name': 'Hex(2) HexNAc(3) NeuGc(2)', 'abbr': 'Hex(2)HexNAc(3)NeuGc(2)', 'mass': 1547.524427 }, { 'name': 'dHex(4) Hex(2) HexNAc(2) Kdn', 'abbr': 'dHex(4)Hex(2)HexNAc(2)Kdn(1)', 'mass': 1564.564895 }, { 'name': 'dHex Hex(2) HexNAc(4) NeuAc', 'abbr': 'dHex(1)Hex(2)HexNAc(4)NeuAc(1)', 'mass': 1573.576463 }, { 'name': 'dHex(3) Hex(2) HexNAc(4)', 'abbr': 'dHex(3)Hex(2)HexNAc(4)', 'mass': 1574.596864 }, { 'name': 'Hex HexNAc NeuGc(4)', 'abbr': 'Hex(1)HexNAc(1)NeuGc(4)', 'mass': 1593.493521 }, { 'name': 'dHex(4) Hex HexNAc(3) Kdn', 'abbr': 'dHex(4)Hex(1)HexNAc(3)Kdn(1)', 'mass': 1605.591444 }, { 'name': 'Hex(4) HexNAc(4) Sulf(2)', 'abbr': 'Hex(4)HexNAc(4)Sulf(2)', 'mass': 1620.442414 }, { 'name': 'dHex(3) Hex(2) HexNAc(3) Kdn ---OR--- Hex(3) HexNAc(2) dHex(3) NeuAc', 'abbr': 'dHex(3)Hex(2)HexNAc(3)Kdn(1)', 'mass': 1621.586359 }, { 'name': 'dHex(2) Hex(2) HexNAc(5)', 'abbr': 'dHex(2)Hex(2)HexNAc(5)', 'mass': 1631.618328 }, { 'name': 'dHex(2) Hex(3) HexA HexNAc(3) Sulf', 'abbr': 'dHex(2)Hex(3)HexA(1)HexNAc(3)Sulf(1)', 'mass': 1643.501309 }, { 'name': 'dHex Hex(4) HexA HexNAc(3) Sulf', 'abbr': 'dHex(1)Hex(4)HexA(1)HexNAc(3)Sulf(1)', 'mass': 1659.496223 }, { 'name': 'Hex(3) HexNAc(3) NeuAc(2)', 'abbr': 'Hex(3)HexNAc(3)NeuAc(2)', 'mass': 1677.587422 }, { 'name': 'dHex(2) Hex(3) HexNAc(3) NeuAc ---OR--- Hex(2) HexNAc(4) dHex(2) Kdn', 'abbr': 'dHex(2)Hex(3)HexNAc(3)NeuAc(1)', 'mass': 1678.607823 }, { 'name': 'dHex(4) Hex(3) HexNAc(3)', 'abbr': 'dHex(4)Hex(3)HexNAc(3)', 'mass': 1679.628224 }, { 'name': 'Hex(9) Phos(3)', 'abbr': 'Hex(9)Phos(3)', 'mass': 1698.374404 }, { 'name': 'dHex(2) HexNAc(7)', 'abbr': 'dHex(2)HexNAc(7)', 'mass': 1713.671426 }, { 'name': 'Hex(2) HexNAc NeuGc(4)', 'abbr': 'Hex(2)HexNAc(1)NeuGc(4)', 'mass': 1755.546345 }, { 'name': 'Hex(3) HexNAc(3) NeuAc(2) Sulf', 'abbr': 'Hex(3)HexNAc(3)NeuAc(2)Sulf(1)', 'mass': 1757.544236 }, { 'name': 'dHex(2) Hex(3) HexNAc(5)', 'abbr': 'dHex(2)Hex(3)HexNAc(5)', 'mass': 1793.671151 }, { 'name': 'dHex Hex(2) HexNAc(2) NeuGc(3)', 'abbr': 'dHex(1)Hex(2)HexNAc(2)NeuGc(3)', 'mass': 1797.593295 }, { 'name': 'dHex(2) Hex(4) HexA HexNAc(3) Sulf', 'abbr': 'dHex(2)Hex(4)HexA(1)HexNAc(3)Sulf(1)', 'mass': 1805.554132 }, { 'name': 'Hex(2) HexNAc(3) NeuAc(3)', 'abbr': 'Hex(2)HexNAc(3)NeuAc(3)', 'mass': 1806.630015 }, { 'name': 'dHex Hex(3) HexNAc(3) NeuAc(2)', 'abbr': 'dHex(1)Hex(3)HexNAc(3)NeuAc(2)', 'mass': 1823.64533 }, { 'name': 'dHex(3) Hex(3) HexNAc(3) NeuAc', 'abbr': 'dHex(3)Hex(3)HexNAc(3)NeuAc(1)', 'mass': 1824.665732 }, { 'name': 'Hex(2) HexNAc(3) NeuGc(3)', 'abbr': 'Hex(2)HexNAc(3)NeuGc(3)', 'mass': 1854.614759 }, { 'name': 'Hex(10) Phos(3)', 'abbr': 'Hex(10)Phos(3)', 'mass': 1860.427228 }, { 'name': 'dHex Hex(2) HexNAc(4) NeuAc(2)', 'abbr': 'dHex(1)Hex(2)HexNAc(4)NeuAc(2)', 'mass': 1864.67188 }, { 'name': 'Hex HexNAc NeuGc(5)', 'abbr': 'Hex(1)HexNAc(1)NeuGc(5)', 'mass': 1900.583852 }, { 'name': 'Hex(4) HexNAc(4) NeuAc Sulf(2)', 'abbr': 'Hex(4)HexNAc(4)NeuAc(1)Sulf(2)', 'mass': 1911.53783 }, { 'name': 'Hex(4) HexNAc(4) NeuGc Sulf(2)', 'abbr': 'Hex(4)HexNAc(4)NeuGc(1)Sulf(2)', 'mass': 1927.532745 }, { 'name': 'dHex(2) Hex(3) HexNAc(3) NeuAc(2)', 'abbr': 'dHex(2)Hex(3)HexNAc(3)NeuAc(2)', 'mass': 1969.703239 }, { 'name': 'Hex(4) HexNAc(4) NeuAc Sulf(3)', 'abbr': 'Hex(4)HexNAc(4)NeuAc(1)Sulf(3)', 'mass': 1991.494645 }, { 'name': 'dHex(2) Hex(2) HexNAc(2)', 'abbr': 'dHex(2)Hex(2)HexNAc(2)', 'mass': 1022.38021 }, { 'name': 'dHex Hex(3) HexNAc(2)', 'abbr': 'dHex(1)Hex(3)HexNAc(2)', 'mass': 1038.375125 }, { 'name': 'dHex Hex(2) HexNAc(3)', 'abbr': 'dHex(1)Hex(2)HexNAc(3)', 'mass': 1079.401674 }, { 'name': 'Hex(3) HexNAc(3)', 'abbr': 'Hex(3)HexNAc(3)', 'mass': 1095.396588 }, { 'name': 'dHex Hex(3) HexNAc(2) Sulf', 'abbr': 'dHex(1)Hex(3)HexNAc(2)Sulf(1)', 'mass': 1118.331939 }, { 'name': 'dHex(2) Hex(3) HexNAc(2)', 'abbr': 'dHex(2)Hex(3)HexNAc(2)', 'mass': 1184.433033 }, { 'name': 'dHex Hex(4) HexNAc(2)', 'abbr': 'dHex(1)Hex(4)HexNAc(2)', 'mass': 1200.427948 }, { 'name': 'dHex(2) Hex(2) HexNAc(3)', 'abbr': 'dHex(2)Hex(2)HexNAc(3)', 'mass': 1225.459583 }, { 'name': 'dHex Hex(3) HexNAc(3)', 'abbr': 'dHex(1)Hex(3)HexNAc(3)', 'mass': 1241.454497 }, { 'name': 'Hex(4) HexNAc(3)', 'abbr': 'Hex(4)HexNAc(3)', 'mass': 1257.449412 }, { 'name': 'dHex(2) Hex(4) HexNAc(2)', 'abbr': 'dHex(2)Hex(4)HexNAc(2)', 'mass': 1346.485857 }, { 'name': 'dHex(2) Hex(3) HexNAc(3)', 'abbr': 'dHex(2)Hex(3)HexNAc(3)', 'mass': 1387.512406 }, { 'name': 'A3', 'abbr': 'Hex(3)HexNAc(5)', 'mass': 1501.555334 }, { 'name': 'Hex(4) HexNAc(3) NeuAc ---OR--- Hex(3) HexNAc(4) Kdn', 'abbr': 'Hex(4)HexNAc(3)NeuAc(1)', 'mass': 1548.544828 }, { 'name': 'dHex(2) Hex(3) HexNAc(4)', 'abbr': 'dHex(2)Hex(3)HexNAc(4)', 'mass': 1590.591779 }, { 'name': 'dHex Hex(3) HexNAc(5)', 'abbr': 'dHex(1)Hex(3)HexNAc(5)', 'mass': 1647.613242 }, { 'name': 'A4', 'abbr': 'Hex(3)HexNAc(6)', 'mass': 1704.634706 }, { 'name': 'Hex(4) HexNAc(4) NeuAc', 'abbr': 'Hex(4)HexNAc(4)NeuAc(1)', 'mass': 1751.624201 }, { 'name': 'dHex(2) Hex(4) HexNAc(4) ---OR--- Hex(4) HexNAc(4) dHex Pent Me', 'abbr': 'dHex(2)Hex(4)HexNAc(4)', 'mass': 1752.644602 }, { 'name': 'Hex(6) HexNAc(4)', 'abbr': 'Hex(6)HexNAc(4)', 'mass': 1784.634431 }, { 'name': 'Hex(5) HexNAc(5)', 'abbr': 'Hex(5)HexNAc(5)', 'mass': 1825.660981 }, { 'name': 'dHex Hex(3) HexNAc(6)', 'abbr': 'dHex(1)Hex(3)HexNAc(6)', 'mass': 1850.692615 }, { 'name': 'dHex Hex(4) HexNAc(4) NeuAc ---OR--- Hex(3) HexNAc(5) dHex Kdn', 'abbr': 'dHex(1)Hex(4)HexNAc(4)NeuAc(1)', 'mass': 1897.68211 }, { 'name': 'dHex(3) Hex(4) HexNAc(4)', 'abbr': 'dHex(3)Hex(4)HexNAc(4)', 'mass': 1898.702511 }, { 'name': 'dHex Hex(3) HexNAc(5) NeuAc', 'abbr': 'dHex(1)Hex(3)HexNAc(5)NeuAc(1)', 'mass': 1938.708659 }, { 'name': 'dHex(2) Hex(4) HexNAc(5)', 'abbr': 'dHex(2)Hex(4)HexNAc(5)', 'mass': 1955.723975 }, { 'name': 'SUMOylation by Giardia lamblia', 'abbr': 'NQIGG', 'mass': 469.228496 }, { 'name': 'Carboxyethylpyrrole', 'abbr': 'Carboxyethylpyrrole', 'mass': 122.036779 }, { 'name': 'Fluorescein-tyramine adduct by peroxidase activity', 'abbr': 'Fluorescein-tyramine', 'mass': 493.116152 }, { 'name': 'Fucosylated biantennary + 2 alphaGal', 'abbr': 'dHex(1)Hex(7)HexNAc(4)', 'mass': 2092.745164 }, { 'name': 'beta-Funaltrexamine', 'abbr': 'betaFNA', 'mass': 454.210387 }, { 'name': 'Brij 58 synthetic polymer terminus', 'abbr': 'Brij58', 'mass': 224.250401 }, { 'name': 'Brij 35 synthetic polymer terminus', 'abbr': 'Brij35', 'mass': 168.187801 }, { 'name': 'Triton synthetic polymer terminus', 'abbr': 'Triton', 'mass': 188.156501 }, { 'name': 'Tween 80 synthetic polymer terminus', 'abbr': 'Tween80', 'mass': 263.237491 }, { 'name': 'Tween 20 synthetic polymer terminus', 'abbr': 'Tween20', 'mass': 165.164326 }, { 'name': 'tris adduct causes 104 Da addition at asparagine-succinimide intermediate', 'abbr': 'Tris', 'mass': 104.071154 }, { 'name': 'Biotin-Phenol', 'abbr': 'Biotin-tyramide', 'mass': 361.146012 }, { 'name': 'LeudimethylArgGlyGly', 'abbr': 'LRGG+dimethyl', 'mass': 411.259403 }, { 'name': 'Simulate peptide-RNA conjugates', 'abbr': 'RNPXL', 'mass': 324.035867 }, { 'name': 'transamidation of glycine ethyl ester to glutamine', 'abbr': 'GEE', 'mass': 86.036779 }, { 'name': 'Pyro-Glu from E + Methylation', 'abbr': 'Glu->pyro-Glu+Methyl', 'mass': -3.994915 }, { 'name': 'Pyro-Glu from E + Methylation Medium', 'abbr': 'Glu->pyro-Glu+Methyl:2H(2)13C(1)', 'mass': -0.979006 }, { 'name': 'LeumethylArgGlyGly', 'abbr': 'LRGG+methyl', 'mass': 397.243753 }, { 'name': 'NP-40 synthetic polymer terminus', 'abbr': 'NP40', 'mass': 220.182715 }, { 'name': 'Iodoacetamide derivative of stilbene (reaction product with thiol)', 'abbr': 'IASD', 'mass': 452.034807 }, { 'name': 'EZ-Link Sulfo-NHS-SS-Biotin', 'abbr': 'Biotin:Thermo-21328', 'mass': 389.090154 }, { 'name': 'Cytidine monophosphate', 'abbr': 'PhosphoCytidine', 'mass': 305.041287 }, { 'name': 'Azidophenylalanine', 'abbr': 'AzidoF', 'mass': 41.001397 }, { 'name': 'Cys alkylation by dimethylaminoethyl halide', 'abbr': 'Dimethylaminoethyl', 'mass': 71.073499 }, { 'name': 'Glutarylation', 'abbr': 'Gluratylation', 'mass': 114.031694 }, { 'name': '2-hydroxyisobutyrylation', 'abbr': 'hydroxyisobutyryl', 'mass': 86.036779 }, { 'name': 'S-Methyl Methyl phosphorothioate', 'abbr': 'MeMePhosphorothioate', 'mass': 107.979873 }, { 'name': 'Replacement of 3 protons by iron', 'abbr': 'Cation:Fe[III]', 'mass': 52.911464 }, { 'name': 'DTT adduct of cysteine', 'abbr': 'DTT', 'mass': 151.996571 }, { 'name': 'Sulfenic Acid specific probe', 'abbr': 'DYn-2', 'mass': 161.09664 }, { 'name': 'Water-quenched monolink of DSSO crosslinker', 'abbr': 'Xlink:DSSO[176]', 'mass': 176.01433 }, { 'name': 'Acetone chemical artifact', 'abbr': 'MesitylOxide', 'mass': 98.073165 }, { 'name': 'Tris-quenched monolink of DSS/BS3 crosslinker', 'abbr': 'Xlink:DSS[259]', 'mass': 259.141973 }, { 'name': 'formaldehyde induced modifications', 'abbr': 'methylol', 'mass': 30.010565 }, { 'name': 'Ammonia-quenched monolink of DSSO crosslinker', 'abbr': 'Xlink:DSSO[175]', 'mass': 175.030314 }, { 'name': 'Tris-quenched monolink of DSSO crosslinker', 'abbr': 'Xlink:DSSO[279]', 'mass': 279.077658 }, { 'name': 'Alkene fragment of DSSO crosslinker', 'abbr': 'Xlink:DSSO[54]', 'mass': 54.010565 }, { 'name': 'Thiol fragment of DSSO crosslinker', 'abbr': 'Xlink:DSSO[86]', 'mass': 85.982635 }, { 'name': 'Sulfenic acid fragment of DSSO crosslinker', 'abbr': 'Xlink:DSSO[104]', 'mass': 103.9932 }, { 'name': 'BuUr fragment of BuUrBu crosslinker', 'abbr': 'Xlink:BuUrBu[111]', 'mass': 111.032028 }, { 'name': 'Bu fragment of BuUrBu crosslinker', 'abbr': 'Xlink:BuUrBu[85]', 'mass': 85.052764 }, { 'name': 'Water quenched monolink of BuUrBu crosslinker', 'abbr': 'Xlink:BuUrBu[214]', 'mass': 214.095357 }, { 'name': 'Tris quenched monolink of BuUrBu crosslinker', 'abbr': 'Xlink:BuUrBu[317]', 'mass': 317.158686 }, { 'name': 'Intact DSSO crosslinker', 'abbr': 'Xlink:DSSO[158]', 'mass': 158.003765 }, { 'name': 'Intact DSS/BS3 crosslinker', 'abbr': 'Xlink:DSS[138]', 'mass': 138.06808 }, { 'name': 'Intact BuUrBu crosslinker', 'abbr': 'Xlink:BuUrBu[196]', 'mass': 196.084792 }, { 'name': 'Intact DTBP crosslinker', 'abbr': 'Xlink:DTBP[172]', 'mass': 172.01289 }, { 'name': 'Intact DST crosslinker', 'abbr': 'Xlink:DST[114]', 'mass': 113.995309 }, { 'name': 'Intact DSP/DTSSP crosslinker', 'abbr': 'Xlink:DTSSP[174]', 'mass': 173.980921 }, { 'name': 'Intact SMCC cross-link', 'abbr': 'Xlink:SMCC[219]', 'mass': 219.089543 }, { 'name': 'Replacement of 3 protons by aluminium', 'abbr': 'Cation:Al[III]', 'mass': 23.958063 }, { 'name': 'Ammonium-quenched monolink of BS2-G crosslinker', 'abbr': 'Xlink:BS2G[113]', 'mass': 113.047679 }, { 'name': 'Water-quenched monolink of BS2-G crosslinker', 'abbr': 'Xlink:BS2G[114]', 'mass': 114.031694 }, { 'name': 'Tris-quenched monolink of BS2-G crosslinker', 'abbr': 'Xlink:BS2G[217]', 'mass': 217.095023 }, { 'name': 'Ammonia quenched monolink of DMP crosslinker', 'abbr': 'Xlink:DMP[139]', 'mass': 139.110947 }, { 'name': 'Intact DMP crosslinker', 'abbr': 'Xlink:DMP[122]', 'mass': 122.084398 }, { 'name': 'glyoxal-derived AGE', 'abbr': 'glyoxalAGE', 'mass': 21.98435 }, { 'name': 'Methionine oxidation to aspartic semialdehyde', 'abbr': 'Met->AspSA', 'mass': -32.008456 }, { 'name': 'Decarboxylation', 'abbr': 'Decarboxylation', 'mass': -30.010565 }, { 'name': 'Aspartylurea', 'abbr': 'Aspartylurea', 'mass': -10.031969 }, { 'name': 'In Bachi as Formylaspargine (typo?)', 'abbr': 'Formylasparagine', 'mass': 4.97893 }, { 'name': 'aldehyde and ketone modifications', 'abbr': 'Carbonyl', 'mass': 13.979265 }, { 'name': 'Proline oxidation to 5-hydroxy-2-aminovaleric acid', 'abbr': 'Pro->HAVA', 'mass': 18.010565 }, { 'name': 'adduction of aflatoxin B1 Dialdehyde to lysine', 'abbr': 'AFB1_Dialdehyde', 'mass': 310.047738 }, { 'name': 'Tryptophan oxidation to beta-unsaturated-2,4-bis-tryptophandione', 'abbr': 'Delta:H(-4)O(2)', 'mass': 27.958529 }, { 'name': 'Tryptophan oxidation to hydroxy-bis-tryptophandione', 'abbr': 'Delta:H(-4)O(3)', 'mass': 43.953444 }, { 'name': 'Tryptophan oxidation to dihydroxy-N-formaylkynurenine', 'abbr': 'Delta:O(4)', 'mass': 63.979659 }, { 'name': 'methylglyoxal-derived carboxyethyllysine', 'abbr': 'Delta:H(4)C(3)O(2)', 'mass': 72.021129 }, { 'name': 'methylglyoxal-derived argpyrimidine', 'abbr': 'Delta:H(4)C(5)O(1)', 'mass': 80.026215 }, { 'name': 'crotonaldehyde-derived dimethyl-FDP-lysine', 'abbr': 'Delta:H(10)C(8)O(1)', 'mass': 122.073165 }, { 'name': 'methylglyoxal-derived tetrahydropyrimidine', 'abbr': 'Delta:H(6)C(7)O(4)', 'mass': 154.026609 }, { 'name': 'Hex(2) O(3) S', 'abbr': 'Hex(2)Sulf(1)', 'mass': 404.062462 }, { 'name': 'Pent(2)', 'abbr': 'Pent(2)', 'mass': 264.084518 }, { 'name': 'Pent HexNAc', 'abbr': 'Pent(1)HexNAc(1)', 'mass': 335.121631 }, { 'name': 'Hex:1 Pent:2 Me:1', 'abbr': 'Hex(1)Pent(2)Me(1)', 'mass': 440.152991 }, { 'name': 'HexNAc(2) Sulf', 'abbr': 'HexNAc(2)Sulf(1)', 'mass': 486.11556 }, { 'name': 'Hex Pent(3) Me', 'abbr': 'Hex(1)Pent(3)Me(1)', 'mass': 572.19525 }, { 'name': 'Hex(2) Pent(2)', 'abbr': 'Hex(2)Pent(2)', 'mass': 588.190165 }, { 'name': 'Hex(2) Pent(2) Me', 'abbr': 'Hex(2)Pent(2)Me(1)', 'mass': 602.205815 }, { 'name': 'Hex(4) HexA', 'abbr': 'Hex(4)HexA(1)', 'mass': 824.243382 }, { 'name': 'Hex(2) HexNAc Pent HexA', 'abbr': 'Hex(2)HexNAc(1)Pent(1)HexA(1)', 'mass': 835.259366 }, { 'name': 'Hex(3) HexNAc HexA', 'abbr': 'Hex(3)HexNAc(1)HexA(1)', 'mass': 865.269931 }, { 'name': 'Hex HexNAc(2) dHex(2) Sulf', 'abbr': 'Hex(1)HexNAc(2)dHex(2)Sulf(1)', 'mass': 940.284201 }, { 'name': 'HexA(2) HexNAc(3)', 'abbr': 'HexA(2)HexNAc(3)', 'mass': 961.302294 }, { 'name': 'dHex Hex(4) HexA', 'abbr': 'dHex(1)Hex(4)HexA(1)', 'mass': 970.301291 }, { 'name': 'Hex(5) HexA', 'abbr': 'Hex(5)HexA(1)', 'mass': 986.296206 }, { 'name': 'Hex(4) HexA HexNAc', 'abbr': 'Hex(4)HexA(1)HexNAc(1)', 'mass': 1027.322755 }, { 'name': 'dHex(3) Hex(3) HexNAc', 'abbr': 'dHex(3)Hex(3)HexNAc(1)', 'mass': 1127.41157 }, { 'name': 'Hex(6) HexNAc', 'abbr': 'Hex(6)HexNAc(1)', 'mass': 1175.396314 }, { 'name': 'Sulf dHex Hex HexNAc(4)', 'abbr': 'Hex(1)HexNAc(4)dHex(1)Sulf(1)', 'mass': 1200.385037 }, { 'name': 'dHex Hex(2) HexNAc NeuAc(2)', 'abbr': 'dHex(1)Hex(2)HexNAc(1)NeuAc(2)', 'mass': 1255.433762 }, { 'name': 'dHex(3) Hex(3) HexNAc(2)', 'abbr': 'dHex(3)Hex(3)HexNAc(2)', 'mass': 1330.490942 }, { 'name': 'dHex(2) Hex HexNAc(4) Sulf', 'abbr': 'dHex(2)Hex(1)HexNAc(4)Sulf(1)', 'mass': 1346.442946 }, { 'name': 'dHex Hex(2) HexNAc(4) Sulf(2)', 'abbr': 'dHex(1)Hex(2)HexNAc(4)Sulf(2)', 'mass': 1442.394675 }, { 'name': 'Hex(9)', 'abbr': 'Hex(9)', 'mass': 1458.475412 }, { 'name': 'Sulf dHex(2) Hex(3) HexNAc(3)', 'abbr': 'dHex(2)Hex(3)HexNAc(3)Sulf(1)', 'mass': 1467.469221 }, { 'name': 'Me dHex(2) Hex(5) HexNAc(2)', 'abbr': 'dHex(2)Hex(5)HexNAc(2)Me(1)', 'mass': 1522.554331 }, { 'name': 'Sulf(2) dHex(2) Hex(2) HexNAc(4)', 'abbr': 'dHex(2)Hex(2)HexNAc(4)Sulf(2)', 'mass': 1588.452584 }, { 'name': 'Hex(9) HexNAc', 'abbr': 'Hex(9)HexNAc(1)', 'mass': 1661.554784 }, { 'name': 'dHex(3) Hex(2) HexNAc(4) Sulf(2)', 'abbr': 'dHex(3)Hex(2)HexNAc(4)Sulf(2)', 'mass': 1734.510493 }, { 'name': 'Hex(4) HexNAc(4) NeuGc', 'abbr': 'Hex(4)HexNAc(4)NeuGc(1)', 'mass': 1767.619116 }, { 'name': 'dHex(4) Hex(3) HexNAc(2) NeuAc(1)', 'abbr': 'dHex(4)Hex(3)HexNAc(2)NeuAc(1)', 'mass': 1767.644268 }, { 'name': 'Hex(3) HexNAc(5) NeuAc(1)', 'abbr': 'Hex(3)HexNAc(5)NeuAc(1)', 'mass': 1792.65075 }, { 'name': 'Hex(10) HexNAc(1)', 'abbr': 'Hex(10)HexNAc(1)', 'mass': 1823.607608 }, { 'name': 'dHex Hex(8) HexNAc(2)', 'abbr': 'dHex(1)Hex(8)HexNAc(2)', 'mass': 1848.639242 }, { 'name': 'Hex(3) HexNAc(4) NeuAc(2)', 'abbr': 'Hex(3)HexNAc(4)NeuAc(2)', 'mass': 1880.666794 }, { 'name': 'dHex(2) Hex(3) HexNAc(4) NeuAc', 'abbr': 'dHex(2)Hex(3)HexNAc(4)NeuAc(1)', 'mass': 1881.687195 }, { 'name': 'dHex(2) Hex(2) HexNAc(6) Sulf', 'abbr': 'dHex(2)Hex(2)HexNAc(6)Sulf(1)', 'mass': 1914.654515 }, { 'name': 'Hex(5) HexNAc(4) NeuAc Ac', 'abbr': 'Hex(5)HexNAc(4)NeuAc(1)Ac(1)', 'mass': 1955.687589 }, { 'name': 'Hex(3) HexNAc(3) NeuAc(3)', 'abbr': 'Hex(3)HexNAc(3)NeuAc(3)', 'mass': 1968.682838 }, { 'name': 'Hex(5) HexNAc(4) NeuAc Ac(2)', 'abbr': 'Hex(5)HexNAc(4)NeuAc(1)Ac(2)', 'mass': 1997.698154 }, { 'name': 'Unidentified modification of 162.1258 found in open search', 'abbr': 'Unknown:162', 'mass': 162.125595 }, { 'name': 'Unidentified modification of 176.7462 found in open search', 'abbr': 'Unknown:177', 'mass': 176.744957 }, { 'name': 'Unidentified modification of 210.1616 found in open search', 'abbr': 'Unknown:210', 'mass': 210.16198 }, { 'name': 'Unidentified modification of 216.1002 found in open search', 'abbr': 'Unknown:216', 'mass': 216.099774 }, { 'name': 'Unidentified modification of 234.0742 found in open search', 'abbr': 'Unknown:234', 'mass': 234.073953 }, { 'name': 'Unidentified modification of 248.1986 found in open search', 'abbr': 'Unknown:248', 'mass': 248.19876 }, { 'name': 'Unidentified modification of 249.981 found in open search', 'abbr': 'Unknown:250', 'mass': 249.981018 }, { 'name': 'Unidentified modification of 301.9864 found in open search', 'abbr': 'Unknown:302', 'mass': 301.986514 }, { 'name': 'Unidentified modification of 306.0952 found in open search', 'abbr': 'Unknown:306', 'mass': 306.095082 }, { 'name': 'Unidentified modification of 420.0506 found in open search', 'abbr': 'Unknown:420', 'mass': 420.051719 }, { 'name': 'O-diethylphosphothione', 'abbr': 'Diethylphosphothione', 'mass': 152.006087 }, { 'name': 'Ubiquitin D (FAT10) leaving after chymotrypsin digestion Cys-Ile-Gly-Gly', 'abbr': 'CIGG', 'mass': 330.136176 }, { 'name': 'Ubiquitin D (FAT10) leaving after trypsin digestion Gly-Asn-Leu-Leu-Phe-Leu-Ala-Cys-Tyr-Cys-Ile-Gly-Gly', 'abbr': 'GNLLFLACYCIGG', 'mass': 1324.6308 }, { 'name': 'O-dimethylphosphothione', 'abbr': 'Dimethylphosphothione', 'mass': 123.974787 }, { 'name': 'O-methylphosphothione', 'abbr': 'monomethylphosphothione', 'mass': 109.959137 }, { 'name': 'heavy tris(2,4,6-trimethoxyphenyl)phosphonium acetic acid N-hydroxysuccinimide ester derivative', 'abbr': 'TMPP-Ac:13C(9)', 'mass': 581.211328 }, { 'name': 'Photo-induced Lysine adduct', 'abbr': 'Lys+O(2)', 'mass': 160.084792 }, { 'name': 'carbobenzoxy-L-glutaminyl-glycine', 'abbr': 'ZQG', 'mass': 320.100836 }, { 'name': 'DST crosslinker cleaved by sodium periodate', 'abbr': 'Xlink:DST[56]', 'mass': 55.989829 }, { 'name': 'O-Dichloroethylphosphate', 'abbr': 'Haloxon', 'mass': 203.950987 }, { 'name': 'O-methyl amino phosphinate', 'abbr': 'Methamidophos-O', 'mass': 92.997965 }, { 'name': 'Loss of O2; nitro photochemical decomposition', 'abbr': 'Nitrene', 'mass': 12.995249 }, { 'name': 'Super Heavy Tandem Mass Tag', 'abbr': 'shTMT', 'mass': 235.176741 }, { 'name': 'TMTpro 16plex Tandem Mass Tag', 'abbr': 'TMTpro', 'mass': 304.207146 }, { 'name': 'Native TMTpro Tandem Mass Tag', 'abbr': 'TMTpro_zero', 'mass': 295.189592 }, { 'name': '3-hydroxybenzyl phosphate', 'abbr': '3-hydroxybenzyl-phosphate', 'mass': 186.008196 }, { 'name': 'A3G3S3', 'abbr': 'Hex(6)HexNAc(5)NeuAc(3)', 'mass': 2861.000054 }, { 'name': 'andrographolide with the loss of H2O', 'abbr': 'Andro-H2O', 'mass': 332.19876 }, { 'name': 'Photo-induced histidine adduct', 'abbr': 'His+O(2)', 'mass': 169.048741 }, { 'name': 'A4G4', 'abbr': 'Hex(7)HexNAc(6)', 'mass': 2352.846 }, { 'name': 'Photo-induced Methionine Adduct', 'abbr': 'Met+O(2)', 'mass': 163.030314 }, { 'name': 'Photo-induced Glycine Adduct', 'abbr': 'Gly+O(2)', 'mass': 89.011293 }, { 'name': 'Photo-induced Glutamate adduct', 'abbr': 'Glu+O(2)', 'mass': 161.032422 }, { 'name': 'MBS_233p24 plus peptide 1250p53', 'abbr': 'MBS+peptide', 'mass': 1482.77 }, { 'name': 'phenyl phosphate', 'abbr': 'phenyl-phosphate', 'mass': 155.997631 }, { 'name': 'RNA-protein UVC-crosslinked, hydrofluoride-digested uridine adduct', 'abbr': 'RBS-ID_Uridine', 'mass': 244.069536 }];
